<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'utils.form2content.php');

jimport('joomla.application.component.controller');

class Form2ContentControllerConfiguration extends JController
{
	var $modelName = 'configuration';

	function __construct()
	{
		parent::__construct();
		$this->registerTask('apply', 'save');
	}

	function __getRedirect()
	{
		return 'index.php?option=com_form2content';
	}

	function display()
	{
		JRequest::setVar('view', $this->modelName);		
		parent::display();
	}

	function save()
	{
		$data = JRequest::get('POST');

		$config = new JRegistry('F2CConfig');
		$config_array = array();
		
		$config_array['edit_items_level'] = JRequest::getInt('edit_items_level', 0);
		$config_array['generate_sample_template'] = JRequest::getInt('generate_sample_template', 0);
		$config_array['max_image_upload_size'] = JRequest::getInt('max_image_upload_size', 1024);
		$config_array['date_format'] = JRequest::getString('date_format', '%d-%m-%Y');
		$config_array['autosync_article_order'] = JRequest::getInt('autosync_article_order', 0);
		$config_array['default_thumbnail_width'] = JRequest::getInt('default_thumbnail_width', F2C_DEFAULT_THUMBNAIL_WIDTH);
		$config_array['default_thumbnail_height'] = JRequest::getInt('default_thumbnail_height', F2C_DEFAULT_THUMBNAIL_HEIGHT);
		$config_array['front_end_publish'] = JRequest::getInt('front_end_publish', 1);
		$config_array['recaptcha_public_key'] = JRequest::getString('recaptcha_public_key', '');
		$config_array['recaptcha_private_key'] = JRequest::getString('recaptcha_private_key', '');
		
		$jpeg_quality = JRequest::getInt('jpeg_quality', 75);
		
		if($jpeg_quality < 0 || $jpeg_quality > 100)
		{
			$jpeg_quality = 75;
		}
		$config_array['jpeg_quality'] = $jpeg_quality;
		
		$config->loadArray($config_array);

		// Get the path of the configuration file
		$fname = JPATH_COMPONENT_SITE.DS.'configuration.php';
		
		// Try to make configuration.php writeable
		jimport('joomla.filesystem.path');
		
		$jConfig = new JConfig();
				
		if (!$jConfig->ftp_enable && JPath::isOwner($fname) && !JPath::setPermissions($fname, '0644')) 
		{
			JError::raiseNotice('SOME_ERROR_CODE', 'Could not make configuration.php writable');
		}

		// Get the config registry in PHP class format and write it to configuation.php
		jimport('joomla.filesystem.file');
		if (JFile::write($fname, $config->toString('PHP', 'F2CConfig', array('class' => 'F2CConfig')))) 
		{
			$msg = JText::_('The Configuration Details have been updated');
		} 
		else 
		{
			$msg = JText::_('ERRORCONFIGFILE');
		}

		// Try to make configuration.php unwriteable
		if (!$jConfig->ftp_enable && JPath::isOwner($fname) && !JPath::setPermissions($fname, '0444')) 
		{
			JError::raiseNotice('SOME_ERROR_CODE', 'Could not make configuration.php unwritable');
		}

		$this->setRedirect($this->__getRedirect(), $msg);
	}
	
	function cancel()
	{
		$message = JText::_('OPERATION_CANCELLED');
		$this->setRedirect($this->__getRedirect(), $message);
	}
	
	function syncorder()
	{
		$db =& JFactory::getDBO();	
		$db->setQuery('SELECT DISTINCT f.catid FROM #__f2c_form f WHERE f.reference_id IS NOT NULL');
		$categoryList = $db->loadObjectList();
		
		if(count($categoryList))
		{
			foreach($categoryList as $category)
			{
				ContentHelper::syncArticleOrder($category->catid);
			}
		}

		$this->setRedirect($this->__getRedirect(), JText::_('SYNC_ORDER_SUCCESS'));
	}
}
?>