<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'class.form2content.php');

jimport('joomla.application.component.controller');

class Form2ContentControllerForm extends JController
{
	var $_modelName = 'form';
	var $formId = 0;
	var $contentTypeId = 0;

	function __construct()
	{
		parent::__construct();
		$this->registerTask('newform', 'edit');
	}

	function __getRedirect()
	{
		return 'index.php?option=com_form2content&task=viewformlist&c=forms';
	}

	function __save()
	{
		$data 	= JRequest::get('POST');
		$model 	= $this->getModel($this->_modelName);		
		
		if ($model->save($data)) 
		{
			$message = JText::_('FORM_SAVED');
			$this->formId = $model->_id;
			$this->contentTypeId = $model->_contentTypeId;
		} 
		else
		{
			$this->formId = $model->_id;
			$this->contentTypeId = $model->_contentTypeId;
			$message = JText::_('FORM_SAVE_ERROR'). ' [' . $model->getError() . ']';
		}
		
		return $message;	
	}

	function add()
	{
		JRequest::setVar('view', 'projectselect');
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}
	
	function edit()
	{
		JRequest::setVar('view', $this->_modelName);
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}

	function display()
	{
		parent::display();
	}

	function save()
	{
		$message = $this->__save();
		$this->setRedirect($this->__getRedirect(), $message);
	}
		
	function apply()
	{
		$message = $this->__save();				
		$this->setRedirect('index.php?option=com_form2content&c=form&task=edit&cid[]='.(int)$this->formId.'&projectid='.(int)$this->contentTypeId, $message);			
	}
	
	function remove()
	{
		$model = $this->getModel($this->_modelName);
		
		if($model->delete()) 
		{
			$message = JText::_('FORM_DELETED' );
		}
		else 
		{
			$message = JText::_('FORM_DELETE_ERROR');
			$message .= ' [' . $model->getError() . ']';
		}

		$this->setRedirect($this->__getRedirect(), $message);
	}

	function publish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$message = '';
		$model = $this->getModel($this->_modelName);		
		$publishState = 1;
		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count($cid) < 1) 
		{
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$numSuccess = 0;
		$errors = array();
		
		foreach($cid as $formId)
		{
			$model->setId($formId);
			$model->getData();
			
			if($model->parse($publishState))
			{
				$numSuccess++;
			}
		}

		if(count($cid) == 1)
		{
			if($numSuccess == 1)
			{
				$message = JText::_('ARTICLE_SUCCESSFULLY_PUBLISHED');	
			}
			else
			{
				$message = JText::_('ERROR_ARTICLE_PUBLISH');
			}
		}
		else
		{
			$message = sprintf(JText::_('X_ARTICLES_SUCCESSFULLY_PUBLISHED'), $numSuccess);	
		}
				
		if(count($model->getErrors()))
		{
			$message .= ' [' . implode(', ', $model->getErrors()) . ']';
		}
		
		$this->setRedirect($this->__getRedirect(), $message);
	}

	function unpublish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$message = '';
		$model = $this->getModel($this->_modelName);		
		$publishState = 0;
		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count($cid) < 1) 
		{
			JError::raiseError(500, JText::_( 'Select an item to unpublish'));
		}

		$numSuccess = 0;
		$errors = array();
		
		foreach($cid as $formId)
		{
			$model->setId($formId);
			$model->getData();
			
			if($model->parse($publishState))
			{
				$numSuccess++;
			}
		}

		if(count($cid) == 1)
		{
			if($numSuccess == 1)
			{
				$message = JText::_('ARTICLE_SUCCESSFULLY_UNPUBLISHED');	
			}
			else
			{
				$message = JText::_('ERROR_ARTICLE_UNPUBLISH');
			}
		}
		else
		{
			$message = sprintf(JText::_('X_ARTICLES_SUCCESSFULLY_UNPUBLISHED'), $numSuccess);	
		}
		
		if(count($model->getErrors()))
		{
			$message .= ' [' . implode(', ', $model->getErrors()) . ']';
		}
		 
		$this->setRedirect($this->__getRedirect(), $message);
	}

	function cancel()
	{
		$message = JText::_('OPERATION_CANCELLED');
		$this->setRedirect($this->__getRedirect(), $message);
	}

	function orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');

		$model = $this->getModel($this->_modelName);
		$model->move(-1);
		$this->setRedirect($this->__getRedirect());
	}

	function orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit('Invalid Token');

		$model = $this->getModel($this->_modelName);
		$model->move(1);		
		$this->setRedirect($this->__getRedirect());
	}

	function refresh()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$message = '';		
		$model = $this->getModel($this->_modelName);		
		$publishState = -1; // retain current state

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count($cid) < 1) 
		{
			JError::raiseError(500, JText::_( 'Select an item to refresh' ) );
		}
		
		$numSuccess = 0;
		$errors = array();

		foreach($cid as $formId)
		{
			$model->setId($formId);
			$model->getData();
			
			if($model->parse($publishState))
			{
				$numSuccess++;
			}
		}

		$message = sprintf(JText::_('X_ARTICLES_SUCCESSFULLY_REFRESHED'), $numSuccess);	
				
		if(count($model->getErrors()))
		{
			$message .= ' [' . implode(', ', $model->getErrors()) . ']';
		}
		
		$this->setRedirect($this->__getRedirect(), $message);
	}
	
	function copy()
	{
		$model = $this->getModel($this->_modelName);
		
		if($model->copy())
		{
			$message = JText::_('DATA_COPIED' );			
		}
		else
		{
			$message = JText::_('DATA_COPY_ERROR');
			$message .= ' [' . $model->getError() . ']';			
		}
		
		$this->setRedirect($this->__getRedirect(), $message);		
	}	
}

?>