﻿<?php
defined('_JEXEC') or die('Restricted acccess');

jimport('joomla.application.component.controller');

class Form2ContentControllerProject extends JController
{
	var $_modelName = 'Project';
	var $_contentTypeId = 0;

	function __construct()
	{
		parent::__construct();
		$this->registerTask('add', 'edit');
	}

	function __getRedirect()
	{
		return 'index.php?option=com_form2content&task=viewprojectlist&c=projects';
	}

	function __save()
	{
		$data = JRequest::get('POST');
		
		$model = $this->getModel($this->_modelName);

		if ($model->save($data)) 
		{
			$message = JText::_('PROJECT_SAVED');
			$this->_contentTypeId = $model->_id;
		} 
		else
		{
			$message = JText::_('PROJECT_SAVE_ERROR');
			$message .= ' [' . $model->getError() . ']';
		}
		
		return $message;
	}
	
	function edit()
	{
		JRequest::setVar('view', 'project');
		JRequest::setVar('hidemainmenu', 1);
		
		parent::display();
	}

	function display()
	{
		parent::display();
	}

	function publish()
	{
		$model = $this->getModel($this->_modelName);
		
		if($model->publish()) 
		{
			$message = JText::_('ITEMS_PUBLISHED' );
		}
		else 
		{
			$message = JText::_('ITEMS_PUBLISH_ERROR');
			$message .= ' [' . $model->getError() . ']';
		}

		$this->setRedirect($this->__getRedirect(), $message);
	}

	function unpublish()
	{
		$model = $this->getModel($this->_modelName);
		
		if($model->unpublish()) 
		{
			$message = JText::_('ITEMS_UNPUBLISHED' );
		}
		else 
		{
			$message = JText::_('ITEMS_UNPUBLISH_ERROR');
			$message .= ' [' . $model->getError() . ']';
		}

		$this->setRedirect($this->__getRedirect(), $message);		
	}
	
	function save()
	{
		$message = $this->__save();		
		$this->setRedirect($this->__getRedirect(), $message);
	}

	function apply()
	{
		$message = $this->__save();				
		$this->setRedirect('index.php?option=com_form2content&c=project&task=edit&cid[]=' . (int)$this->_contentTypeId, $message);			
	}
	
	function remove()
	{
		$model = $this->getModel($this->_modelName);
		$modelForm = $this->getModel('Form');
		
		if($model->delete($modelForm)) 
		{
			$message = JText::_('PROJECT_DELETED' );
		}
		else 
		{
			$message = JText::_('PROJECT_DELETE_ERROR');
			$message .= ' [' . $model->getError() . ']';
		}

		$this->setRedirect($this->__getRedirect(), $message);
	}

	function copy()
	{
		$model = $this->getModel($this->_modelName);
		
		if($model->copy())
		{
			$message = JText::_('DATA_COPIED' );			
		}
		else
		{
			$message = JText::_('DATA_COPY_ERROR');
			$message .= ' [' . $model->getError() . ']';			
		}
		
		$this->setRedirect($this->__getRedirect(), $message);		
	}

	function syncjadvparms()
	{
		$model = $this->getModel($this->_modelName);
		
		// first force an 'apply'
		$this->__save();
		
		$this->_contentTypeId = $model->_id;
		$message = $model->syncjadvparms();
		$this->setRedirect('index.php?option=com_form2content&c=project&task=edit&cid[]=' . (int)$this->_contentTypeId, $message);			
	}

	function syncmetadata()
	{
		// first force an 'apply'
		$this->__save();
		
		$model = $this->getModel($this->_modelName);
		$this->_contentTypeId = $model->_id;
		$message = $model->syncmetadata();
		$this->setRedirect('index.php?option=com_form2content&c=project&task=edit&cid[]=' . (int)$this->_contentTypeId, $message);			
	}
	
	function cancel()
	{
		$message = JText::_('OPERATION_CANCELLED');
		$this->setRedirect($this->__getRedirect(), $message);
	}
}

?>