<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'utils.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'class.form2content.php');

jimport('joomla.application.component.controller');

class Form2ContentControllerTemplate extends JController
{
	function __construct()
	{
		parent::__construct();
	}

	function cancel()
	{
		$message = JText::_('OPERATION_CANCELLED');
		$this->setRedirect($this->__getRedirect(), $message);
	}

	function edit()
	{
		JRequest::setVar('view', 'template');
		JRequest::setVar('hidemainmenu', 1);
		
		parent::display();
	}

	function __getRedirect()
	{
		return 'index.php?option=com_form2content&task=viewtemplatelist&c=templates';
	}

	function display()
	{
		parent::display();
	}

	function upload()
	{
		global $clearUploads;
	
		$file = JRequest::getVar('upload', '', 'files', 'array');
		
		if(empty($file['name'])) 
		{
			$this->setRedirect($this->__getRedirect(), JText::_('ERROR_TEMPLATE_FILE_UPLOAD_EMPTY'), 'error');
			return;
		}

		$templateFile = Path::Combine(F2C_Config::getTemplatePath(), strtolower($file['name']));
		
		if(JFile::exists($templateFile)) 
		{
			$this->setRedirect($this->__getRedirect(), JText::_('ERROR_TEMPLATE_FILE_UPLOAD_EXISTS'), 'error');
			return;
		}

		if(strtolower(JFile::getExt($templateFile)) != 'tpl')
		{
			$this->setRedirect($this->__getRedirect(), JText::_('ERROR_TEMPLATE_FILE_UPLOAD_INVALID_FILE_TYPE'), 'error');
			return;			
		}
		
		if(JFile::upload($file['tmp_name'], $templateFile))
		{
			JPath::setPermissions($templateFile);
			$this->setRedirect($this->__getRedirect(), JText::_('TEMPLATE_UPLOAD_SUCCESSFUL'));			
		}
		else
		{
			$this->setRedirect($this->__getRedirect(), JText::_('ERROR_TEMPLATE_FILE_UPLOAD_FAILED'), 'error');			
		}
			
		$clearUploads = true;
	}
	
	function save()
	{
		$model = $this->getModel('Template');
		
		if ($model->save()) 
		{
			$message = JText::_('TEMPLATE_SAVED');
		} 
		else
		{
			$message = JText::_('TEMPLATE_SAVE_ERROR');
			$message .= ' [' . $model->getError() . ']';
		}

		$this->setRedirect($this->__getRedirect(), $message);
	}
	
	function remove()
	{
		$message = JText::_('TEMPLATE_DELETE_SUCCESSFUL');
		$files = JRequest::getVar('cid');
		
		if($files)
		{
			foreach($files as $file)
			{
				$file = Path::Combine(F2C_Config::getTemplatePath(), $file);
			
				if(!JFile::exists($file))
				{
					$message = JText::_('ERROR_TEMPLATE_NOT_FOUND');
					break;
				}
				
				if(!JFile::delete($file))
				{
					$message = JText::_('ERROR_TEMPLATE_DELETE');
				}
			}
		}
		 
		$this->setRedirect($this->__getRedirect(), $message);
	}
}
?>