<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'models'.DS.'formbase.php');

class Form2ContentModelForm extends Form2ContentModelFormBase
{	
	function __construct()
	{
		parent::__construct();

		$cid = JRequest::getVar('cid', false, 'DEFAULT', 'array');
		
		if($cid)
		{
			$id = $cid[0];
		}
		else
		{
			$id = JRequest::getInt('id', 0);
		}
		
		$this->setId($id);
		$this->_contentTypeId = JRequest::getInt('projectid', 0);
	}
			
	function save($data)
	{
		$config 		= new F2CConfig();	
		$configJoomla	=& JFactory::getConfig();
		$tzoffset 		= $configJoomla->getValue('config.offset');
		$projectid 		= JRequest::getInt('projectid', 0);
		$datenow 		=& JFactory::getDate();
		$timestamp 		= $datenow->toMySQL();
		$nullDate		= $this->_db->getNullDate();
		$row 			=& $this->getTable();
		$validator 		= new F2C_Validation();
		$parseData 		= true;
		
		JPluginHelper::importPlugin('form2content');
		
		$this->setId(JRequest::getInt('id', 0));
		
		$F2C_FIELD_SETTINGS_MAPPING = array(F2C_FIELDTYPE_SINGLELINE => 'F2C_SingleLineTextSettings',
											F2C_FIELDTYPE_MULTILINETEXT => 'F2C_MultiLineTextSettings',
											F2C_FIELDTYPE_MULTILINEEDITOR => 'F2C_MultiLineEditorSettings',
											F2C_FIELDTYPE_CHECKBOX => 'F2C_CheckBoxSettings',
											F2C_FIELDTYPE_SINGLESELECTLIST => 'F2C_SingleSelectSettings', 
											F2C_FIELDTYPE_IMAGE => 'F2C_ImageSettings',
											F2C_FIELDTYPE_IFRAME => 'F2C_IFrameSettings', 
											F2C_FIELDTYPE_EMAIL => 'F2C_EmailSettings', 
											F2C_FIELDTYPE_HYPERLINK => 'F2C_LinkSettings', 
											F2C_FIELDTYPE_MULTISELECTLIST => 'F2C_MultiSelectSettings', 
											F2C_FIELDTYPE_INFOTEXT => 'F2C_InfoTextSettings', 
											F2C_FIELDTYPE_DATEPICKER => 'F2C_DatePickerSettings', 
											F2C_FIELDTYPE_DISPLAYLIST => 'F2C_DisplayListSettings', 
											F2C_FIELDTYPE_FILE => 'F2C_FileSettings', 
											F2C_FIELDTYPE_DATABASE_LOOKUP => 'F2C_DatabaseLookupSettings', 
											F2C_FIELDTYPE_GEOCODER => 'F2C_GeoCoderSettings',
											F2C_FIELDTYPE_DB_LOOKUP_MULTI => 'F2C_DatabaseLookupMultiSettings');		
				
		// Bind the form fields to the table
		if (!$row->bind($data)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// get all the field definitions for this form
	 	$this->_db->setQuery("SELECT f.* FROM #__f2c_projectfields f "
	 						. "WHERE f.projectid =" . $projectid
	 						. " ORDER BY ordering ASC");
	  	$fields = $this->_db->loadObjectList();	

		// Check required fields		
		foreach($fields as $field)
		{
			$fieldSettings = ($field->settings) ? unserialize($field->settings) : new $F2C_FIELD_SETTINGS_MAPPING[$field->fieldtypeid]();
			
			if($fieldSettings->required)
			{
				if(!$validator->valReqField($field, 't'.$field->id, $data))
				{
					$msg = ($fieldSettings->errorMessageRequired) ? $fieldSettings->errorMessageRequired : sprintf(JText::_('ERROR_FIELD_X_REQUIRED'), $field->title);
					$this->setError($msg);
					return false;
				}
			}
			
			switch($field->fieldtypeid)
			{
				case F2C_FIELDTYPE_IMAGE:
					$msg = $validator->valSizeImage($field, $config);					
					break;
				case F2C_FIELDTYPE_FILE:
					$msg = $validator->valSizeFileUpload($field, $config);
					break;
				default:
					$msg = '';
					break;
			}
			
			if($msg)
			{
				$this->setError($msg);
				return false;
			}						
		}
		
		// Handle metadata defaults
		$metadata = JRequest::getVar( 'meta', null, 'post', 'array');

		if (is_array($metadata))
		{
			$txt = array();
			
			foreach ($metadata as $k => $v)
			{
				if ($k == 'description')
				{
					$row->metadesc = $v;
				}
				elseif ($k == 'keywords') 
				{
					$row->metakey = $v;
				}
				else
				{
					$txt[] = "$k=$v";
				}
			}
			$row->metadata = implode("\n", $txt);
		}
		
		$row->attribs = ContentHelper::encodeParameters('params');

		// handle created date
		if ($row->created && strlen(trim($row->created)) <= 10) 
		{
			$row->created 	.= ' 00:00:00';
		}
		
		if($row->created)
		{			
			$date = ParseDate($row->created, $config->date_format);

			if($date)
			{
				$created =& JFactory::getDate($date->toMySQL(), $tzoffset);
			}
			else
			{
				$created =& JFactory::getDate(null, $tzoffset);
			}			
		}
		else
		{
			$created =& JFactory::getDate(null, $tzoffset);
		}
		
		$row->created = $created->toMySQL();			
		
		// handle publish dates
		if($row->publish_up)
		{			
			$date = ParseDate($row->publish_up, $config->date_format);
			
			if($date)
			{
				$publish_up =& JFactory::getDate($date->toMySQL(), $tzoffset);
				$row->publish_up = $publish_up->toMySQL();
			}
			else
			{
				$row->publish_up = $nullDate;
			}
		}

		if(trim($row->publish_down) == JText::_('Never') || trim($row->publish_down) == '')
		{
			$row->publish_down = $nullDate;
		}
		else
		{
			$date = ParseDate($row->publish_down, $config->date_format);
			
			if($date)
			{
				$publish_down =& JFactory::getDate($date->toMySQL(), $tzoffset);
				$row->publish_down = $publish_down->toMySQL();
			}
			else
			{
				$row->publish_down = $nullDate;
			}			
		}

		if ($row->id) 
		{
			$row->modified = $timestamp;
		}
		else
		{
			// new record -> initialize
			$row->created = $timestamp;
		}
		
		if (!$row->check()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// create new Storage object for back-end handling
		$storage = new F2C_Storage($config, $row->id, true);
		$storage->prepareSubmittedData($fields);
		
		$eventDataBeforeSave			= new F2C_SaveEventArgs();
		$eventDataBeforeSave->isNew		= $this->isNew();
		$eventDataBeforeSave->formNew 	=& $row;
		$eventDataBeforeSave->fieldsNew	=& $storage->preparedData;
		
		if($eventDataBeforeSave->isNew)
		{
			$eventDataBeforeSave->formOld	= null;
			$eventDataBeforeSave->fieldsOld	= null;
		}
		else
		{
			// Load the existing form data
			$this->_loadData();
			
			$eventDataBeforeSave->formOld	= $this->_data;;
			$eventDataBeforeSave->fieldsOld	= $this->_fieldData;;
		}

		$result = $this->_dispatcher->trigger('onBeforeF2cContentSave', array(&$eventDataBeforeSave));
				
		// Store the table to the database
		if (!$row->store()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Update item order
		$row->reorder('catid = '.(int)$row->catid);
		
		// sync id's
		$this->setId($row->id);
		$storage->formId = $row->id;
				
		$storage->storeFields($fields);
		
		// sync data
		$this->_loadData();
		
		if(!$this->parse(-1))
		{
			return false;
		}
		
		$eventDataAfterSave 			= new F2C_SaveEventArgs();
		$eventDataAfterSave->isNew		= $eventDataBeforeSave->isNew;
		$eventDataAfterSave->formNew 	= $this->_data;
		$eventDataAfterSave->fieldsNew 	= $this->_fieldData;
		$eventDataAfterSave->formOld	= $eventDataBeforeSave->formOld;
		$eventDataAfterSave->fieldsOld	= $eventDataBeforeSave->fieldsOld;
		
		$result = $this->_dispatcher->trigger('onAfterF2cContentSave', array($eventDataAfterSave));

		return true;
	}
		
	function move($direction)
	{
		$config 	= new F2CConfig();		
		$row 		=& $this->getTable();
		
		if (!$row->load($this->_id)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// move function does not return true on success!
		$row->move($direction, 'catid = ' . (int)$row->catid); 

		if(array_key_exists('autosync_article_order',get_object_vars($config)) && $config->autosync_article_order)
		{
			ContentHelper::syncArticleOrder($row->catid);	
		}

		$cache = & JFactory::getCache('com_form2content');
		$cache->clean();

		return true;
	}

	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT ' .
					 'frm.*, sec.title AS secTitle, sec.alias AS secAlias, ' .
					 'cat.title AS catTitle, cat.alias AS catAlias ' .
					 'FROM ' . $this->_db->nameQuote('#__f2c_form') . ' frm ' .
					 'LEFT JOIN #__sections sec ON frm.sectionid = sec.id ' .
					 'LEFT JOIN #__categories cat ON frm.catid = cat.id ' .					  
					 'WHERE frm.id = ' . (int)$this->_id;

			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();

			if($this->_data)
			{
				$this->_contentTypeId = $this->_data->projectid;
			}
			
			// Load the fields data
			$this->_db->setQuery('SELECT ' .
						  		 'pf.id, pf.fieldname, pf.title, pf.description, pf.fieldtypeid, pf.settings, ' .
						  		 'fc.attribute, fc.content ' .
						  		 'FROM #__f2c_fieldcontent fc ' .
						  		 'INNER JOIN #__f2c_projectfields pf on fc.fieldid = pf.id ' .
						  		 'WHERE fc.formid = '.(int)$this->_id . ' ORDER BY pf.fieldtypeid');
						  
			$fieldContentList = $this->_db->loadObjectList();

			$this->_fieldData = array();
			
			foreach($fieldContentList as $fieldContent)
			{
				if(!array_key_exists($fieldContent->id, $this->_fieldData))
				{
					$fldData 				= new F2C_FieldData();
					$fldData->id 			= $fieldContent->id;
					$fldData->fieldtypeid 	= $fieldContent->fieldtypeid;
					$fldData->title 		= $fieldContent->title;
					$fldData->description	= $fieldContent->description;
					$fldData->fieldname 	= $fieldContent->fieldname;
					$fldData->settings 		= $fieldContent->settings;
										
					if($fldData->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
					{
						$fldData->attributes['VALUE'] = array();
					}
					
					$this->_fieldData[$fieldContent->id] = $fldData;					 			
				}
							
				if($fldData->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
				{
					$this->_fieldData[$fieldContent->id]->attributes[$fieldContent->attribute][] = $fieldContent->content;
				}
				else
				{						
					$this->_fieldData[$fieldContent->id]->attributes[$fieldContent->attribute] = $fieldContent->content;
				}
			}
			
			return (boolean)$this->_data;
		}
		
		return true;
	}

	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$projectId = JRequest::getInt('projectid');
			$this->_initForm($projectId);
			return (boolean) $this->_data;		
		}
		return true;
	}	
}
?>