﻿<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'class.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'utils.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'configuration.php');

jimport('joomla.application.component.model');

class Form2ContentModelProject extends JModel
{
	var $_id = null;
	var $_data = null;
	
	function __construct()
	{
		parent::__construct();

		$cid = JRequest::getVar('cid', false, 'DEFAULT', 'array');
		
		if($cid && $cid[0])
		{
			$id = $cid[0];
		}
		else
		{
			$id = JRequest::getInt('id', 0);
		}
		
		$this->setId($id);
	}
	
	function setId($id = 0)
	{
		$this->_id = $id;
		$this->_data = null;
	}
	
	function &getData()
	{
		if (!$this->_loadData())
		{
			$this->_initData();	
		}

		return $this->_data;				
	}
	
	function _loadData()
	{
		if(empty($this->_data))
		{
			$db =& $this->getDBO();
			$query = "SELECT * FROM " . $db->nameQuote('#__f2c_project') . " WHERE " . $db->nameQuote('id') . " = " . (int)$this->_id;
			$db->setQuery($query);
			$this->_data = $db->loadObject();
		}
		
		return $this->_data;
	}
	
	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$project = new stdClass();
			$project->id					= 0;
			$project->title					= null;
			$project->created_by			= 0;
			$project->created				= null;
			$project->modified				= 0;
			$project->version				= '';
			$project->published				= 0;
			$project->sectionid				= 0;
			$project->catid					= 0;
			$project->intro_template		= '';
			$project->main_template			= '';
			$project->frontend_catsel		= 1;
			$project->frontend_templsel		= 1;
			$project->frontend_pubsel		= 1;
			$project->settings				= null;
			$project->attribs				= null;
			$project->metadata				= null;
			$this->_data					= $project;
			return (boolean)$this->_data;
		}
		
		return true;
	}	
	
	function save($data)
	{
		$row =& $this->getTable('Project');
		$isNew = false;
		
		// Bind the form fields to the table
		if (!$row->bind($data)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// fill the contentType settings
		$contentTypeSettings 							= new F2C_ContentTypeSettings();
		$contentTypeSettings->article_caption			= unquoteData(JRequest::getString('article_caption'));
		$contentTypeSettings->title_front_end	 		= JRequest::getInt('title_front_end');
		$contentTypeSettings->title_caption 			= unquoteData(JRequest::getString('title_caption'));
		$contentTypeSettings->title_default				= unquoteData(JRequest::getString('title_default'));
		$contentTypeSettings->title_alias_front_end 	= JRequest::getInt('title_alias_front_end');
		$contentTypeSettings->title_alias_caption		= unquoteData(JRequest::getString('title_alias_caption'));
		$contentTypeSettings->metakey_front_end 		= JRequest::getInt('metakey_front_end');
		$contentTypeSettings->metakey_caption	 		= unquoteData(JRequest::getString('metakey_caption'));
		$contentTypeSettings->metadesc_front_end 		= JRequest::getInt('metadesc_front_end');
		$contentTypeSettings->metadesc_caption 			= unquoteData(JRequest::getString('metadesc_caption'));
		$contentTypeSettings->section_category_caption 	= unquoteData(JRequest::getString('section_category_caption'));		
		$contentTypeSettings->created_by_front_end	 	= JRequest::getInt('created_by_front_end');
		$contentTypeSettings->created_by_caption	 	= JRequest::getString('created_by_caption');
		$contentTypeSettings->created_by_alias_front_end= JRequest::getInt('created_by_alias_front_end');
		$contentTypeSettings->created_by_alias_caption	= JRequest::getString('created_by_alias_caption');
		$contentTypeSettings->state_front_end	 		= JRequest::getInt('state_front_end');
		$contentTypeSettings->state_caption		 		= JRequest::getString('state_caption');
		$contentTypeSettings->state_default		 		= JRequest::getInt('state_default');
		$contentTypeSettings->frontpage_front_end		= JRequest::getInt('frontpage_front_end');
		$contentTypeSettings->frontpage_caption			= JRequest::getString('frontpage_caption');
		$contentTypeSettings->frontpage_default	 		= JRequest::getInt('frontpage_default');
		$contentTypeSettings->max_forms			 		= JRequest::getInt('max_forms');
		$contentTypeSettings->access_front_end 			= JRequest::getInt('access_front_end');
		$contentTypeSettings->access_caption 			= unquoteData(JRequest::getString('access_caption'));
		$contentTypeSettings->access_default 			= unquoteData(JRequest::getInt('access_default'));
		$contentTypeSettings->date_created_front_end	= JRequest::getInt('date_created_front_end');
		$contentTypeSettings->captcha_front_end			= JRequest::getInt('captcha_front_end');
		$contentTypeSettings->required_field_text		= JRequest::getString('required_field_text');
		
		if(trim($row->title) == '')
		{
			$this->setError(JText::_('ERROR_PROJECT_TITLE_EMPTY'));
			return false;
		}
		
		if($contentTypeSettings->title_front_end == 0 && trim($contentTypeSettings->title_default) == '')
		{
			$this->setError(JText::_('ERROR_PROJECT_TITLE_DEFAULT_EMPTY'));
			return false;
		}

		if($row->frontend_templsel == 0 && trim($row->intro_template) == '')
		{
			$this->setError(JText::_('ERROR_PROJECT_INTRO_TEMPLATE_DEFAULT_EMPTY'));
			return false;
		}

		if($row->frontend_catsel == 0 && $row->catid < 0)
		{
			$this->setError(JText::_('ERROR_PROJECT_SECTION_CATEGORY_DEFAULT_EMPTY'));
			return false;
		}

		// Handle metadata defaults
		$metadata = JRequest::getVar( 'meta', null, 'post', 'array');

		if (is_array($metadata))
		{
			$txt = array();
			
			foreach ($metadata as $k => $v)
			{
				if ($k == 'description')
				{
					$contentTypeSettings->metadesc_default = $v;
				}
				elseif ($k == 'keywords') 
				{
					$contentTypeSettings->metakey_default = $v;
				}
				else
				{
					$txt[] = "$k=$v";
				}
			}
			$row->metadata = implode("\n", $txt);
		}
		
		$row->settings 	= serialize($contentTypeSettings);		
		$row->attribs 	= ContentHelper::encodeParameters('params');
		
		$timestamp =& JFactory::getDate();
		
		if(!$row->id)
		{
			// new record -> initialize
			$isNew = true;
			$user =& JFactory::getUser();
		
			$row->created_by = $user->id;		
			$row->created = $timestamp->toMySQL();
		}	

		if(!$row->version)
		{
			if($data = JApplicationHelper::parseXMLInstallFile(JPATH_COMPONENT.DS.'form2content.xml')) 
			{
				$row->version = $data['version'];
			}
		}
		
		$row->modified = $timestamp->toMySQL();;
						
		if(!$row->store())
		{
			$this->setError($row->getError());
			return false;
		}
		
		// sync id's
		$this->setId($row->id);
		
		// check if we need to generate a default template
		if($isNew)
		{
			$config = new F2CConfig();
			
			if($config->generate_sample_template)
			{
				F2C_AdminHelper::generateSampleTemplate($row->id);
				$row->intro_template = 'default_intro_template_' . JFile::makeSafe($row->title) . '.tpl';
				$row->main_template  = 'default_main_template_' . JFile::makeSafe($row->title) . '.tpl';
				
				if(!$row->store())
				{
					$this->setError($row->getError());
					return false;
				}
			}
		}
		
		$cache = & JFactory::getCache('com_form2content');
		$cache->clean();
		
		return true;
	}
	
	function delete($modelForm)
	{
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		
		if(count($cids))
		{
			foreach($cids as $cid) 
			{
				// Get the list of forms for this Content Type
				$this->_db->setQuery('SELECT id FROM #__f2c_form WHERE projectid='.(int)$cid);											
				$forms = $this->_db->LoadObjectList();
				
				if(count($forms))
				{
					foreach($forms as $form)
					{
						$modelForm->deleteSingleForm($form->id);					
					}
				}
				
				// remove the base image dir
				if(JFolder::exists(Path::Combine(F2C_Image::GetImagesRootPath(), "p$cid")))
				{
					JFolder::delete(Path::Combine(F2C_Image::GetImagesRootPath(), "p$cid"));
				}
				
				// remove the base file dir
				if(JFolder::exists(Path::Combine(F2C_FileUpload::GetFilesRootPath(), "c$cid")))
				{
					JFolder::delete(Path::Combine(F2C_FileUpload::GetFilesRootPath(), "c$cid"));
				}
				
				// Delete the translations
				$this->_db->setQuery('DELETE tra.* FROM #__f2c_translation tra ' . 
									 'INNER JOIN #__f2c_projectfields pfl ON pfl.id = tra.reference_id ' .
									 'WHERE pfl.projectid ='.(int)$cid);
				
				if(!$this->_db->query())
				{
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
				
				// Delete the Content Type Field definitions
				$this->_db->setQuery('DELETE FROM #__f2c_projectfields WHERE projectid='.(int)$cid);
				
				if(!$this->_db->query())
				{
					$this->setError($this->_db->getErrorMsg());
					return false;
				}

				// Delete the Content Type				
				$this->_db->setQuery('DELETE FROM #__f2c_project WHERE id='.(int)$cid);
				
				if(!$this->_db->query())
				{
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}
		
		return true;
	}	
	
	function publish()
	{
		return $this->_publish(1);
	}	

	function unpublish()
	{
		return $this->_publish(0);
	}

	function _publish($state)
	{
		$cids = JRequest::getVar('cid', array(0), 'post', 'array');
		$user =& JFactory::getUser();
		$table =& $this->getTable();

		if(!$table->publish($cids, $state, $user->get('id')))
		{
			$this->setError($table->getError());
			return false;
		}
		
		return true;
	}
	
	function copy()
	{
		$cids 					= JRequest::getVar('cid', array(0), 'post', 'array');
		$contentTypeTable 		= JTable::getInstance('project','Table');
		$contentTypeFieldRow 	=& $this->getTable('ProjectField');
		$dateNow 				=& JFactory::getDate();
		$timestamp 				= $dateNow->toMySQL();
		
		foreach($cids as $cid)
		{
			if(!$contentTypeTable->load($cid))
			{
				$this->setError($contentTypeTable->getError());
				return false;
			}
			
			$contentTypeTable->title = JText::_('COPY_OF') . ' ' . $contentTypeTable->title;
			$contentTypeTable->id = 0; // force insert
			$contentTypeTable->created = $timestamp;
			$contentTypeTable->modified = $timestamp;
			
			if(!$contentTypeTable->store())
			{
				$this->setError($contentTypeTable->getError());
				return false;
			}
			
			// copy the ContentType Fields
			$sql = 'SELECT * FROM #__f2c_projectfields WHERE projectid = ' . (int)$cid;
			
			$this->_db->setQuery($sql);
			$contentTypeFields = $this->_db->loadObjectList();
			
			if(count($contentTypeFields))
			{
				foreach($contentTypeFields as $contentTypeField)
				{
					if (!$contentTypeFieldRow->bind($contentTypeField)) 
					{
						$this->setError($this->_db->getErrorMsg());
						return false;
					}

					$contentTypeFieldRow->id = 0; // force insert
					$contentTypeFieldRow->projectid = $contentTypeTable->id;
				
					if(!$contentTypeFieldRow->store())
					{
						$this->setError($contentTypeFieldRow->getError());
						return false;
					}
				}
			}
		}
		
		return true;
	}
	
	function syncjadvparms()
	{
		$sql = 	'UPDATE #__f2c_form frm ' .
				'INNER JOIN #__f2c_project prj ON frm.projectid = prj.id AND prj.id = ' . $this->_id . ' ' . 
				'SET frm.attribs = prj.attribs';
		$this->_db->setQuery($sql);
		
		if($this->_db->query())
		{			
			return JText::_('SYNC_OK');
		}
		else
		{
			return $this->_db->getErrorMsg(); 
		}
	}
	
	function syncmetadata()
	{
		$this->_loadData();
		
		$cts 		= ($this->_data->settings) ? unserialize($this->_data->settings) : new F2C_ContentTypeSettings();
		$metakey	= ($cts->metakey_default) ? $cts->metakey_default : '';
		$metadesc	= ($cts->metadesc_default) ? $cts->metadesc_default : '';
		
		$sql = 	'UPDATE #__f2c_form frm ' .
				'INNER JOIN #__f2c_project prj ON frm.projectid = prj.id AND prj.id = ' . $this->_id . ' ' . 
				'SET frm.metadata = prj.metadata, ' .
				'frm.metakey = ' . $this->_db->Quote($metakey) . ' , ' .
				'frm.metadesc = ' . $this->_db->Quote($metadesc) . ' ';

		$this->_db->setQuery($sql);
		
		if($this->_db->query())
		{			
			return JText::_('SYNC_OK');
		}
		else
		{
			return $this->_db->getErrorMsg(); 
		}
	}
	
	function display()
	{
	}	
}
?>