﻿<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'utils.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'class.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'configuration.php');

jimport('joomla.application.component.model');

class Form2ContentModelProjectField extends JModel
{
	var $_id = null;
	var $_data = null;
	
	function __construct()
	{
		parent::__construct();

		$cid = JRequest::getVar('cid', false, 'DEFAULT', 'array');
		
		if($cid)
		{
			$id = $cid[0];
		}
		else
		{
			$id = JRequest::getInt('id', 0);
		}
		
		$this->setId($id);
	}
	
	function setId($id = 0)
	{
		$this->_id = $id;
		$this->_data = null;
	}
	
	function &getData()
	{
		if (!$this->_loadData())
		{
			$this->_initData();	
		}

		return $this->_data;		
	}
	
	function save($data)
	{
		$config 					= new F2CConfig();
		$row 						=& $this->getTable();
		$fieldRequired 				= JRequest::getInt('required', 0);
		$fieldRequiredErrorMessage 	= JRequest::getString('error_message_required', '');
		
		// Bind the form fields to the table
		if (!$row->bind($data)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		switch((int)$row->fieldtypeid)
		{
			case F2C_FIELDTYPE_SINGLELINE:
				$fieldSettings = new F2C_SingleLineTextSettings();
				$fieldSettings->required = $fieldRequired;
				$fieldSettings->errorMessageRequired = $fieldRequiredErrorMessage;
				$fieldSettings->size = JRequest::getInt('slt_size', 0);
				$fieldSettings->maxLength = JRequest::getInt('slt_max_length', 0);
				$fieldSettings->attributes = unquoteData(JRequest::getVar('slt_attributes', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$row->settings = serialize($fieldSettings);
				break;
				
			case F2C_FIELDTYPE_MULTILINETEXT:
				$multiLineTextSettings = new F2C_MultiLineTextSettings();
				$multiLineTextSettings->maxNumChars = JRequest::getInt('mlt_max_num_chars', 0);
				$multiLineTextSettings->required = $fieldRequired;
				$multiLineTextSettings->errorMessageRequired = $fieldRequiredErrorMessage;
				$multiLineTextSettings->numCols = JRequest::getInt('mlt_num_cols', 0);
				$multiLineTextSettings->numRows = JRequest::getInt('mlt_num_rows', 0);
				$multiLineTextSettings->attributes = unquoteData(JRequest::getVar('mlt_attributes', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$row->settings = serialize($multiLineTextSettings);
				break;
				
			case F2C_FIELDTYPE_MULTILINEEDITOR:
				$fieldSettings = new F2C_MultiLineEditorSettings();
				$fieldSettings->numRows					= JRequest::getString('mle_num_rows');
				$fieldSettings->numCols					= JRequest::getString('mle_num_cols');
				$fieldSettings->width					= JRequest::getString('mle_width');
				$fieldSettings->height					= JRequest::getString('mle_height');
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired	= $fieldRequiredErrorMessage;				
				$row->settings = serialize($fieldSettings);
				break;
			
			case F2C_FIELDTYPE_CHECKBOX:
				$fieldSettings = new F2C_CheckBoxSettings();
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired	= $fieldRequiredErrorMessage;				
				$fieldSettings->attributes = unquoteData(JRequest::getVar('chk_attributes', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$row->settings = serialize($fieldSettings);
				break;
								
			case F2C_FIELDTYPE_SINGLESELECTLIST:
			
				$listNew = null;

				if(count($data['tblSingleSelectKvpRowKey']))
				{
					foreach($data['tblSingleSelectKvpRowKey'] as $rowKey)
					{
						$key = $data[$rowKey . 'key'];
						
						if($key != '')
						{
							if(!$listNew || !array_key_exists($key, $listNew))
							{	
								// fix up special html field
								$listNew[$key] = JRequest::getVar($rowKey . 'val', '', 'post', 'string', JREQUEST_ALLOWRAW);
							}
						}						
					}
				}
				
				$singleSelectSettings = new F2C_SingleSelectSettings();
				$singleSelectSettings->listOptions = $listNew;
				$singleSelectSettings->displayMode = getValueOrDefault($data['singleSelectDisplayMode'], 0);
				$singleSelectSettings->showEmptyText = array_key_exists('ssl_show_empty_choice_text',$data) ? true : false;
				$singleSelectSettings->emptyText = getValueOrDefault($data['ssl_empty_choice_text'], ''); 
				$singleSelectSettings->required = $fieldRequired;
				$singleSelectSettings->errorMessageRequired = $fieldRequiredErrorMessage;
				$singleSelectSettings->attributes = unquoteData(JRequest::getVar('ssl_attributes', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$row->settings = serialize($singleSelectSettings);		
				break;
				
			case F2C_FIELDTYPE_IMAGE:
				$fieldSettings = new F2C_ImageSettings();
				
				// get default thumbnail sizes from config
				$defaultThumbnailWidth = (array_key_exists('default_thumbnail_width',get_object_vars($config)) && (int)$config->default_thumbnail_width) ? (int)$config->default_thumbnail_width : F2C_DEFAULT_THUMBNAIL_WIDTH;
				$defaultThumbnailHeight = (array_key_exists('default_thumbnail_height',get_object_vars($config)) && (int)$config->default_thumbnail_height) ? (int)$config->default_thumbnail_height : F2C_DEFAULT_THUMBNAIL_HEIGHT;
				
				$maxImageWidth 		= getValueOrDefault($data['maxImageWidth'], 0);
				$maxImageHeight 	= getValueOrDefault($data['maxImageHeight'], 0);
				$thumbnailWidth 	= (int)getValueOrDefault($data['thumbnailWidth']) ? (int)getValueOrDefault($data['thumbnailWidth']) : $defaultThumbnailWidth;
				$thumbnailHeight 	= (int)getValueOrDefault($data['thumbnailHeight']) ? (int)getValueOrDefault($data['thumbnailHeight']) : $defaultThumbnailHeight;

				$fieldSettings->width 					= $maxImageWidth ? $maxImageWidth : 10000;
				$fieldSettings->height 					= $maxImageHeight ? $maxImageHeight : 10000;
				$fieldSettings->imageOutputMode 		= $data['imageOutputMode'];				
				$fieldSettings->thumbnailWidth 			= $thumbnailWidth;
				$fieldSettings->thumbnailHeight 		= $thumbnailHeight;
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired 	= $fieldRequiredErrorMessage;
				$fieldSettings->uploadAttributes 		= unquoteData(JRequest::getVar('img_attributes_image', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->deleteAttributes 		= unquoteData(JRequest::getVar('img_attributes_delete', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->altValueAttributes 		= unquoteData(JRequest::getVar('img_attributes_alt_text', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->titleAttributes 		= unquoteData(JRequest::getVar('img_attributes_title', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->showAltTag 				= JRequest::getInt('imageShowAltTag');
				$fieldSettings->showTitleTag 			= JRequest::getInt('imageShowTitleTag');				
				$row->settings 							= serialize($fieldSettings);
				break;
				
			case F2C_FIELDTYPE_IFRAME:
				$fieldSettings 							= new F2C_IFrameSettings();
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired	= $fieldRequiredErrorMessage;				
				$fieldSettings->iFrameAttributes 		= unquoteData(JRequest::getVar('ifr_attributes_iframe', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->widthAttributes 		= unquoteData(JRequest::getVar('ifr_attributes_width', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->heightAttributes 		= unquoteData(JRequest::getVar('ifr_attributes_height', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$row->settings 							= serialize($fieldSettings);
				break;
				
			case F2C_FIELDTYPE_EMAIL:
				$fieldSettings 							= new F2C_EmailSettings();
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired	= $fieldRequiredErrorMessage;				
				$fieldSettings->emailAttributes 		= unquoteData(JRequest::getVar('eml_attributes_email', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->displayAsAttributes 	= unquoteData(JRequest::getVar('eml_attributes_display_as', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->showDisplayAs 			= JRequest::getInt('eml_show_display_as');				
				$row->settings 							= serialize($fieldSettings);			
				break;
				
			case F2C_FIELDTYPE_HYPERLINK:
				$fieldSettings 							= new F2C_LinkSettings();
				$fieldSettings->outputMode 				= $data['linkOutputMode'];
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired 	= $fieldRequiredErrorMessage;
				$fieldSettings->linkAttributes 			= unquoteData(JRequest::getVar('lnk_attributes_link', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->displayAsAttributes 	= unquoteData(JRequest::getVar('lnk_attributes_display_as', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->titleAttributes 		= unquoteData(JRequest::getVar('lnk_attributes_title', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->targetAttributes 		= unquoteData(JRequest::getVar('lnk_attributes_target', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->showDisplayAs 			= JRequest::getInt('lnk_show_display_as');				
				$fieldSettings->showTitle 				= JRequest::getInt('lnk_show_title');				
				$fieldSettings->showTarget 				= JRequest::getInt('lnk_show_target');								
				$row->settings 							= serialize($fieldSettings);
				break;
			
			case F2C_FIELDTYPE_MULTISELECTLIST:
			
				$multiSelectSettings 						= new F2C_MultiSelectSettings();
				$listNew 									= null;
				$multiSelectSettings->required 				= $fieldRequired;
				$multiSelectSettings->errorMessageRequired 	= $fieldRequiredErrorMessage;
				$multiSelectSettings->preListTag			= unquoteData(JRequest::getVar('mslPreListTag', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$multiSelectSettings->postListTag			= unquoteData(JRequest::getVar('mslPostListTag', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$multiSelectSettings->preElementTag			= unquoteData(JRequest::getVar('mslPreElementTag', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$multiSelectSettings->postElementTag		= unquoteData(JRequest::getVar('mslPostElementTag', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$multiSelectSettings->attributes 			= unquoteData(JRequest::getVar('msl_attributes', '', 'post', 'string', JREQUEST_ALLOWRAW));

				if(count($data['tblMultiSelectKvpRowKey']))
				{
					foreach($data['tblMultiSelectKvpRowKey'] as $rowKey)
					{
						$key = $data[$rowKey . 'key'];
						
						if($key != '')
						{
							if(!$listNew || !array_key_exists($key, $listNew))
							{	
								// fix up special html field
								$listNew[$key] = JRequest::getVar($rowKey . 'val', '', 'post', 'string', JREQUEST_ALLOWRAW);
							}
						}						
					}
				}
				
				$multiSelectSettings->listOptions = $listNew;
				$row->settings = serialize($multiSelectSettings);							
				break;
				
			case F2C_FIELDTYPE_INFOTEXT:
				$infoTextSettings = new F2C_InfoTextSettings();
				$infoTextSettings->text = JRequest::getVar('infoFieldText', '', 'post', 'string', JREQUEST_ALLOWRAW );		
				$infoTextSettings->required = $fieldRequired;
				$infoTextSettings->errorMessageRequired = $fieldRequiredErrorMessage;
				$row->settings = serialize($infoTextSettings);
				break;		
				
			case F2C_FIELDTYPE_DATEPICKER:
				$fieldSettings 							= new F2C_DatePickerSettings();
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired	= $fieldRequiredErrorMessage;				
				$fieldSettings->attributes 				= unquoteData(JRequest::getVar('dat_attributes', '', 'post', 'string', JREQUEST_ALLOWRAW));								
				$row->settings 							= serialize($fieldSettings);							
				break;
				
			case F2C_FIELDTYPE_DISPLAYLIST:
				$fieldSettings 							= new F2C_DisplayListSettings();
				$fieldSettings->ordered 				= JRequest::getInt('displayListOrdered', '0');
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired 	= $fieldRequiredErrorMessage;
				$fieldSettings->attributesTable			= unquoteData(JRequest::getVar('dsp_attributes_table', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesTr			= unquoteData(JRequest::getVar('dsp_attributes_tr', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesTh			= unquoteData(JRequest::getVar('dsp_attributes_th', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesTd			= unquoteData(JRequest::getVar('dsp_attributes_td', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesItemText		= unquoteData(JRequest::getVar('dsp_attributes_item_text', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesAddButton		= unquoteData(JRequest::getVar('dsp_attributes_add_button', '', 'post', 'string', JREQUEST_ALLOWRAW));				
				$row->settings 							= serialize($fieldSettings);
				break;

			case F2C_FIELDTYPE_FILE:			
				$fileSettings = new F2C_fileSettings();
				$fileSettings->whiteList = array();
				$fileSettings->blackList = array();
				
				$fileSettings->outputMode = $data['fileOutputMode'];
				
				if(count($data['tblFileWhiteListRowKey']))
				{
					foreach($data['tblFileWhiteListRowKey'] as $rowKey)
					{
						$key = strtolower(getValueOrDefault($data[$rowKey . 'key']));

						if($key != '')
						{
							if(!$fileSettings->whiteList || !array_key_exists($key, $fileSettings->whiteList))
							{	
								$fileSettings->whiteList[$key] = $key;
							}
						}						
					}
				}
				
				if(count($data['tblFileBlackListRowKey']))
				{
					foreach($data['tblFileBlackListRowKey'] as $rowKey)
					{
						$key = strtolower(getValueOrDefault($data[$rowKey . 'key']));

						if($key != '')
						{
							if(!$fileSettings->blackList || !array_key_exists($key, $fileSettings->blackList))
							{	
								$fileSettings->blackList[$key] = $key;
							}
						}						
					}
				}

				$fileSettings->required 				= $fieldRequired;
				$fileSettings->errorMessageRequired 	= $fieldRequiredErrorMessage;
				$fileSettings->uploadAttributes 		= unquoteData(JRequest::getVar('ful_attributes_upload', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fileSettings->deleteAttributes 		= unquoteData(JRequest::getVar('ful_attributes_delete', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$maxFileSize							= JRequest::getInt('ful_max_file_size');
				$fileSettings->maxFileSize				= ($maxFileSize) ? $maxFileSize : -1;
				$row->settings 							= serialize($fileSettings);		
				break;

			case F2C_FIELDTYPE_DATABASE_LOOKUP:
			
				$databaseLookupSettings = new F2C_DatabaseLookupSettings();				
				$databaseLookupSettings->displayMode = getValueOrDefault($data['dbl_display_mode'], 0);
				$databaseLookupSettings->query = getValueOrDefault($data['dbl_query'], '');
				
				if(strstr($databaseLookupSettings->query, '*'))
				{
					$this->setError(JText::_('ERROR_DBL_QUERY_ASTERISK_NOT_ALLOWED'));
					return false;					
				}
				
				$databaseLookupSettings->showEmptyText = array_key_exists('dbl_show_empty_choice_text',$data) ? true : false;
				$databaseLookupSettings->emptyText = getValueOrDefault($data['dbl_empty_choice_text'], ''); 
				$databaseLookupSettings->required = $fieldRequired;
				$databaseLookupSettings->errorMessageRequired = $fieldRequiredErrorMessage;
				$databaseLookupSettings->attributes = unquoteData(JRequest::getVar('dbl_attributes', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$row->settings = serialize($databaseLookupSettings);		
				break;

			case F2C_FIELDTYPE_GEOCODER:
				$geoCoderSettings 						= new F2C_GeoCoderSettings();
				$geoCoderSettings->showMap 				= $data['gcd_show_map'];
				$geoCoderSettings->mapWidth 			= getValueOrDefault($data['gcd_map_width'], '');
				$geoCoderSettings->mapHeight 			= getValueOrDefault($data['gcd_map_height'], '');
				$geoCoderSettings->mapLat 				= getValueOrDefault($data['gcd_map_lat'], '');
				$geoCoderSettings->mapLon 				= getValueOrDefault($data['gcd_map_lon'], '');
				$geoCoderSettings->mapZoom 				= $data['gcd_map_zoom'];
				$geoCoderSettings->mapType 				= $data['gcd_map_type'];
				$geoCoderSettings->required 			= $fieldRequired;
				$geoCoderSettings->errorMessageRequired = $fieldRequiredErrorMessage;
				$geoCoderSettings->attributesAddress	= unquoteData(JRequest::getVar('gcd_attributes_address', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$geoCoderSettings->attributesLookup		= unquoteData(JRequest::getVar('gcd_attributes_lookup_lat_lon', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$geoCoderSettings->attributesClear		= unquoteData(JRequest::getVar('gcd_attributes_clear_results', '', 'post', 'string', JREQUEST_ALLOWRAW));		
				$row->settings 							= serialize($geoCoderSettings);
				break;
				
			case F2C_FIELDTYPE_DB_LOOKUP_MULTI:
				$fieldSettings 							= new F2C_DatabaseLookupMultiSettings();
				$fieldSettings->ordered 				= JRequest::getInt('databaseLookupMultiOrderedList', '0');
				$fieldSettings->required 				= $fieldRequired;
				$fieldSettings->errorMessageRequired 	= $fieldRequiredErrorMessage;
				$fieldSettings->attributesTable			= unquoteData(JRequest::getVar('dlm_attributes_table', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesTr			= unquoteData(JRequest::getVar('dlm_attributes_tr', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesTh			= unquoteData(JRequest::getVar('dlm_attributes_th', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesTd			= unquoteData(JRequest::getVar('dlm_attributes_td', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesItemText		= unquoteData(JRequest::getVar('dlm_attributes_item_text', '', 'post', 'string', JREQUEST_ALLOWRAW));
				$fieldSettings->attributesAddButton		= unquoteData(JRequest::getVar('dlm_attributes_add_button', '', 'post', 'string', JREQUEST_ALLOWRAW));
				
				$fieldSettings->query = getValueOrDefault($data['dlm_query'], '');
				
				if(strstr($fieldSettings->query, '*'))
				{
					$this->setError(JText::_('ERROR_DBL_QUERY_ASTERISK_NOT_ALLOWED'));
					return false;					
				}
				
				$fieldSettings->showEmptyText 		= array_key_exists('dlm_show_empty_choice_text',$data) ? true : false;
				$fieldSettings->emptyText 			= getValueOrDefault($data['dlm_empty_choice_text'], ''); 
				$fieldSettings->attributesSelect 	= unquoteData(JRequest::getVar('dlm_attributes_select', '', 'post', 'string', JREQUEST_ALLOWRAW));								
				$row->settings 						= serialize($fieldSettings);
				break;
		}		
			
		// if new item, order last in appropriate group
		if (!$row->id) 
		{
			$row->ordering = $row->getNextOrder();
		}

		if (!$row->check()) 
		{
			$this->setError($row->getError());
			return false;
		}

		// Store the table to the database
		if (!$row->store()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Update item order
		$row->reorder('projectid = '.(int)$row->projectid);
		
		if($config->generate_sample_template)
		{
			F2C_AdminHelper::generateSampleTemplate($row->projectid);
		}
		
		$cache = & JFactory::getCache('com_form2content');
		$cache->clean();
		
		return true;
	}
	
	function delete()
	{
		$config = new F2CConfig();
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$idList = 'id=' . implode(' OR id=', $cids);
		
		if(count($cids))
		{
			foreach($cids as $cid) 
			{
				deleteImages(F2C_ENTITY_CONTENTTYPEFIELD, $cid);	
				F2C_FileUpload::deleteFiles(F2C_ENTITY_CONTENTTYPEFIELD, $cid);	
			}
			
			if($config->generate_sample_template)
			{
				$this->_db->setQuery("SELECT projectid FROM #__f2c_projectfields WHERE id=$cids[0]");
				$projectid = $this->_db->loadResult();
			}
		
			deleteTableRows('#__f2c_translation', 'reference_id=' . implode(' OR reference_id=', $cids));
			deleteTableRows('#__f2c_fieldcontent', 'fieldid=' . implode(' OR fieldid=', $cids));
			
			$this->_db->setQuery("DELETE FROM #__f2c_projectfields WHERE ($idList)");
			
			if(!$this->_db->query())
			{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			if($config->generate_sample_template)
			{
				F2C_AdminHelper::generateSampleTemplate($row->projectid);
			}
			
			$cache = & JFactory::getCache('com_form2content');
			$cache->clean();
		}
				
		return true;
	}	
	
	function move($direction)
	{
		$row =& $this->getTable();
		
		if (!$row->load($this->_id)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move($direction, 'projectid = ' . (int)$row->projectid)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		$this->_cleanCache();
		
		return true;
	}

	function saveorder($cid, $order)
	{
		$total		= count($cid);
		$conditions	= array();
		
		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate a form table object
		JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_form2content'.DS.'tables');
		$row =& JTable::getInstance('projectfield', 'Table');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load((int)$cid[$i]);
			
			if ($row->ordering != $order[$i]) 
			{
				$row->ordering = $order[$i];
				
				if (!$row->store()) 
				{
					JError::raiseError( 500, $db->getErrorMsg());
					return false;
				}
				
				// remember to updateOrder this group
				$condition = 'projectid = '.(int)$row->projectid;
				$found = false;
				
				foreach($conditions as $cond)
				{
					if ($cond[1] == $condition) 
					{
						$found = true;
						break;
					}
				}
					
				if (!$found)
				{
					$conditions[] = array ($row->id, $condition);
				}
			}
		}

		// execute updateOrder for each group
		foreach($conditions as $cond)
		{
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}

		$this->_cleanCache();

		return true;
	}				
		
	function display()
	{
	}	

	function copy()
	{
		$cids 					= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$contentTypeId 			= JRequest::getInt('projectid');
		$contentTypeFieldRow 	=& $this->getTable('ProjectField');
		
		if(count($cids))
		{
			$sql = 'SELECT * FROM #__f2c_projectfields WHERE id IN (' . implode(',', $cids) . ')';			
			$this->_db->setQuery($sql);
			$contentTypeFields = $this->_db->loadObjectList();
						
			foreach($contentTypeFields as $contentTypeField)
			{
				if (!$contentTypeFieldRow->bind($contentTypeField)) 
				{
					$this->setError($this->_db->getErrorMsg());
					return false;
				}

				$contentTypeFieldRow->id 		= 0; // force insert
				$contentTypeFieldRow->fieldname = $contentTypeFieldRow->fieldname . '_copy';
				$contentTypeFieldRow->projectid = $contentTypeId;
				$contentTypeFieldRow->ordering 	= $contentTypeFieldRow->getNextOrder();
			
				if(!$contentTypeFieldRow->store())
				{
					$this->setError($contentTypeFieldRow->getError());
					return false;
				}								
			}
			
			if($config->generate_sample_template)
			{
				F2C_AdminHelper::generateSampleTemplate($contentTypeId);
			}
			
			$cache = & JFactory::getCache('com_form2content');
			$cache->clean();			
		}
		
		return true;		
	}
	
	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = "SELECT * FROM " . $this->_db->nameQuote('#__f2c_projectfields') . " WHERE " . $this->_db->nameQuote('id') . " = " . (int)$this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean)$this->_data;
		}
		return true;
	}

	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$projectfield = new stdClass();
			$projectfield->id			= 0;
			$projectfield->projectid	= JRequest::getInt('projectid');
			$projectfield->fieldname	= null;
			$projectfield->title		= null;
			$projectfield->description	= null;
			$projectfield->fieldtypeid	= 0;
			$projectfield->settings		= null;
			$projectfield->ordering		= 0;
			$projectfield->frontvisible	= 1;
			$this->_data				= $projectfield;
			return (boolean)$this->_data;
		}
		
		return true;
	}
	
	function _cleanCache()
	{
		$cache = &JFactory::getCache('com_form2content');
		$cache->clean();		
	}	
}
?>