﻿<?php
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class Form2ContentModelProjectFields extends JModel
{
	var $_data = null;
	var $_pagination = null;
	var $_total = null;

	function __construct()
	{
		parent::__construct();
		
		$app 		=& JFactory::getApplication();
		$option 	= JRequest::getCmd('option');		
		$limit 		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart = $app->getUserStateFromRequest($option.'.projectfields.limitstart', 'limitstart', 0, 'int');
		
		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);		
	}

	function getData()
	{
		if(empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	
	function getPagination()
	{
		if(empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
		}
		
		return $this->_pagination;
	}
	
	function getTotal()
	{		
		if(empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);			
		}
		
		return $this->_total;		
	}	
	
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();
		
		$query = 'SELECT a.*, t.description AS fieldtype ' .
				 'FROM #__f2c_projectfields a LEFT JOIN #__f2c_fieldtype t ON a.fieldtypeid = t.id ' . 
				 $where .
				 $orderby;
		
		return $query;
	}
	
	function _buildContentWhere()
	{
		$app 	=& JFactory::getApplication();
		$option = JRequest::getCmd('option');		
		$db		=& JFactory::getDBO();
		$search	= $app->getUserStateFromRequest( $option.'searchprojectfields', 'search', '', 'string');
		$search	= JString::strtolower($search);

		$where = array();

		// filter for project
		$where[] = 'a.projectid=' . JRequest::getInt('projectid', 0);
		
		if ($search) 
		{
			$where[] = 'LOWER(a.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}

		$where = (count($where) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}
	
	function _buildContentOrderBy()
	{
		return ' ORDER BY a.ordering ';;
	}		
}
?>
