<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'class.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'utils.form2content.php');

jimport('joomla.application.component.model');

class Form2ContentModelTranslation extends JModel
{
	var $_id = null;
	var $_data = null;
	
	function __construct()
	{
		parent::__construct();

		$cid = JRequest::getVar('cid', false, 'DEFAULT', 'array');
		
		if($cid)
		{
			$id = $cid[0];
		}
		else
		{
			$id = JRequest::getInt('id', 0);
		}
		
		$this->setId($id);
	}
	
	function setId($id = 0)
	{
		$this->_id = $id;
		$this->_data = null;
	}
	
	function &getData()
	{
		if (!$this->_loadData())
		{
			$this->_initData();	
		}

		return $this->_data;		
	}
	
	function save($data)
	{
		$row =& $this->getTable();
		
		// Bind the form fields to the table
		if (!$row->bind($data)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		$timestamp = JFactory::getDate();
		$user =& JFactory::getUser();
		
		$row->modified = $timestamp->toMySQL();
		$row->modified_by = $user->id;		
		
		if (!$row->check()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the table to the database
		if (!$row->store()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return true;
	}
	
	function store()
	{
		$row =& $this->getTable();
		
		// Bind the form fields to the table
		if (!$row->bind($this->_data)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		if (!$row->check()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the table to the database
		if (!$row->store()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		return true;
	}
	
	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		if (count($cids))
		{			
			$idList = 'id=' . implode(' OR id=', $cids);
			$this->_db->setQuery("DELETE FROM #__f2c_translation WHERE ($idList)");
			
			if(!$this->_db->query())
			{
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		
			$cache = &JFactory::getCache('com_form2content'); 
			$cache->clean(); 
		}
		
		return true;
	}	
	
	function display()
	{
	}	

	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = "SELECT * FROM " . $this->_db->nameQuote('#__f2c_translation') . " WHERE " . $this->_db->nameQuote('id') . " = " . (int)$this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean)$this->_data;
		}
		return true;
	}

	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$form = new stdClass();
			$form->id						= 0;
			$form->language_id				= null;
			$form->reference_id				= JRequest::getInt('reference_id');;
			$form->title_translation		= null;
			$form->description_translation	= null;
			$form->modified					= null;
			$form->modified_by				= null;
			$this->_data					= $form;
			return (boolean) $this->_data;		
		}
		return true;
	}
}
?>