<?php
defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class Form2ContentModelTranslations extends JModel
{
	var $_data = null;
	var $_pagination = null;
	var $_total = null;

	function __construct()
	{
		parent::__construct();
		
		$app 		=& JFactory::getApplication();
		$option 	= JRequest::getCmd('option');		
		$limit 		= $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
		$limitstart = $app->getUserStateFromRequest($option.'.translations.limitstart', 'limitstart', 0, 'int');
		
		// In case limit has been changed, adjust it
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);		
	}

	function getData()
	{
		if(empty($this->_data))
		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}

		return $this->_data;
	}
	
	function getPagination()
	{
		if(empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
		}
		
		return $this->_pagination;
	}
	
	function getTotal()
	{		
		if(empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);			
		}
		
		return $this->_total;		
	}	
	
	function _buildQuery()
	{
		$where				= $this->_buildContentWhere();
		$orderby			= $this->_buildContentOrderBy();
		$languageid 	 	= JRequest::getVar('filter_languageid', '-1');
		$numLanguages 		= count(JLanguageHelper::createLanguageList(''));
		$langRestriction 	= '';
		
		if($languageid != '' && $languageid != -1)
		{
			$langRestriction = ' AND (t.language_id = \'' . $languageid . '\' OR t.language_id IS NULL) ';	
		}
		
		$query = "SELECT f.id as fieldid, f.title as fieldtitle, p.title as projecttitle, t.id, t.language_id, t.title_translation, t.modified, u.name AS modifier, '' as language "
				. "FROM #__f2c_projectfields f "
				. "INNER JOIN #__f2c_project p on f.projectid = p.id "
				. "INNER JOIN #__f2c_translation t on f.id = t.reference_id " . $langRestriction
				. "LEFT JOIN #__users AS u ON u.id = t.modified_by "
				. $where
				. " UNION ALL "
				. "SELECT f.id as fieldid, f.title as fieldtitle, p.title as projecttitle, null, null, null, null, '' AS modifier, '' as language "
				. "FROM #__f2c_projectfields f "
				. "INNER JOIN #__f2c_project p on f.projectid = p.id "
				. $where;
				
				if(strstr($where, ' WHERE'))
				{
					if($languageid != '' && $languageid != -1)
					{
						$query .= " AND f.id NOT IN (SELECT reference_id FROM #__f2c_translation WHERE language_id = '" . $languageid . "') ";
					}
					else
					{
						$query .= " AND f.id NOT IN (SELECT reference_id FROM #__f2c_translation GROUP BY reference_id HAVING count(reference_id) > " . ($numLanguages- 1) . ") ";
					}
				}
				else
				{
					if($languageid != '' && $languageid != -1)
					{
						$query .= " WHERE f.id NOT IN (SELECT reference_id FROM #__f2c_translation WHERE language_id = '" . $languageid . "') ";
					}
					else
					{
						$query .= " WHERE f.id NOT IN (SELECT reference_id FROM #__f2c_translation GROUP BY reference_id HAVING count(reference_id) > " . ($numLanguages- 1) . ") ";						
					}					 
				}
				
				$query .= $orderby;
				
		return $query;
	}
	
	function _buildContentWhere()
	{
		$app 				=& JFactory::getApplication();
		$option 			= JRequest::getCmd('option');		
		$db					=& JFactory::getDBO();
		$search				= $app->getUserStateFromRequest($option.'searchtranslations', 'search', '', 'string');
		$search				= JString::strtolower($search);
		$languageid 		= JRequest::getVar('filter_languageid', '-1');
		$projectid 			= JRequest::getInt('filter_projectid', '-1');		

		$where = array();

		if($projectid != -1)
		{
			$where[] = 'p.id = ' . $projectid;		
		}

		if($languageid == 'NULL')
		{
			$where[] = 't.language_id IS NULL';
		}

		if ($search) 
		{
			$where[] = 'LOWER(f.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}

		$where = (count($where) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	
	}
	
	function _buildContentOrderBy()
	{
		return ' ORDER BY fieldtitle';
	}		
}
?>
