﻿<?php
class TableProjectField extends JTable
{
	/** @var int Primary key **/
	var $id = null;	
	/** @var int Project Id **/
	var $projectid = null;	
	/** @var string Field name **/
	var $fieldname = null;
	/** @var string Title **/
	var $title = null;
	/** @var string Description **/
	var $description = null;
	/** @var int Field type Id **/
	var $fieldtypeid = 0;
	/** @var string Settings **/
	var $settings = null;	
	/** @var int Ordering **/
	var $ordering = null;	
	/** @var boolean Front visible **/
	var $frontvisible = 1;	
	
	/**
	 * Constructor
	 *
	 * @param database Database object
	 */
	function __construct(&$db)
	{
		parent::__construct('#__f2c_projectfields', 'id', $db);
	}
	 
	/**
	 * Validation
	 *
	 * @return boolean True if buffer valid
	 */
	function check()
	{
		if (trim($this->fieldname) == '') 
		{
			$this->setError(JText::_('ERROR_PROJECTFIELD_FIELDNAME_EMPTY'));
			return false;
		}
		
		if(!preg_match('/^[a-zA-Z0-9_]+$/', $this->fieldname))
		{
			$this->setError(JText::_('ERROR_PROJECTFIELD_FIELDNAME_INVALID_CHARS'));
			return false;			
		}

		$compareId = ($this->id) ? $this->id : -1;
						
		$db	= &JFactory::getDBO();
		
		// check unique for project.....
		$db->setQuery("SELECT COUNT(*) FROM #__f2c_projectfields "
					. "WHERE projectid=$this->projectid AND "
					. "fieldname = '$this->fieldname' AND "
					. "id <> $compareId");
							
		if($db->loadResult())
		{
			$this->setError(JText::_('ERROR_PROJECTFIELD_FIELDNAME_NOT_UNIQUE'));
			return false;						
		}									

		return true;
	}
}

?>