<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'configuration.php');
require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');

jimport('joomla.application.component.view');

class Form2ContentViewConfiguration extends JView
{
	function display($tpl = null)
	{
		$config 				= new F2CConfig();
		$recaptcha_public_key	= '';
		$recaptcha_private_key	= '';
		$autosync_article_order	= 0;
		
		JToolBarHelper::title(JText::_('FORM2CONTENT') . ' - ' . JText::_('Configuration'), 'config.png');
		JToolBarHelper::custom('syncorder', 'syncorder', 'syncorder', JText::_('SYNC_ORDER'), false);				
		JToolBarHelper::save();
		JToolBarHelper::cancel();
		
		$yesno[] = JHTML::_('select.option', '1', JText::_('COM_F2C_YES'), 'value', 'text');
		$yesno[] = JHTML::_('select.option', '0', JText::_('COM_F2C_NO'), 'value', 'text');
		$lists['generate_sample_template'] = JHTML::_('select.genericlist',  $yesno, 'generate_sample_template', 'class="inputbox" size="1"', 'value', 'text', $config->generate_sample_template);
		
		$itemEdit[] = JHTML::_('select.option', '0', JText::_('ALL_ITEMS'), 'value', 'text');
		$itemEdit[] = JHTML::_('select.option', '1', JText::_('OWN_ITEMS_ONLY'), 'value', 'text');
		$itemEdit[] = JHTML::_('select.option', '2', JText::_('USERS_OWN_ITEMS_ADMINS_ALL'), 'value', 'text');
		$lists['edit_items_level'] = JHTML::_('select.genericlist',  $itemEdit, 'edit_items_level', 'class="inputbox" size="1"', 'value', 'text', $config->edit_items_level);
		
		$dateFormatList[] = JHTML::_('select.option', '%d-%m-%Y', '%d-%m-%Y', 'value', 'text');
		$dateFormatList[] = JHTML::_('select.option', '%m-%d-%Y', '%m-%d-%Y', 'value', 'text');
		$dateFormatList[] = JHTML::_('select.option', '%Y-%m-%d', '%Y-%m-%d', 'value', 'text');
		$lists['dateFormatList'] = JHTML::_('select.genericlist',  $dateFormatList, 'date_format', 'class="inputbox" size="1"', 'value', 'text', $config->date_format);

		if(array_key_exists('autosync_article_order', get_object_vars($config)))
		{
			$autosync_article_order = $config->autosync_article_order;
		}

		if(array_key_exists('recaptcha_private_key', get_object_vars($config)))
		{
			$recaptcha_private_key = $config->recaptcha_private_key;
		}

		if(array_key_exists('recaptcha_public_key', get_object_vars($config)))
		{
			$recaptcha_public_key = $config->recaptcha_public_key;
		}
		
		$config->default_thumbnail_width = (array_key_exists('default_thumbnail_width',get_object_vars($config)) && (int)$config->default_thumbnail_width) ? (int)$config->default_thumbnail_width : F2C_DEFAULT_THUMBNAIL_WIDTH;
		$config->default_thumbnail_height = (array_key_exists('default_thumbnail_height',get_object_vars($config)) && (int)$config->default_thumbnail_height) ? (int)$config->default_thumbnail_height : F2C_DEFAULT_THUMBNAIL_HEIGHT;
		$config->front_end_publish = (array_key_exists('front_end_publish',get_object_vars($config))) ? (int)$config->front_end_publish : 1;
		
		$lists['autosync_article_order'] = JHTML::_('select.genericlist',  $yesno, 'autosync_article_order', 'class="inputbox" size="1"', 'value', 'text', $autosync_article_order);
		
		$frontEndPublish[] = JHTML::_('select.option', '0', JText::_('NO'), 'value', 'text');
		$frontEndPublish[] = JHTML::_('select.option', '1', JText::_('YES').' ('.JText::_('ALL_USERS').')', 'value', 'text');
		$frontEndPublish[] = JHTML::_('select.option', '2', JText::_('YES').' ('.JText::_('ADMINS_ONLY').')', 'value', 'text');
		$lists['front_end_publish'] = JHTML::_('select.genericlist',  $frontEndPublish, 'front_end_publish', 'class="inputbox" size="1"', 'value', 'text', $config->front_end_publish);
		
		
		
		//$lists['front_end_publish'] = JHTML::_('select.booleanlist', 'front_end_publish', '', $config->front_end_publish);
		
		$this->assignRef('lists', $lists);
		$this->assignRef('config', $config);
		$this->assignRef('recaptcha_private_key', $recaptcha_private_key);
		$this->assignRef('recaptcha_public_key', $recaptcha_public_key);
		
		parent::display($tpl);
	}
}
?>