<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'configuration.php');
require_once(JPATH_COMPONENT_SITE.DS.'renderer.form2content.php');

jimport('joomla.application.component.view');
jimport('joomla.language.helper');

class Form2ContentViewForm extends JView
{
	function display($tpl = null)
	{
		$config 		= new F2CConfig();
		$dataObject 	=& $this->get('Data');
		$editor 		=& JFactory::getEditor();
		$isNew			= ($dataObject->id < 1);
		$lists 			= array();
		$db 			=& JFactory::getDBO();		
		$languageId 	= JLanguageHelper::detectLanguage();
		$nullDate 		= $db->getNullDate();
		$jsValidation	= '';
		$jsFieldVal		= '';
		$jsEditorInit	= '';
		$jsEditorSave 	= '';
		
		if(!$languageId)
		{
			$languageId = -1;
		}
		
		$db->setQuery('SELECT * FROM #__f2c_project WHERE id=' . (int)$dataObject->projectid);
		$contentType = $db->loadObject();
		$contentTypeSettings = ($contentType->settings) ? unserialize($contentType->settings) : new F2C_ContentTypeSettings();
		
		$text = $isNew ? JText::_('New') : JText::_('Edit');		
		$formTitle = ($contentTypeSettings->article_caption) ? $contentTypeSettings->article_caption : JText::_('FORM');
		
		JToolBarHelper::title($formTitle . ': <small><small>[ ' . $text.' ]</small></small>');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		
		if ($isNew)  
		{
			JToolBarHelper::cancel();
		} 
		else 
		{
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel('cancel', 'Close');
		}
		
 		if($dataObject->created)
		{
	  		if($dataObject->created == $db->getNullDate())
			{
				$dataObject->created = '';
			}
			else
			{
				$dataObject->created = JHTML::_('date', $dataObject->created, $config->date_format . ' %H:%M:%S');
			}
		}
		
  		if($dataObject->publish_up == $db->getNullDate())
		{
			$dataObject->publish_up = '';
		}
		else
		{
			$dataObject->publish_up = JHTML::_('date', $dataObject->publish_up, $config->date_format . ' %H:%M:%S');
		}

 		if($dataObject->publish_down && $dataObject->publish_down != $db->getNullDate())
		{
			$dataObject->publish_down = JHTML::_('date', $dataObject->publish_down, $config->date_format . ' %H:%M:%S');
		}
		else
		{
			$dataObject->publish_down = JText::_('NEVER');
		}
		
		// Load field definitions for the current project		
	 	$db->setQuery("SELECT f.* " 
				  	. "FROM #__f2c_projectfields f "
				  	. "WHERE f.projectid =" . $dataObject->projectid
				  	. " ORDER BY f.ordering ASC");
				  	
	  	$fields = $db->loadObjectList();	
			
		// Load translated fields	
	 	$db->setQuery("SELECT f.id, t.title_translation, t.description_translation " 
				  	. "FROM #__f2c_projectfields f "
				  	. "INNER JOIN #__f2c_translation t ON f.id = t.reference_id and t.language_id = '$languageId' "
				  	. "WHERE f.projectid =" . $dataObject->projectid);
			
		$translatedFields = $db->loadObjectList('id');
		
		$jsValidation .= 'var arrValidation=new Array;';		
		$validationCounter = 0;

		$jsEditorInit .= 'function F2C_GetEditorText(id) { switch(id) { ';
		
		foreach($fields as $field)
		{
			switch($field->fieldtypeid)
			{
				case F2C_FIELDTYPE_MULTILINEEDITOR:
					$elmEditor = 't' . $field->id; // elementname
					$jsEditorInit .= "case '".$elmEditor."': return ".$editor->getContent($elmEditor)."\n";
					$jsEditorSave .= $editor->save($elmEditor);
					break;
				case F2C_FIELDTYPE_FILE:
					$jsFieldVal .= F2C_Validation::createFileUploadClientSideScript($field);
					break;
			}
			
			if($field->settings)
			{
				$fieldSettings = unserialize($field->settings);
				
				if($fieldSettings->required)
				{
					$requiredMsg = ($fieldSettings->errorMessageRequired) ? $fieldSettings->errorMessageRequired : sprintf(JText::_('ERROR_FIELD_X_REQUIRED'), $field->title);
					$jsValidation .= 'arrValidation['.$validationCounter++.']=new Array('.$field->id.','.$field->fieldtypeid.',\''.$requiredMsg.'\');';
				}
			}
		}
		
		$jsEditorInit .= '}}';
		
		// load field content
		$db->setQuery("SELECT fc.id, fc.fieldid, fc.attribute, fc.content, pf.fieldtypeid "
					. "FROM #__f2c_form f "
					. "INNER JOIN #__f2c_fieldcontent fc ON f.id = fc.formid "
					. "INNER JOIN #__f2c_projectfields pf ON fc.fieldid = pf.id "
					. "WHERE f.id = $dataObject->id");
							
		$fieldValuesObjectList = $db->loadObjectList();
		
		$fieldValues = array();
		
		// Group data by field id
		foreach($fieldValuesObjectList as $fieldValueObject)
		{
			if(!array_key_exists($fieldValueObject->fieldid, $fieldValues))
			{
				$fieldValues[$fieldValueObject->fieldid] = array();
				
				if($fieldValueObject->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
				{
					$fieldValues[$fieldValueObject->fieldid]['VALUE'] = array();
				}
			}
			
			if($fieldValueObject->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
			{
				$fieldValues[$fieldValueObject->fieldid][$fieldValueObject->attribute][] = $fieldValueObject;
			}
			else
			{						
				$fieldValues[$fieldValueObject->fieldid][$fieldValueObject->attribute] = $fieldValueObject;
			}
		}
		
		if($contentType->catid == -2)
		{
			// only show category
			$lists['catid'] = getCategoryList($contentType->sectionid, $dataObject->catid);
			$lists['sectionid'] = HtmlHelper::hiddenField('sectionid', $contentType->sectionid);
			// get the category title
			$db->setQuery('SELECT title FROM #__sections WHERE id = '.(int)$contentType->sectionid);
			$lists['sectionid'] .= HtmlHelper::stringHTMLSafe($db->loadResult());
		}
		else
		{
			$javascript = "onchange=\"changeDynaList( 'catid', sectioncategories, document.adminForm.sectionid.options[document.adminForm.sectionid.selectedIndex].value, 0, 0);\"";		
			$lists = getSectionCategoryList($dataObject->sectionid, $dataObject->catid, $javascript);
		}
		
		$lists['created_by'] 	= JHTML::_('select.genericlist', getAuthorList(), 'created_by', 'class="inputbox" size="1"', 'created_by', 'name', $dataObject->created_by);
		$lists['frontpage'] 	= JHTML::_('select.booleanlist', 'frontpage', '', $dataObject->frontpage);
		$lists['state'] 		= JHTML::_('select.booleanlist', 'state', '', $dataObject->state);
		$lists['access'] 		= JHTML::_('select.genericlist', getAccessLevelList(), 'access', 'class="inputbox" size="1"', 'value', 'text', $dataObject->access);
		
		$jAdvancedArticleParms = new JParameter('', JPATH_BASE.DS.'components'.DS.'com_content'.DS.'models'.DS.'article.xml');
		
		// Advanced parmaters
		$jAdvancedArticleParms->loadINI($dataObject->attribs);

		// Metadata Group
		$jAdvancedArticleParms->set('description', $dataObject->metadesc);
		$jAdvancedArticleParms->set('keywords', $dataObject->metakey);
		$jAdvancedArticleParms->loadINI($dataObject->metadata);
		
		$jFormRow = & JTable::getInstance('content');
		$jFormRow->load((int)$dataObject->reference_id);
			
		if(!(int)$dataObject->reference_id)
		{
			$jFormRow->created 	= $nullDate;
			$jFormRow->modified = $nullDate;
			$jFormRow->version 	= 0;
			$jFormRow->state	= $dataObject->state;
		}
		
		$renderer = new F2C_Renderer($config, $dataObject->id, $translatedFields, $contentTypeSettings);
		
		$this->assignRef('lists', $lists);
		$this->assignRef('form', $dataObject);
		$this->assignRef('contentType', $contentType);
		$this->assignRef('contentTypeSettings', $contentTypeSettings);
		$this->assignRef('isNew', $isNew);
		$this->assignRef('fields', $fields);
		$this->assignRef('fieldValues', $fieldValues);
		$this->assignRef('jAdvancedArticleParms', $jAdvancedArticleParms);
		$this->assignRef('jFormRow', $jFormRow);
		$this->assignRef('renderer', $renderer);		
		$this->assignRef('jsValidation', $jsValidation);
		$this->assignRef('jsFieldVal', $jsFieldVal);				
		$this->assignRef('jsEditorInit', $jsEditorInit);
		$this->assignRef('jsEditorSave', $jsEditorSave);
						
		parent::display($tpl);		
	}
}
?>