﻿<?php
defined('_JEXEC') or die('Restricted acccess');

jimport('joomla.application.component.view');

require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'class.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'configuration.php');

class Form2ContentViewProjectField extends JView
{
	function display($tpl = null)
	{
		$db 		=& JFactory::getDBO();				
		$config 	= new F2CConfig();
		$dataObject =& $this->get('Data');
		$isNew		= ($dataObject->id < 1);
		$text 		= $isNew ? JText::_('New') : JText::_('Edit');
		
		if($isNew)
		{
			$dataObject->projectid = JRequest::getInt('projectid', 0);
		}
		
		JToolBarHelper::title(JText::_('PROJECTFIELD').': <small><small>[ ' . $text.' ]</small></small>');
		JToolBarHelper::save();
		
		if ($isNew)  
		{
			JToolBarHelper::cancel();
		} 
		else 
		{
			// for existing items the button is renamed `close`
			JToolBarHelper::cancel('cancel', 'Close');
		}

		$query = 'SELECT * FROM #__f2c_fieldtype ORDER BY description ASC';
		$db->setQuery($query);
		$lists['fieldtypeid'] = $db->loadObjectList();		

		// Prepare field settings
		$fieldTypeList 					= array();
		$fieldValueList 				= array();
		$fieldSettings 					= null;
		$singleSelectList 				= '';
		$multiSelectList 				= '';
		$maxImageWidth 					= '';
		$maxImageHeight 				= '';
		$imageoutputmode 				= 1;
		$linkoutputmode 				= 1;
		$selectOptionsdisplayMode 		= 0;
		$displayListOrdered 			= 1;		
		$singleLineTextSettings			= new F2C_SingleLineTextSettings();
		$multiLineTextSettings 			= new F2C_MultiLineTextSettings();
		$multiLineEditorSettings		= new F2C_MultiLineEditorSettings();
		$checkBoxSettings 				= new F2C_CheckBoxSettings();
		$singleSelectSettings 			= new F2C_SingleSelectSettings();
		$imageSettings 					= new F2C_ImageSettings();			
		$iFrameSettings					= new F2C_IFrameSettings();
		$emailSettings					= new F2C_EmailSettings();
		$multiSelectSettings 			= new F2C_MultiSelectSettings();
		$hyperLinkSettings				= new F2C_LinkSettings();
		$infoTextSettings				= new F2C_InfoTextSettings();
		$datePickerSettings				= new F2C_DatePickerSettings();
		$displayListSettings			= new F2C_DisplayListSettings();		
		$fileSettings 					= new F2C_FileSettings();			
		$databaseLookupSettings 		= new F2C_DatabaseLookupSettings();
		$geoCoderSettings 				= new F2C_GeoCoderSettings();
		$databaseLookupMultiSettings 	= new F2C_DatabaseLookupMultiSettings();
		$fieldRequired 				= 0;
		$fieldRequiredErrorMessage 	= '';

		if($dataObject->settings)
		{
			switch ($dataObject->fieldtypeid) 
			{	
				case F2C_FIELDTYPE_SINGLELINE:
					$singleLineTextSettings = unserialize($dataObject->settings);
					$fieldRequired = $singleLineTextSettings->required;
					$fieldRequiredErrorMessage = $singleLineTextSettings->errorMessageRequired;				
					break;
								
				case F2C_FIELDTYPE_MULTILINETEXT:
					$multiLineTextSettings = unserialize($dataObject->settings);
					$fieldRequired = $multiLineTextSettings->required;
					$fieldRequiredErrorMessage = $multiLineTextSettings->errorMessageRequired;				
					break;
					
				case F2C_FIELDTYPE_MULTILINEEDITOR:
					$multiLineEditorSettings = unserialize($dataObject->settings);
					$fieldRequired = $multiLineEditorSettings->required;
					$fieldRequiredErrorMessage = $multiLineEditorSettings->errorMessageRequired;				
					break;
				
				case F2C_FIELDTYPE_CHECKBOX:
					$checkBoxSettings = unserialize($dataObject->settings);
					$fieldRequired = $checkBoxSettings->required;
					$fieldRequiredErrorMessage = $checkBoxSettings->errorMessageRequired;				
					break;
				
				case F2C_FIELDTYPE_SINGLESELECTLIST:
					$singleSelectSettings = unserialize($dataObject->settings);	
					$fieldRequired = $singleSelectSettings->required;
					$fieldRequiredErrorMessage = $singleSelectSettings->errorMessageRequired;				
					break;
					
				case F2C_FIELDTYPE_IMAGE:
					$imageSettings = unserialize($dataObject->settings);
					$maxImageWidth = $imageSettings->width != 10000 ? $imageSettings->width : '';
					$maxImageHeight = $imageSettings->height != 10000 ? $imageSettings->height : '';
					$imageoutputmode = $imageSettings->imageOutputMode;
					
					$defaultThumbnailWidth = (array_key_exists('default_thumbnail_width',get_object_vars($config)) && (int)$config->default_thumbnail_width) ? (int)$config->default_thumbnail_width : F2C_DEFAULT_THUMBNAIL_WIDTH;
					$defaultThumbnailHeight = (array_key_exists('default_thumbnail_height',get_object_vars($config)) && (int)$config->default_thumbnail_height) ? (int)$config->default_thumbnail_height : F2C_DEFAULT_THUMBNAIL_HEIGHT;
					$imageSettings->thumbnailWidth 	= (int)$imageSettings->thumbnailWidth ? (int)$imageSettings->thumbnailWidth : $defaultThumbnailWidth;
					$imageSettings->thumbnailHeight 	= (int)$imageSettings->thumbnailHeight ? (int)$imageSettings->thumbnailHeight : $defaultThumbnailHeight;
					
					$fieldRequired = $imageSettings->required;
					$fieldRequiredErrorMessage = $imageSettings->errorMessageRequired;				
					break;
					
				case F2C_FIELDTYPE_IFRAME:
					$iFrameSettings = unserialize($dataObject->settings);	
					$fieldRequired = $iFrameSettings->required;
					$fieldRequiredErrorMessage = $iFrameSettings->errorMessageRequired;				
					break;
				
				case F2C_FIELDTYPE_EMAIL:
					$emailSettings = unserialize($dataObject->settings);	
					$fieldRequired = $emailSettings->required;
					$fieldRequiredErrorMessage = $emailSettings->errorMessageRequired;				
					break;
					
				case F2C_FIELDTYPE_HYPERLINK:
					$hyperLinkSettings = unserialize($dataObject->settings);
					$linkoutputmode = $hyperLinkSettings->outputMode;
					$fieldRequired = $hyperLinkSettings->required;
					$fieldRequiredErrorMessage = $hyperLinkSettings->errorMessageRequired;				
					break;			
								
				case F2C_FIELDTYPE_MULTISELECTLIST:
					$multiSelectSettings = ($dataObject->settings) ? unserialize($dataObject->settings) : new F2C_MultiSelectSettings();
					$fieldRequired = $multiSelectSettings->required;
					$fieldRequiredErrorMessage = $multiSelectSettings->errorMessageRequired;				
					break;		
				
				case F2C_FIELDTYPE_INFOTEXT:
					$infoTextSettings = ($dataObject->settings) ? unserialize($dataObject->settings) : new F2C_InfoTextSettings();
	//				$infoText = $infoTextSettings->text;
					$fieldRequired = $infoTextSettings->required;
					$fieldRequiredErrorMessage = $infoTextSettings->errorMessageRequired;				
					break;
				
				case F2C_FIELDTYPE_DATEPICKER:
					$datePickerSettings = unserialize($dataObject->settings);	
					$fieldRequired = $datePickerSettings->required;
					$fieldRequiredErrorMessage = $datePickerSettings->errorMessageRequired;				
					break;
				
				case F2C_FIELDTYPE_DISPLAYLIST:
					$displayListSettings = ($dataObject->settings) ? unserialize($dataObject->settings) : new F2C_DisplayListSettings();
					$displayListOrdered = $displayListSettings->ordered;
					$fieldRequired = $displayListSettings->required;
					$fieldRequiredErrorMessage = $displayListSettings->errorMessageRequired;				
					break;	
																		
				case F2C_FIELDTYPE_FILE:
					$fileSettings = ($dataObject->settings) ? unserialize($dataObject->settings) : new F2C_FileSettings();
					$fieldRequired = $fileSettings->required;
					$fieldRequiredErrorMessage = $fileSettings->errorMessageRequired;				
					break;
					
				case F2C_FIELDTYPE_DATABASE_LOOKUP:
					$databaseLookupSettings = ($dataObject->settings) ? unserialize($dataObject->settings) : new F2C_DatabaseLookupSettings();
					$fieldRequired = $databaseLookupSettings->required;
					$fieldRequiredErrorMessage = $databaseLookupSettings->errorMessageRequired;				
					break;
					
				case F2C_FIELDTYPE_GEOCODER:
					$geoCoderSettings = ($dataObject->settings) ? unserialize($dataObject->settings) : new F2C_GeoCoderSettings();
					$fieldRequired = $geoCoderSettings->required;
					$fieldRequiredErrorMessage = $geoCoderSettings->errorMessageRequired;
					break;

				case F2C_FIELDTYPE_DB_LOOKUP_MULTI:
					$databaseLookupMultiSettings = ($dataObject->settings) ? unserialize($dataObject->settings) : new F2C_DatabaseLookupMultiSettings();
					$displayListOrdered = $displayListSettings->ordered;
					$fieldRequired = $databaseLookupMultiSettings->required;
					$fieldRequiredErrorMessage = $databaseLookupMultiSettings->errorMessageRequired;				
					break;	
					
			}
		}
				
		$yesno[] = JHTML::_('select.option', '1', JText::_('COM_F2C_YES'), 'value', 'text');
		$yesno[] = JHTML::_('select.option', '0', JText::_('COM_F2C_NO'), 'value', 'text');		
		$lists['frontvisible'] = JHTML::_('select.genericlist',  $yesno, 'frontvisible', 'class="inputbox" size="1"', 'value', 'text', $dataObject->frontvisible);
		
		$displayModeSelectList[] = JHTML::_('select.option', '0', JText::_('DROPDOWNLIST'), 'id', 'description');
		$displayModeSelectList[] = JHTML::_('select.option', '1', JText::_('RADIOBUTTONLIST'), 'id', 'description');							 
		$lists['singleSelectDisplayMode'] = JHTML::_('select.genericlist',  $displayModeSelectList, 'singleSelectDisplayMode', 'class="inputbox" size="1"', 'id', 'description', $singleSelectSettings->displayMode);

		$dblDisplayMode[] = JHTML::_('select.option', '0', JText::_('DROPDOWNLIST'), 'id', 'description');
		$dblDisplayMode[] = JHTML::_('select.option', '1', JText::_('RADIOBUTTONLIST'), 'id', 'description');							 
		$lists['dbl_display_mode'] = JHTML::_('select.genericlist',  $dblDisplayMode, 'dbl_display_mode', 'class="inputbox" size="1"', 'id', 'description', $databaseLookupSettings->displayMode);

		$imageOutputModeList[] = JHTML::_('select.option', '0', JText::_('RAW_IMAGE_URL'), 'value', 'text');
		$imageOutputModeList[] = JHTML::_('select.option', '1', JText::_('HTML_IMAGE_TAG'), 'value', 'text');
		$lists['imageOutputMode'] = JHTML::_('select.genericlist',  $imageOutputModeList, 'imageOutputMode', 'class="inputbox" size="1"', 'value', 'text', $imageoutputmode);
		
		$lists['eml_show_display_as'] = JHTML::_('select.genericlist',  $yesno, 'eml_show_display_as', 'class="inputbox" size="1"', 'value', 'text', $emailSettings->showDisplayAs);
		
		$lists['imageShowAltTag'] = JHTML::_('select.genericlist',  $yesno, 'imageShowAltTag', 'class="inputbox" size="1"', 'value', 'text', $imageSettings->showAltTag);
		$lists['imageShowTitleTag'] = JHTML::_('select.genericlist',  $yesno, 'imageShowTitleTag', 'class="inputbox" size="1"', 'value', 'text', $imageSettings->showTitleTag);
		
		$linkOutputModeList[] = JHTML::_('select.option', '0', JText::_('RAW_LINK_URL'), 'value', 'text');
		$linkOutputModeList[] = JHTML::_('select.option', '1', JText::_('HTML_LINK_TAG'), 'value', 'text');
		$lists['linkOutputMode'] = JHTML::_('select.genericlist',  $linkOutputModeList, 'linkOutputMode', 'class="inputbox" size="1"', 'value', 'text', $linkoutputmode);
		$lists['lnk_show_display_as'] = JHTML::_('select.genericlist',  $yesno, 'lnk_show_display_as', 'class="inputbox" size="1"', 'value', 'text', $hyperLinkSettings->showDisplayAs);
		$lists['lnk_show_title'] = JHTML::_('select.genericlist',  $yesno, 'lnk_show_title', 'class="inputbox" size="1"', 'value', 'text', $hyperLinkSettings->showTitle);
		$lists['lnk_show_target'] = JHTML::_('select.genericlist',  $yesno, 'lnk_show_target', 'class="inputbox" size="1"', 'value', 'text', $hyperLinkSettings->showTarget);
				
		$displayListOrderedList[] = JHTML::_('select.option', '1', JText::_('ORDERED_LIST'), 'value', 'text');
		$displayListOrderedList[] = JHTML::_('select.option', '0', JText::_('UNORDERED_LIST'), 'value', 'text');		
		$lists['displayListOrderedList'] = JHTML::_('select.genericlist',  $displayListOrderedList, 'displayListOrdered', 'class="inputbox" size="1"', 'value', 'text', $displayListOrdered);
		
		$fileOutputModeList[] = JHTML::_('select.option', '0', JText::_('RAW_LINK_URL'), 'value', 'text');
		$fileOutputModeList[] = JHTML::_('select.option', '1', JText::_('HTML_LINK_TAG'), 'value', 'text');
		$lists['fileOutputMode'] = JHTML::_('select.genericlist',  $fileOutputModeList, 'fileOutputMode', 'class="inputbox" size="1"', 'value', 'text', $fileSettings->outputMode);
		
		// Geocoder setting
		$googleMapTypes[] = JHTML::_('select.option', 'ROADMAP', JText::_('GOOGLE_MAP_TYPE_ROADMAP'), 'value', 'text');
		$googleMapTypes[] = JHTML::_('select.option', 'SATELLITE', JText::_('GOOGLE_MAP_TYPE_SATELLITE'), 'value', 'text');
		$googleMapTypes[] = JHTML::_('select.option', 'HYBRID', JText::_('GOOGLE_MAP_TYPE_HYBRID'), 'value', 'text');
		$googleMapTypes[] = JHTML::_('select.option', 'TERRAIN', JText::_('GOOGLE_MAP_TYPE_TERRAIN'), 'value', 'text');

		$lists['gcd_show_map'] = JHTML::_('select.genericlist',  $yesno, 'gcd_show_map', 'class="inputbox" size="1"', 'value', 'text', $geoCoderSettings->showMap);		
		$lists['gcd_map_zoom'] = JHTML::_('select.integerlist', 1, 19, 1, 'gcd_map_zoom', 'class="inputbox" size="1"', $geoCoderSettings->mapZoom);
		$lists['gcd_map_type'] = JHTML::_('select.genericlist',  $googleMapTypes, 'gcd_map_type', 'class="inputbox" size="1"', 'value', 'text', $geoCoderSettings->mapType);		
		
		$databaseLookupMultiOrderedList[] = JHTML::_('select.option', '1', JText::_('ORDERED_LIST'), 'value', 'text');
		$databaseLookupMultiOrderedList[] = JHTML::_('select.option', '0', JText::_('UNORDERED_LIST'), 'value', 'text');		
		$lists['databaseLookupMultiOrderedList'] = JHTML::_('select.genericlist',  $databaseLookupMultiOrderedList, 'databaseLookupMultiOrderedList', 'class="inputbox" size="1"', 'value', 'text', $databaseLookupMultiOrderedList);
		
		$lists['required'] = JHTML::_('select.genericlist',  $yesno, 'required', 'class="inputbox" size="1"', 'value', 'text', $fieldRequired);
		
		if($multiLineTextSettings->maxNumChars == 0)
		{
			$multiLineTextSettings->maxNumChars = '';
		}
		
//		$this->assignRef('infoText', $infoText);
		
		$this->assignRef('singleLineTextSettings', $singleLineTextSettings);
		$this->assignRef('multiLineTextSettings', $multiLineTextSettings);
		$this->assignRef('multiLineEditorSettings', $multiLineEditorSettings);
		$this->assignRef('checkBoxSettings', $checkBoxSettings);
		$this->assignRef('singleSelectSettings', $singleSelectSettings);
		$this->assignRef('imageSettings', $imageSettings);
		$this->assignRef('iFrameSettings', $iFrameSettings);
		$this->assignRef('emailSettings', $emailSettings);
		$this->assignRef('multiSelectSettings', $multiSelectSettings);
		$this->assignRef('hyperLinkSettings', $hyperLinkSettings);
		$this->assignRef('infoTextSettings', $infoTextSettings);
		$this->assignRef('datePickerSettings', $datePickerSettings);
		$this->assignRef('displayListSettings', $displayListSettings);
		$this->assignRef('fileSettings', $fileSettings);
		$this->assignRef('databaseLookupSettings', $databaseLookupSettings);
		$this->assignRef('geoCoderSettings', $geoCoderSettings);		
		$this->assignRef('databaseLookupMultiSettings', $databaseLookupMultiSettings);
		
		$this->assignRef('maxImageWidth', $maxImageWidth);
		$this->assignRef('maxImageHeight', $maxImageHeight);
//		$this->assignRef('fieldSettings', $fieldSettings);
		$this->assignRef('lists', $lists);
		$this->assignRef('projectfield', $dataObject);
		$this->assignRef('isNew', $isNew);
		$this->assignRef('fieldRequiredErrorMessage', $fieldRequiredErrorMessage);
		
		parent::display($tpl);		
	}
}
?>