<?php
defined('_JEXEC') or die('Restricted acccess');

/*
 * Start field settings
 */
class F2C_SingleLineTextSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $size;
	var $maxLength;
	var $attributes;
}

class F2C_MultiLineTextSettings
{
	var $maxNumChars = 0;
	var $required = 0;
	var $errorMessageRequired = '';
	var $numRows = 0;
	var $numCols = 0;
	var $attributes = '';
}

class F2C_MultiLineEditorSettings
{
	var $required = 0;
	var $errorMessageRequired = '';	
	var $numRows = 0;
	var $numCols = 0;
	var $width = 0;
	var $height = 0;
}

class F2C_CheckBoxSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';	
}

class F2C_SingleSelectSettings
{
	var $listOptions;
	var $displayMode = 0;
	var $showEmptyText = false;
	var $emptyText = '';
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';	
}

class F2C_ImageSettings
{
	var $width;
	var $height;	
	var $imageOutputMode;
	var $thumbnailWidth;
	var $thumbnailHeight;
	var $required = 0;
	var $errorMessageRequired = '';
	var $uploadAttributes = '';
	var $deleteAttributes = '';
	var $altValueAttributes = '';
	var $titleAttributes = '';
	var $showAltTag = true;
	var $showTitleTag = true;
}

class F2C_IFrameSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $iFrameAttributes;
	var $widthAttributes;
	var $heightAttributes;
}

class F2C_EmailSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $emailAttributes = '';
	var $displayAsAttributes = '';
	var $showDisplayAs = 1;
}

class F2C_MultiSelectSettings
{
	var $listOptions;
	var $required = 0;
	var $errorMessageRequired = '';	
	var $preListTag = '';
	var $postListTag = '';
	var $preElementTag = '';
	var $postElementTag = ',';
	var $attributes = '';
}

class F2C_LinkSettings
{
	var $outputMode;
	var $required = 0;
	var $errorMessageRequired = '';
	var $linkAttributes = '';
	var $displayAsAttributes = '';
	var $titleAttributes = '';
	var $targetAttributes = '';
	var $showDisplayAs = 1;
	var $showTitle = 1;
	var $showTarget = 1;
}

class F2C_InfoTextSettings
{
	var $text;
	var $required = 0;
	var $errorMessageRequired = '';	
}

class F2C_DatePickerSettings
{
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';
}

class F2C_DisplayListSettings
{
	var $ordered = 1;
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributesTable = '';
	var $attributesTr = '';
	var $attributesTd = '';
	var $attributesTh = '';
	var $attributesItemText = '';
	var $attributesAddButton = '';	
}

class F2C_FileSettings
{
	var $whiteList;
	var $blackList;
	var $outputMode = 0;
	var $required = 0;
	var $errorMessageRequired = '';	
	var $uploadAttributes = '';
	var $deleteAttributes = '';
	var $maxFileSize = -1;
}

class F2C_DatabaseLookupSettings
{
	var $query = '';
	var $showEmptyText = false;
	var $emptyText = '';
	var $displayMode = 0;
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributes = '';	
}

class F2C_GeoCoderSettings
{
	var $showMap = true;
	var $mapWidth = '';
	var $mapHeight = '';
	var $mapLat = '';
	var $mapLon = '';
	var $mapZoom = 3;
	var $mapType = 'ROADMAP';
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributesAddress = '';
	var $attributesLookup = '';
	var $attributesClear = '';
}

class F2C_DatabaseLookupMultiSettings
{
	var $ordered = 1;
	var $required = 0;
	var $errorMessageRequired = '';
	var $attributesTable = '';
	var $attributesTr = '';
	var $attributesTd = '';
	var $attributesTh = '';
	var $attributesItemText = '';
	var $attributesAddButton = '';		
	var $query = '';
	var $showEmptyText = false;
	var $emptyText = '';
	var $attributesSelect = '';		
}

/*
 * End field settings
 */
 
class F2C_IFrame
{
	var $url;
	var $width;
	var $height;
	
	function F2C_IFrame()
	{
	}
}

class F2C_Email
{
	var $email;
	var $display;
	
	function F2C_Email()
	{
	}
}

class F2C_Link
{
	var $url;
	var $display;
	var $title;
	var $target;
	
	function F2C_Link()
	{
	}
}

class F2C_FileUpload
{
	var $filename;
	
	function F2C_FileUpload()
	{
	}

	function GetFileUrl($contentTypeId, $articleId, $fieldId, $relative = false)
	{
		$path = ($relative) ? '' : JURI::root();
		$path.= 'media/com_form2content/documents/c'.$contentTypeId.'/a'.$articleId.'/f'.$fieldId;
		return $path;
	}

	function GetFilesRootPath($relative = false)
	{
		if($relative)
		{
			return 'media'.DS.'com_form2content'.DS.'documents'.DS;
		}
		else
		{
			return JPATH_SITE.DS.'media'.DS.'com_form2content'.DS.'documents'.DS;
		}				
	}
	
	function GetFilesPath($projectId, $formId, $relative = false)
	{
		return Path::Combine(F2C_FileUpload::GetFilesRootPath($relative), 'c'.$projectId.DS.'a'.$formId);
	}

	function GetFilePath($contentTypeId, $articleId, $fieldId, $relative = false)
	{
		return Path::Combine(F2C_FileUpload::GetFilesRootPath($relative), 'c'.$contentTypeId.DS.'a'.$articleId.DS.'f'.$fieldId);
	}

	function GetFilePathFormRoot($contentTypeId, $articleId, $relative = false)
	{
		return Path::Combine(F2C_FileUpload::GetFilesRootPath($relative), 'c'.$contentTypeId.DS.'a'.$articleId);
	}
	
	function DeleteFile($contentTypeId, $ArticleId, $fieldId)
	{
		if($this->filename)
		{
			$file = Path::Combine($this->GetFilePath($contentTypeId, $ArticleId, $fieldId), $this->filename);
		
			if(JFile::exists($file))
			{
				JFile::delete($file);
			}
		}
	}
	
	function deleteFiles($entity, $entityId)
	{
		$db =& JFactory::getDBO(); 

		switch($entity)
		{
			case F2C_ENTITY_CONTENTTYPE:
				recursiveRemoveDirectory(Path::Combine(F2C_FileUpload::GetFilesRootPath(), "c$entityId"));		
				break;
				
			case F2C_ENTITY_ARTICLE:
				$db->setQuery("SELECT frm.projectid FROM #__f2c_form frm WHERE frm.id = $entityId");
				$projectid = $db->loadResult();
				recursiveRemoveDirectory(Path::Combine(F2C_FileUpload::GetFilesRootPath(), "c$projectid/a$entityId"));							
				break;
				
			case F2C_ENTITY_CONTENTTYPEFIELD:
				$sql =	'SELECT pfl.projectid, fct.formid, fct.content  
						 FROM #__f2c_projectfields pfl 
						 INNER JOIN #__f2c_fieldcontent fct ON pfl.id = fct.fieldid 
						 WHERE pfl.fieldtypeid = '. F2C_FIELDTYPE_FILE .' AND pfl.id = ' . (int)$entityId;
						
				$db->setQuery($sql);
				$rows = $db->loadObjectList();
				
				for ($i=0, $n=count($rows); $i < $n; $i++) 
				{
			  		$row = &$rows[$i];
					recursiveRemoveDirectory(Path::Combine(F2C_FileUpload::GetFilesRootPath(), "c$row->projectid/a$row->formid/f$entityId")); 
				}					
				break;
		}	
	}
}

class F2C_Image
{
	var $filename;
	var $alt;
	var $title;
	var $width = -1;
	var $height = -1;
	var $widthThumbnail = -1;
	var $heightThumbnail = -1;
	 
	function F2C_Image()
	{
	}
	
	function GetImagesUrl($projectId, $formId, $relative = false)
	{
		if($relative)
		{
			return "com_form2content/p$projectId/f$formId/" ;
		}
		else
		{
			return JURI::root()."images/stories/com_form2content/p$projectId/f$formId/" ;
		}
	}
	
	function GetThumbnailsUrl($projectId, $formId, $relative = false)
	{
		return Path::Combine(F2C_Image::GetImagesUrl($projectId, $formId, $relative), 'thumbs');	
	}

	function GetImagesRootPath($relative = false)
	{
		if($relative)
		{
			return 'com_form2content/';
		}
		else
		{
			return JPATH_SITE.DS.'images/stories/com_form2content/';
		}				
	}
	
	function GetImagesPath($projectId, $formId, $relative = false)
	{
		return Path::Combine(F2C_Image::GetImagesRootPath($relative), 'p'.$projectId.'/'.'f'.$formId);
	}

	function GetThumbnailsPath($projectId, $formId, $relative = false)
	{
		return Path::Combine(F2C_Image::GetImagesPath($projectId, $formId, $relative), 'thumbs');	
	}

	function CreateFullImageName($uploadFilename, $fieldId)
	{
		if(!$uploadFilename)
		{
			return '';
		}	
		
		return $fieldId . '.' . JFile::getExt($uploadFilename);
	}
	
	function CreateThumbnailImageName($uploadFilename, $fieldId)
	{
		if(!$uploadFilename)
		{
			return '';
		}	
		
		return $fieldId . '.' . JFile::getExt($uploadFilename);		
	}	

	function DeleteImages($projectId, $formId)
	{
		if($this->filename)
		{
			$img = Path::Combine($this->GetThumbnailsPath($projectId, $formId), $this->filename);
		
			if(JFile::exists($img))
			{
				JFile::delete($img);
			}

			$img = Path::Combine($this->GetImagesPath($projectId, $formId), $this->filename);
		
			if(JFile::exists($img))
			{
				JFile::delete($img);
			}
		}
	}
}

class F2C_Config
{
	function getTemplatePath()
	{
		return JPATH_SITE.DS.'media'.DS.'com_form2content'.DS.'templates'.DS;
	}	
}

class F2C_ContentTypeSettings
{
	var $article_caption			= '';
	var $title_front_end	 		= 1;
	var $title_caption 				= '';
	var $title_default				= '';
	var $title_alias_front_end 		= 1;
	var $title_alias_caption		= '';
	var $metakey_front_end 			= 1;
	var $metakey_caption	 		= '';
	var $metakey_default	 		= '';
	var $metadesc_front_end 		= 1;
	var $metadesc_caption 			= '';
	var $metadesc_default 			= '';
//  var $section_category_front_end	= 1; through db field
	var $section_category_caption 	= '';
	var $max_forms					= 0;
	var $state_front_end			= 0;
	var $state_default				= 0;
	var $state_caption				= '';
	var $frontpage_front_end		= 0;
	var $frontpage_default			= 0;
	var $frontpage_caption			= '';
	var $created_by_front_end		= 0;
	var $created_by_caption			= '';
	var $created_by_alias_front_end	= 0;
	var $created_by_alias_caption	= '';
	var $access_front_end			= 0;
	var $access_caption				= '';
	var $access_default				= 0;
	var $date_created_front_end		= 0;
	var $captcha_front_end			= 0;
	var $required_field_text		= '';
}

class F2C_FieldData
{
	var $id;
	var $fieldname;
	var $title;
	var $fieldtypeid;
	var $settings;
	var $description;
	var $attributes = array();
}

class F2C_SaveEventArgs
{
	var $isNew = false;
	var $formOld = null;
	var $fieldsOld = null;
	var $formNew = null;
	var $fieldsNew = null;
}

class F2C_EventArgs
{
	var $action = null;
	var $isNew = false;
	var $form = null;
	var $fields = null;
	
	function F2C_EventArgs($action)
	{
		$this->action = $action;
	}
}
?>
