<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'class.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'configuration.php');
require_once(JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

jimport('joomla.application.component.controller');

class Form2ContentControllerForm extends JController
{
	var $modelName = 'form';
	var $formId = 0;
	
	function __construct()
	{
		parent::__construct();
		$this->registerTask('newform', 'edit');
	}

	function __getRedirect()
	{
		$params =& JComponentHelper::getParams('com_form2content');
		
		if($params->get('editmode', '-1') != -1)
		{
			if($params->get('redirectmode', '0') == 0)
			{
				// redirect to custom url
				$link = $params->get('redirectaftersave', 'index.php');
			}
			else
			{
				// redirect to new or modified article if this is published
				$now		=& JFactory::getDate();			
				$model 		= $this->getModel($this->modelName);
				$db			=& JFactory::getDBO();
				$nullDate 	= $db->getNullDate();
				$config		=& JFactory::getConfig();
				$published 	= false;
	
				$model->_id = $this->formId;
				$model->_loadData();
				
				$publish_up =& JFactory::getDate($model->_data->publish_up);
				$publish_down =& JFactory::getDate($model->_data->publish_down);
				$publish_up->setOffset($config->getValue('config.offset'));
				$publish_down->setOffset($config->getValue('config.offset'));
				
				if(($now->toUnix() <= $publish_up->toUnix() && $model->_data->state == 1) ||
			   	  (($now->toUnix() <= $publish_down->toUnix() || $model->_data->publish_down == $nullDate) && $model->_data->state == 1)) 
				{
					// Article is published
					$slug 		= ($model->_data->title_alias) ? $model->_data->reference_id.':'.$model->_data->title_alias : $model->_data->reference_id;
					$catslug 	= ($model->_data->catAlias) ? $model->_data->catid.':'.$model->_data->catAlias : $model->_data->catid;
					$link 		= JRoute::_(ContentHelperRoute::getArticleRoute($slug, $catslug, $model->_data->sectionid), false);
				}
				else
				{
					// Article is not published
					$link = 'index.php';
				}
			}
		}
		else
		{
			$link = JRoute::_('index.php?option=com_form2content&task=viewformlist&c=forms&Itemid=' . JRequest::getInt('Itemid'), false); 
		}
		
		return $link;
	}

	function __redirectOnErrors()
	{
		$errors = JError::getErrors();
		
		if(count($errors))
		{
			foreach($errors as $error)
			{
				if($error->code == F2C_ERROR_MAX_FORMS)
				{
					$this->setRedirect($this->__getRedirect());
				}
			}
		} 
	}

	function __save()
	{
		$data 	= JRequest::get('POST');
		$model 	= $this->getModel($this->modelName);
		
		if ($model->save($data)) 
		{
			$message = JText::_('FORM_SAVED');
			$this->formId = $model->_id;
			$this->contentTypeId = $model->_contentTypeId;
		} 
		else
		{
			$message = JText::_('FORM_SAVE_ERROR'). ' [' . $model->getError() . ']';
			$this->formId = $model->_id;
			$this->contentTypeId = $model->_contentTypeId;
		}
		
		return $message;	
	}

	function add()
	{
		// check if the content type is predefined
		$app 	=& JFactory::getApplication();
		$params =& $app->getParams();	
	
		if(!$params->get('show_new_button', 1))
		{
			JError::raiseError(500, JText::_('You are not authorized to create new F2C Articles'));						
		}
	
		if($params->get('contenttypeid', 0) == 0)
		{
			JRequest::setVar('view', 'projectselect');
			$model = $this->getModel('projectselect');
			$contentTypes = $model->getData();

			if(count($contentTypes) == 1)
			{
				// only one contentType available -> redirect to new article
				foreach($contentTypes as $contentType)
				{
					$contentTypeId = $contentType->id;	
				}
				
				$itemid = JRequest::getInt('Itemid');
				$url = 'index.php?option=com_form2content&c=form&task=newform&id=&Itemid='.$itemid.'&projectid='.$contentTypeId;
				$this->setRedirect(JRoute::_($url, false));
			}			
		}
		else
		{
			JRequest::setVar('view', $this->modelName);
		}		
	
		JRequest::setVar('hidemainmenu', 1);
		parent::display();
	}
	
	function edit()
	{
		JRequest::setVar('view', $this->modelName);
		JRequest::setVar('layout', 'default');
		JRequest::setVar('hidemainmenu', 1);
		
		$model = $this->getModel($this->modelName);

		$dataObject =& $model->getData();
		
		$isNew	= ($dataObject->id < 1);

		parent::display();	
		$this->__redirectOnErrors();		
	}

	function orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$model = $this->getModel($this->modelName);
		$model->move(-1);
		$this->setRedirect($this->__getRedirect());
	}

	function orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$model = $this->getModel($this->modelName);
		$model->move(1);		
		$this->setRedirect($this->__getRedirect());
	}

	/*
	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel($this->modelName);
		$model->saveorder($cid, $order);

		$msg = 'New ordering saved';
		$this->setRedirect($this->__getRedirect(), $msg );
	}
	*/
	
	function display()
	{
		parent::display();
		$this->__redirectOnErrors();		
	}

	function save()
	{
		$message = $this->__save();		
		$this->setRedirect($this->__getRedirect(), $message);
	}
		
	function apply()
	{
		$message = $this->__save();
		$this->setRedirect(JRoute::_('index.php?option=com_form2content&c=form&task=edit&id=' . (int)$this->formId . '&Itemid=' . JRequest::getInt('Itemid'), false), $message);
	}
	
	function remove()
	{
		$model = $this->getModel($this->modelName);
		
		if($model->delete()) 
		{
			$message = JText::_('FORM_DELETED' );
		}
		else 
		{
			$message = JText::_('FORM_DELETE_ERROR');
			$message .= ' [' . $model->getError() . ']';
		}

		$this->setRedirect($this->__getRedirect(), $message);
	}

	function publish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$f2cconfig = new F2CConfig();

		if(!$this->_userCanPublish($f2cconfig))
		{
			JError::raiseError(500, JText::_( 'You are not authorized to publish F2C Articles' ) );			
		}
		
		$message = '';
		$model = $this->getModel($this->modelName);		
		$publishState = 1;
		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count($cid) < 1) 
		{
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$numSuccess = 0;
		$errors = array();

		foreach($cid as $formId)
		{
			$model->setId($formId);
			$model->getData();
			
			if($model->parse($publishState))
			{
				$numSuccess++;
			}
		}

		if(count($cid) == 1)
		{
			if($numSuccess == 1)
			{
				$message = JText::_('ARTICLE_SUCCESSFULLY_PUBLISHED');	
			}
			else
			{
				$message = JText::_('ERROR_ARTICLE_PUBLISH');
			}
		}
		else
		{
			$message = sprintf(JText::_('X_ARTICLES_SUCCESSFULLY_PUBLISHED'), $numSuccess);	
		}
				
		if(count($model->getErrors()))
		{
			$message .= ' [' . implode(', ', $model->getErrors()) . ']';
		}
		
		$this->setRedirect($this->__getRedirect(), $message);
	}

	function unpublish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$f2cconfig = new F2CConfig();
		
		if(!$this->_userCanPublish($f2cconfig))
		{
			JError::raiseError(500, JText::_( 'You are not authorized to unpublish F2C Articles' ) );			
		}
		
		$message = '';
		$model = $this->getModel($this->modelName);		
		$publishState = 0;
		
		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count($cid) < 1) 
		{
			JError::raiseError(500, JText::_( 'Select an item to unpublish'));
		}

		$numSuccess = 0;
		$errors = array();
		
		foreach($cid as $formId)
		{
			$model->setId($formId);
			$model->getData();
			
			if($model->parse($publishState))
			{
				$numSuccess++;
			}
		}

		if(count($cid) == 1)
		{
			if($numSuccess == 1)
			{
				$message = JText::_('ARTICLE_SUCCESSFULLY_UNPUBLISHED');	
			}
			else
			{
				$message = JText::_('ERROR_ARTICLE_UNPUBLISH');
			}
		}
		else
		{
			$message = sprintf(JText::_('X_ARTICLES_SUCCESSFULLY_UNPUBLISHED'), $numSuccess);	
		}
				
		if(count($model->getErrors()))
		{
			$message .= ' [' . implode(', ', $model->getErrors()) . ']';
		}
		 
		$this->setRedirect($this->__getRedirect(), $message);
	}

	function copy()
	{
		$model = $this->getModel($this->modelName);
		
		if($model->copy())
		{
			$message = JText::_('DATA_COPIED');			
		}
		else
		{
			$message = JText::_('DATA_COPY_ERROR');
			$message .= ' [' . $model->getError() . ']';			
		}
		
		$this->setRedirect($this->__getRedirect(), $message);		
	}	

	function cancel()
	{
		$message = JText::_('OPERATION_CANCELLED');
		$this->setRedirect($this->__getRedirect(), $message);
	}
	
	function checkCaptcha()
	{
		if(!function_exists('recaptcha_check_answer'))
		{
			require_once(JPATH_COMPONENT_SITE.DS.'libraries'.DS.'recaptcha'.DS.'recaptchalib.php');
		}
		
		$app			=& JFactory::getApplication();
		$config 		= new F2CConfig();
		$challengeField = JRequest::getString('challenge','');
		$responseField 	= JRequest::getString('response','');
		$privatekey 	= (array_key_exists('recaptcha_private_key', get_object_vars($config))) ? $config->recaptcha_private_key : '';
		
		$resp = recaptcha_check_answer($privatekey, $_SERVER["REMOTE_ADDR"], $challengeField, $responseField);	

		if($resp->is_valid)
		{
			$app->setUserState('F2cCaptchaState', '1');
			echo '1';
		}
		else
		{
			$app->setUserState('F2cCaptchaState', '0');
			echo '0';
		}		
	}
	
	/*
	 * Check if an user can publish items in the front end
	 */
	function _userCanPublish($f2cConfig)
	{
		switch((array_key_exists('front_end_publish',get_object_vars($f2cConfig))) ? (int)$f2cConfig->front_end_publish : 1)
		{
			case 0:
				return false;
				break;
			case 1:
				return true;
				break;
			case 2:
				// check if the user is an admin
				$user = JFactory::getUser();		
				return ($user->usertype == 'Super Administrator' || $user->usertype == 'Administrator');
				break;
		}		
	}	
}
?>