function F2C_checkExtension(fieldid, arrWhite, arrBlack, msgWhite, msgBlack)
{
    var fn = document.getElementById(fieldid).value;

    if(fn)
    {
	    var ext = (fn.lastIndexOf('.') != -1) ? fn.substring(fn.lastIndexOf('.')+1, fn.length).toLowerCase() : '';
	
	    if(arrWhite.length)
	    {
	        var found = false;
	        
	        for(var i=0;i<arrWhite.length;i++)
	        {
	            if(ext == arrWhite[i])
	            {
	                found = true;
	                break;
	            }
	        }
	        
	        if(!found)
	        {
	            alert(msgWhite.replace('%s', ext));
	            return false;
	        }
	    }
	    
	    if(arrBlack.length)
	    {
	        for(var i=0;i<arrBlack.length;i++)
	        {
	            if(ext == arrBlack[i]) 
	            {
	                alert(msgBlack.replace('%s', ext));
	                return false;
	            }
	        }
	    }
	}
	    
    return true;
}

function F2C_limitTextArea(field, countfield, maxlimit) 
{
	if (field.value.length > maxlimit)
	{
		field.value = field.value.substring(0, maxlimit);
	}
	else
	{
		countfield.value = maxlimit - field.value.length;
	}
}

function F2C_ValReqSingleLineText(id)
{
	var elm = document.getElementById(id);
	return elm.value.trim().length;
}

function F2C_ValReqMultiLineText(id)
{
	var elm = document.getElementById(id);
	return elm.value.trim().length;
}

function F2C_ValReqMultiLineEditor(id)
{
	var text = F2C_GetEditorText(id);
	return text.trim().length;
}

function F2C_ValReqCheckBox(id)
{
	var elm = document.getElementById(id);
	return elm.checked;
}

function F2C_ValReqSingleSelectList(id)
{
	var elm = document.getElementById(id);
	
	if(elm != null && elm.type != 'radio')
	{
		// Drop down list
		return (elm.value != '');
	}	
	else
	{
		// Radio buttons
		var elements = document.getElementsByName(id);
		
		for(i=0;i<elements.length;i++)
		{
			if(elements[i].id != elements[i].name)
			{
				if(elements[i].checked) return true;	
			}
		}
		
		return false;
	}
}

function F2C_ValReqImage(id)
{
	var elmUpload = document.getElementById(id+'_fileupload');
	var elmPreview = document.getElementById(id+'_preview');
	return (elmUpload.value.trim() != '' || elmPreview);
}

function F2C_ValReqIFrame(id)
{
	var elm = document.getElementById(id);
	return (elm.value.trim() != '');
}

function F2C_ValReqEmail(id)
{
	var elm = document.getElementById(id);
	return (elm.value.trim() != '');
}

function F2C_ValReqHyperlink(id)
{
	var elm = document.getElementById(id);
	return (elm.value.trim() != '');
}

function F2C_ValReqMultiSelectList(id)
{
	var elm = document.getElementsByName(id+'[]');
	
	for(var i=0;i<elm.length;i++)
	{
		if(elm[i].checked) return true;
	}

	return false;
}

function F2C_ValReqDatePicker(id)
{
	var elm = document.getElementById(id);
	return (elm.value.trim() != '');
}

function F2C_ValReqDisplayList(id)
{
	var elmMaxKey = document.getElementById(id+'MaxKey');
	var elm;
	
	for(var i=0;i<=elmMaxKey.value;i++)
	{
		elm = document.getElementById(id+'_'+i+'val');		
		if(elm && elm.value.trim() != '') return true;
	}

	return false;
}

function F2C_ValReqFile(id)
{
	var elmUpload = document.getElementById(id+'_fileupload');
	var elmDel = document.getElementById(id+'_del'); 
	var elmPreview = document.getElementById(id+'_preview');
	
	if(elmDel.checked)
	{
		return false;
	}
	else
	{
		return (elmUpload.value.trim() != '' || elmPreview);
	}
}

function F2C_ValReqDatabaseLookup(id)
{
	var elm = document.getElementById(id);
	return (elm.value != '');
}

function F2C_ValReqGeoCoder(id)
{
	var elmAddress = document.getElementById(id+'_address');
	var elmLatLon = document.getElementById(id+'_latlon');
	var re = new RegExp('^\\(-?\\d{1,3}\\.\\d+,\\s-?\\d{1,3}\\.\\d+\\)$');
	return (elmLatLon.innerHTML.match(re) && elmAddress.value.trim() != '');
}

function F2C_ValReqDatabaseLookupMulti(id)
{
	var elmMaxKey = document.getElementById(id+'MaxKey');
	var elm;
	
	for(var i=0;i<=elmMaxKey.value;i++)
	{
		elm = document.getElementById(id+'_'+i+'val');		
		if(elm && elm.value.trim() != '') return true;
	}

	return false;
}

function F2C_CheckRequiredFields(arrValidation)
{
	var errors = '';
	for(var i=0;i<arrValidation.length;i++)
	{
		var fieldId = 't'+arrValidation[i][0];
		var fieldType = arrValidation[i][1];
		var result;			
		
		switch(fieldType)
		{
			case 1:
				result = F2C_ValReqSingleLineText(fieldId);
				break;
			case 2:
				result = F2C_ValReqMultiLineText(fieldId);
				break;
			case 3:
				result = F2C_ValReqMultiLineEditor(fieldId);
				break;
			case 4:
				result = F2C_ValReqCheckBox(fieldId);
				break;
			case 5:
				result = F2C_ValReqSingleSelectList(fieldId);
				break;
			case 6:
				result = F2C_ValReqImage(fieldId);
				break;
			case 7:
				result = F2C_ValReqIFrame(fieldId);
				break;
			case 8:
				result = F2C_ValReqEmail(fieldId);
				break;
			case 9:
				result = F2C_ValReqHyperlink(fieldId);
				break;
			case 10:					
				result = F2C_ValReqMultiSelectList(fieldId);
				break;					
			case 12:					
				result = F2C_ValReqDatePicker(fieldId);
				break;					
			case 13:
				result = F2C_ValReqDisplayList(fieldId);
				break;	
			case 14:
				result = F2C_ValReqFile(fieldId);
				break;						
			case 15:
				result = F2C_ValReqDatabaseLookup(fieldId);
				break;
			case 16:
				result = F2C_ValReqGeoCoder(fieldId);
				break;
			case 17:
				result = F2C_ValReqDatabaseLookupMulti(fieldId);
				break;
			default:
				result = true;
		}
		
		if(!result) errors += arrValidation[i][2] + '\n';
	}
	
	if(errors)
	{
		alert(errors);
		return false;
	}
	
	return true;		
}

function F2C_CheckCaptcha(pressbutton, msg, itemId)
{	
	var url = 'index.php?option=com_form2content&c=form&format=raw&task=checkCaptcha&response=' + 
			   encodeURIComponent(Recaptcha.get_response()) + '&challenge=' + encodeURIComponent(Recaptcha.get_challenge()) +
			   '&Itemid=' + itemId;

	var a = new Ajax(url, {
                    		method:"get",
                    		onComplete: function(resp)
                    		{
								if(parseInt(resp) != 1)
								{
									alert(msg);
									Recaptcha.reload();
									Recaptcha.focus_response_field();
								}
								else
								{
									submitform(pressbutton);
								}
                    		}
                			}).request();
}