<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'models'.DS.'formbase.php');

class Form2ContentModelForm extends Form2ContentModelFormBase
{	
	function __construct()
	{
		parent::__construct();
	
		$params 				=& JComponentHelper::getParams('com_form2content');
		$cid 					= JRequest::getVar('cid', false, 'DEFAULT', 'array');
		$this->_contentTypeId 	= $params->get('contenttypeid');
		$id 					= ($cid && $cid[0]) ? $cid[0] : JRequest::getInt('id', 0);
		
		if(!$this->_contentTypeId)
		{
			$this->_contentTypeId = JRequest::getInt('projectid', 0);
		}		
		
		switch($params->get('editmode', '-1'))
		{
			case -1:
				// we come from the list menu
				break;
			case 0:
				// always create new
				$id = 0;
				break;
			case 1:
				// edit existing if possible
				$id = $this->_getDefaultArticleId();
				break;
		}
		
		if($id == -1)
		{
			JError::raiseError(F2C_ERROR_NO_CONTENT_TYPE,JText::_('ERROR_NO_CONTENT_TYPE'));
		}
		
		$this->setId($id);		
	}
		
	function save($data)
	{
		$config 		= new F2CConfig();
		$configJoomla	=& JFactory::getConfig();
		$app 			=& JFactory::getApplication();
		$tzoffset 		= $configJoomla->getValue('config.offset');
		$params 		=& JComponentHelper::getParams('com_form2content');
		$projectid 		= JRequest::getInt('projectid', 0);
		$formid 		= JRequest::getInt('id', 0);
		$datenow 		=& JFactory::getDate();
		$timestamp 		= $datenow->toMySQL();
		$nullDate		= $this->_db->getNullDate();
		$row 			=& $this->getTable();
		$validator 		= new F2C_Validation();
		$parseData 		= true;
		
		JPluginHelper::importPlugin('form2content');
		
		$F2C_FIELD_SETTINGS_MAPPING = array(F2C_FIELDTYPE_SINGLELINE => 'F2C_SingleLineTextSettings',
									F2C_FIELDTYPE_MULTILINETEXT => 'F2C_MultiLineTextSettings',
									F2C_FIELDTYPE_MULTILINEEDITOR => 'F2C_MultiLineEditorSettings',
									F2C_FIELDTYPE_CHECKBOX => 'F2C_CheckBoxSettings',
									F2C_FIELDTYPE_SINGLESELECTLIST => 'F2C_SingleSelectSettings', 
									F2C_FIELDTYPE_IMAGE => 'F2C_ImageSettings',
									F2C_FIELDTYPE_IFRAME => 'F2C_IFrameSettings', 
									F2C_FIELDTYPE_EMAIL => 'F2C_EmailSettings', 
									F2C_FIELDTYPE_HYPERLINK => 'F2C_LinkSettings', 
									F2C_FIELDTYPE_MULTISELECTLIST => 'F2C_MultiSelectSettings', 
									F2C_FIELDTYPE_INFOTEXT => 'F2C_InfoTextSettings', 
									F2C_FIELDTYPE_DATEPICKER => 'F2C_DatePickerSettings', 
									F2C_FIELDTYPE_DISPLAYLIST => 'F2C_DisplayListSettings', 
									F2C_FIELDTYPE_FILE => 'F2C_FileSettings', 
									F2C_FIELDTYPE_DATABASE_LOOKUP => 'F2C_DatabaseLookupSettings', 
									F2C_FIELDTYPE_GEOCODER => 'F2C_GeoCoderSettings',
									F2C_FIELDTYPE_DB_LOOKUP_MULTI => 'F2C_DatabaseLookupMultiSettings');

		// load the project
		$this->_db->setQuery('SELECT * FROM #__f2c_project WHERE id=' . (int)$projectid);			
		$project = $this->_db->loadObject();
		$contentTypeSettings = ($project->settings) ? unserialize($project->settings) : new F2C_ContentTypeSettings();

		// Verify the captcha
		if($contentTypeSettings->captcha_front_end)
		{
			if($app->getUserState('F2cCaptchaState', '0') == '0')
			{
				$this->setError(JText::_('ERRROR_CAPTCHA_INCORRECT'));
				return false;
			}

			// reset captcha
			$app->setUserState('F2cCaptchaState', '0');			
		}
			
		// Bind the form fields to the table
		if (!$row->bind($data)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		$this->setId($row->id);
		$this->getData();
		
		$isNew 		= ($row->id) ? false: true;		
		
		checkFormAuthorization($row);
		
		// get all the field definitions for this form
	 	$this->_db->setQuery("SELECT f.* FROM #__f2c_projectfields f "
	 						. "WHERE f.projectid =" . (int)$projectid
	 						. " ORDER BY ordering ASC");
	  	$fields = $this->_db->loadObjectList();	

		// Check required fields		
		foreach($fields as $field)
		{
			$fieldSettings = ($field->settings) ? unserialize($field->settings) : new $F2C_FIELD_SETTINGS_MAPPING[$field->fieldtypeid]();
			
			if($fieldSettings->required)
			{
				if(!$validator->valReqField($field, 't'.$field->id, $data))
				{
					$msg = ($fieldSettings->errorMessageRequired) ? $fieldSettings->errorMessageRequired : sprintf(JText::_('ERROR_FIELD_X_REQUIRED'), $field->title);
					$this->setError($msg);
					return false;
				}
			}
			
			switch($field->fieldtypeid)
			{
				case F2C_FIELDTYPE_IMAGE:
					$msg = $validator->valSizeImage($field, $config);					
					break;
				case F2C_FIELDTYPE_FILE:
					$msg = $validator->valSizeFileUpload($field, $config);
					break;
				default:
					$msg = '';
					break;
			}
			
			if($msg)
			{
				$this->setError($msg);
				return false;
			}			
		}
				
		// load the existing form
		$this->_db->setQuery('SELECT * FROM #__f2c_form WHERE id=' . (int)$row->id);			
		$form = $this->_db->loadObject();

		if(!$this->_canSave())
		{
			return false;			
		}
		
		// process Date Created
		if($contentTypeSettings->date_created_front_end)
		{
			// Date Created is shown in front-end
			if ($row->created)
			{
				if(strlen(trim($row->created)) <= 10) 
				{
					$row->created .= ' 00:00:00';
				}
				
				$date = ParseDate($row->created, $config->date_format);
				
				if($date->_date)
				{
					$created =& JFactory::getDate($date->toMySQL(), $tzoffset);
					$row->created = $created->toMySQL();
				}
				else
				{
					$row->created = $timestamp;
				}			
			}
			else
			{
				$row->created = $timestamp;
			}
		}
		else
		{
			// Date Created not shown on form
			$row->created = ($isNew) ? $timestamp : $form->created;
		}
				
		// process Publish Up and Down dates			
		if($project->frontend_pubsel)
		{
			if($row->publish_up)
			{			
				$date = ParseDate($row->publish_up, $config->date_format);
				
				if($date)
				{
					$publish_up =& JFactory::getDate($date->toMySQL(), $tzoffset);
					$row->publish_up = $publish_up->toMySQL();
				}
				else
				{
					$publish_up = JFactory::getDate(null, $tzoffset);
					$row->publish_up = $publish_up->toMySQL();
				}
			}
			else
			{
				$publish_up = JFactory::getDate(null, $tzoffset);
				$row->publish_up = $publish_up->toMySQL();
			}
			
			if(trim($row->publish_down) == JText::_('Never') || trim($row->publish_down) == '')
			{
				$row->publish_down = $nullDate;
			}
			else
			{
				$date = ParseDate($row->publish_down, $config->date_format);
				
				if($date)
				{
					$publish_down =& JFactory::getDate($date->toMySQL(), $tzoffset);
					$row->publish_down = $publish_down->toMySQL();
				}
				else
				{
					$row->publish_down = $nullDate;
				}			
			}
		}
		else
		{
			// Publish dates not shown on form
			$row->publish_up 	= ($isNew) ? $row->created : $form->publish_up;
			$row->publish_down 	= ($isNew) ? $nullDate : $form->publish_down;
		}
				
		if($row->id) 
		{
			// existing form
			$row->modified = $timestamp;
						
			// check if we need to retain some values
			if(!$contentTypeSettings->title_front_end)
			{
				$row->title = $form->title;
			}
			
			if(	$params->get('restrict_sectioncategory_id', '-1_-1') != '-1_-1' ||
				!$project->frontend_catsel)
			{
				$row->catid = $form->catid;
				$row->sectionid = $form->sectionid;
			}
			else
			{
				if($project->catid == -2)
				{
					// section is fixed
					$row->sectionid = $project->sectionid;
				}
			}
			
			if(!$contentTypeSettings->created_by_front_end)
			{
				$row->created_by = $form->created_by;
			}
			
			if(!$contentTypeSettings->created_by_alias_front_end)
			{
				$row->created_by_alias = $form->created_by_alias;
			}
			
			if(!$project->frontend_templsel)
			{
				$row->intro_template = $form->intro_template;
				$row->main_template = $form->main_template;
			}	
			
			if(!$contentTypeSettings->metadesc_front_end)
			{
				$row->metadesc = $form->metadesc;
			}

			if(!$contentTypeSettings->metakey_front_end)
			{
				$row->metakey = $form->metakey;
			}
								
			if(!$contentTypeSettings->state_front_end)
			{
				$row->state = $form->state;
			}
			
			if(!$contentTypeSettings->frontpage_front_end)
			{
				$row->frontpage = $form->frontpage;
			}
			
			if(!$contentTypeSettings->access_front_end)
			{
				$row->access = $form->access;
			}
			
			$row->attribs = $form->attribs;
			$row->metadata = $form->metadata;						
		}
		else
		{
			// new record -> initialize
			$user =& JFactory::getUser();		

			if(!$contentTypeSettings->created_by_front_end)
			{
				$row->created_by = $user->id;
			}
			
			if(!$contentTypeSettings->created_by_alias_front_end)
			{
				$row->created_by_alias = '';
			}
			
			// set project defaults			
			if(!$contentTypeSettings->title_front_end)
			{
				$row->title = $contentTypeSettings->title_default;
			}
			
			if($params->get('restrict_sectioncategory_id', '-1_-1') != '-1_-1')
			{
				// menu parameter overrules ContentType settings
				$ids = explode('_', $params->get('restrict_sectioncategory_id', '-1_-1'));
				$row->sectionid = $ids[0];
				$row->catid = $ids[1];
			}
			elseif($project->frontend_catsel)
			{
				if($project->catid == -2)
				{
					// section is fixed
					$row->sectionid = $project->sectionid;
				}
			}
			else
			{
				$row->catid = $project->catid;
				$row->sectionid = $project->sectionid;				
			}
			
			if(!$project->frontend_templsel)
			{
				$row->intro_template = $project->intro_template;
				$row->main_template = $project->main_template;
			}
			
			if(!$contentTypeSettings->metadesc_front_end)
			{
				$row->metadesc = $contentTypeSettings->metadesc_default;
			}

			if(!$contentTypeSettings->metakey_front_end)
			{
				$row->metakey = $contentTypeSettings->metakey_default;
			}
			
			if(!$contentTypeSettings->state_front_end)
			{
				$row->state = $contentTypeSettings->state_default;
			}
			
			if(!$contentTypeSettings->frontpage_front_end)
			{
				$row->frontpage = $contentTypeSettings->frontpage_default;
			}		

			if(!$contentTypeSettings->access_front_end)
			{
				$row->access = $contentTypeSettings->access_default;
			}
			
			//use the parameters as specified as Content Type defaults
			$row->attribs  = $project->attribs;
			$row->metadata = $project->metadata;
		}			
		
		if (!$row->check()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// create new Storage object for front-end handling
		$storage = new F2C_Storage($config, $row->id, false);
		$storage->prepareSubmittedData($fields);

		$eventDataBeforeSave			= new F2C_SaveEventArgs();
		$eventDataBeforeSave->isNew		= $this->isNew();
		$eventDataBeforeSave->formNew 	=& $row;
		$eventDataBeforeSave->fieldsNew	=& $storage->preparedData;
		
		if($eventDataBeforeSave->isNew)
		{
			$eventDataBeforeSave->formOld	= null;
			$eventDataBeforeSave->fieldsOld	= null;
		}
		else
		{
			// Load the existing form data
			$this->_loadData();
			
			$eventDataBeforeSave->formOld	= $this->_data;;
			$eventDataBeforeSave->fieldsOld	= $this->_fieldData;;
		}
		
		$result = $this->_dispatcher->trigger('onBeforeF2cContentSave', array(&$eventDataBeforeSave));

		// Store the table to the database
		if (!$row->store()) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Update item order
		$row->reorder('catid = '.(int)$row->catid);
		
		// handle fieldcontent
		$formid = $row->id;
		// sync id's
		$this->setId($row->id);
		$storage->formId = $row->id;
				
		$storage->storeFields($fields);

		// sync data without authorization check
		$this->_loadData(false);

		if(!$this->parse(-1))
		{
			return false;
		}

		$eventDataAfterSave 			= new F2C_SaveEventArgs();
		$eventDataAfterSave->isNew		= $eventDataBeforeSave->isNew;
		$eventDataAfterSave->formNew 	= $this->_data;
		$eventDataAfterSave->fieldsNew 	= $this->_fieldData;
		$eventDataAfterSave->formOld	= $eventDataBeforeSave->formOld;
		$eventDataAfterSave->fieldsOld	= $eventDataBeforeSave->fieldsOld;
		
		$result = $this->_dispatcher->trigger('onAfterF2cContentSave', array($eventDataAfterSave));

		return true;
	}
	
	/**
	 * Method to move a form
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	2.0.3
	 */
	function move($direction)
	{
		$row 		=& $this->getTable();
		$config 	= new F2CConfig();
		
		if (!$row->load($this->_id)) 
		{
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// move function does not return true on success!
		$row->move($direction, 'catid = ' . (int)$row->catid); 

		if(array_key_exists('autosync_article_order',get_object_vars($config)) && $config->autosync_article_order)
		{
			ContentHelper::syncArticleOrder($row->catid);	
		}

		$cache = & JFactory::getCache('com_form2content');
		$cache->clean();
		
		return true;
	}
	
	/*
	function saveorder($cid = array(), $order)
	{
		$row =& $this->getTable();
		$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load((int) $cid[$i] );

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) 
				{
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		return true;
	}	
	*/
	
	function _loadData($performAuthorizationCheck = true)
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT ' .
					 'frm.*, sec.title AS secTitle, sec.alias AS secAlias, ' .
					 'cat.title AS catTitle, cat.alias AS catAlias ' .
					 'FROM ' . $this->_db->nameQuote('#__f2c_form') . ' frm ' .
					 'LEFT JOIN #__sections sec ON frm.sectionid = sec.id ' .
					 'LEFT JOIN #__categories cat ON frm.catid = cat.id ' .					  
					 'WHERE frm.id = ' . (int)$this->_id;
					 
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			
			if($this->_data)
			{
				$this->_contentTypeId = $this->_data->projectid;
			}
							
			if($performAuthorizationCheck)
			{				
				checkFormAuthorization($this->_data);
			}
			
			// Load the fields data
			$this->_db->setQuery('SELECT ' .
						  		 'pf.id, pf.fieldname, pf.title, pf.description, pf.fieldtypeid, pf.settings, ' .
						  		 'fc.attribute, fc.content ' .
						  		 'FROM #__f2c_fieldcontent fc ' .
						  		 'INNER JOIN #__f2c_projectfields pf on fc.fieldid = pf.id ' .
						  		 'WHERE fc.formid = '.(int)$this->_id . ' ORDER BY pf.fieldtypeid');
						  
			$fieldContentList = $this->_db->loadObjectList();

			$this->_fieldData = array();
			
			foreach($fieldContentList as $fieldContent)
			{
				if(!array_key_exists($fieldContent->id, $this->_fieldData))
				{
					$fldData 				= new F2C_FieldData();
					$fldData->id 			= $fieldContent->id;
					$fldData->fieldtypeid 	= $fieldContent->fieldtypeid;
					$fldData->title 		= $fieldContent->title;
					$fldData->description	= $fieldContent->description;					
					$fldData->fieldname 	= $fieldContent->fieldname;
					$fldData->settings 		= $fieldContent->settings;
										
					if($fldData->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
					{
						$fldData->attributes['VALUE'] = array();
					}
					
					$this->_fieldData[$fieldContent->id] = $fldData;					 			
				}
							
				if($fldData->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
				{
					$this->_fieldData[$fieldContent->id]->attributes[$fieldContent->attribute][] = $fieldContent->content;
				}
				else
				{						
					$this->_fieldData[$fieldContent->id]->attributes[$fieldContent->attribute] = $fieldContent->content;
				}
			}
			
			return (boolean)$this->_data;
		}
		return true;
	}
	
	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$this->_initForm($this->_contentTypeId);
			return (boolean)$this->_data;		
		}
		
		return true;
	}
	
	function _canSave()
	{
		$user 		=& JFactory::getUser();
		$max_forms 	= (int)$this->_contentTypeSettings->max_forms;
		
		if($max_forms == 0)
		{
			// no limit
			return true;
		}
		else
		{
			$sql = 	'SELECT COUNT(*) FROM #__f2c_form WHERE ' . 
					'projectid = ' . (int)$this->_data->projectid . ' AND ' .
					'created_by = ' . $user->id . ' AND ' .
					'id <> ' . $this->_id;				
			$this->_db->setQuery($sql);
			$result = $this->_db->loadResult();
	
			if($result >= $max_forms)
			{
				if($max_forms > 1)
				{
					$numArticles = '('.$max_forms.' '.JText::_('ARTICLES').')'; 			
				}
				else
				{
					$numArticles = '('.$max_forms.' '.JText::_('ARTICLE').')'; 					
				}
				
				$this->setError(JText::_('ERROR_MAX_FORMS_EXCEEDED') . ' ' . $numArticles);
				return false; 				
			}
		}
		
		return true;
	}
	
	/**
	 * Load the Id of the newest article that the current user has written.
	 * The ContentTypeId may be predefined.
	 * If no article is found, the id for a new article is returned
	 **/
	function _getDefaultArticleId()
	{
		if(!$this->_contentTypeId)
		{
			// can not determine article Id
			return -1;
		}
		
		$user =& JFactory::getUser();
		
		$sql = 'SELECT id FROM #__f2c_form frm WHERE created_by = ' . $user->id;
		
		if($this->_contentTypeId > 0)
		{
			$sql .= ' AND projectid = ' . $this->_contentTypeId;
		}
		
		$sql .= ' ORDER BY created DESC LIMIT 1';

		$this->_db->setQuery($sql);
		$id = $this->_db->loadResult();
		
		return ($id) ? $id : 0;		
	}
}
?>