<?php
defined('_JEXEC') or die('Restricted acccess');

if (!class_exists('Smarty')) 
{
	require_once(JPATH_SITE.DS.'components'.DS.'com_form2content'.DS.'libraries'.DS.'smarty'.DS.'Smarty.class.php');
}

class F2C_Smarty
{
	var $templates;
	var $config;
	var $form;
	var $error = '';
	var $smarty = null;
	
	function F2C_Smarty($config)
	{
		$jconfig =& JFactory::getConfig();

		$this->config = $config;
		$this->smarty = new Smarty();
		$this->smarty->template_dir =	F2C_Config::getTemplatePath();
		$this->smarty->compile_dir = 	$jconfig->getValue('config.tmp_path');
	}

	function parseIntro()
	{
		$parsedContent = $this->smarty->fetch($this->templates[F2C_TEMPLATE_INTRO]);		
		return $parsedContent;
	}

	function parseMain()
	{
		$parsedContent = '';
		
		if(array_key_exists(F2C_TEMPLATE_MAIN, $this->templates))
		{	
			$parsedContent = $this->smarty->fetch($this->templates[F2C_TEMPLATE_MAIN]);
		}
		
		return $parsedContent;
	}
	
	function addTemplate($templateName, $templateType)
	{
		if(!JFile::exists(Path::Combine(F2C_Config::getTemplatePath(), $templateName)))
		{
			$this->error = JText::_('ERROR_TEMPLATE_NOT_FOUND');
			return false;
		}
		
		$this->templates[$templateType] = $templateName;
		
		return true;	
	}

	function clearTemplates()
	{
		// No action necessary
	}
		
	function addVar($name, $value)
	{
		$this->smarty->assign(strtoupper($name), $value);		
	}
	
	function clearVar($name)
	{
		$this->smarty->clear_assign(strtoupper($name));
	}
	
	
	function clearAllVars()
	{
		$this->smarty->clear_all_assign();
	}
		
	function addFormVar($field)
	{
		$F2C_FIELD_FUNCTION_MAPPING = array(F2C_FIELDTYPE_SINGLELINE => 'SingleLineText',
									F2C_FIELDTYPE_MULTILINETEXT => 'MultiLineText',
									F2C_FIELDTYPE_MULTILINEEDITOR => 'MultiLineEditor',
									F2C_FIELDTYPE_CHECKBOX => 'CheckBox',
									F2C_FIELDTYPE_SINGLESELECTLIST => 'SingleSelectList', 
									F2C_FIELDTYPE_IMAGE => 'Image',
									F2C_FIELDTYPE_IFRAME => 'IFrame', 
									F2C_FIELDTYPE_EMAIL => 'Email', 
									F2C_FIELDTYPE_HYPERLINK => 'Hyperlink', 
									F2C_FIELDTYPE_MULTISELECTLIST => 'MultiSelectList', 
									F2C_FIELDTYPE_INFOTEXT => 'InfoText', 
									F2C_FIELDTYPE_DATEPICKER => 'DatePicker', 
									F2C_FIELDTYPE_DISPLAYLIST => 'DisplayList', 
									F2C_FIELDTYPE_FILE => 'FileUpload', 
									F2C_FIELDTYPE_DATABASE_LOOKUP => 'DatabaseLookup', 
									F2C_FIELDTYPE_GEOCODER => 'GeoCoder',
									F2C_FIELDTYPE_DB_LOOKUP_MULTI => 'DatabaseLookupMulti');

		$functionName 	= '_addVar'.$F2C_FIELD_FUNCTION_MAPPING[$field->fieldtypeid];
		$fieldData 		= count($field->attributes) ? $field->attributes : null;

		// Leave the title for backward compatibility
		$this->addVar($field->fieldname.'_TITLE', HtmlHelper::stringHTMLSafe($field->title));
		$this->addVar($field->fieldname.'_CAPTION', HtmlHelper::stringHTMLSafe($field->title));
		$this->addVar($field->fieldname.'_DESCRIPTION', HtmlHelper::stringHTMLSafe($field->description));	
		$this->$functionName($field, $fieldData);
	}
	
	function _addVarSingleLineText($field, $data)
	{
		$this->addVar($field->fieldname, HtmlHelper::stringHTMLSafe($data['VALUE']));
	}

	function _addVarMultiLineText($field, $data)
	{
		$this->addVar($field->fieldname, nl2br(HtmlHelper::stringHTMLSafe($data['VALUE'])));
	}
	
	function _addVarMultiLineEditor($field, $data)
	{
		$this->addVar($field->fieldname, $data['VALUE']);
	}
	
	function _addVarCheckBox($field, $data)
	{
		if($data['VALUE'])
		{
			$this->addVar($field->fieldname, $data['VALUE']); 
		}
	}

	function _addVarSingleSelectList($field, $data)
	{
		if($data['VALUE'])
		{
			$fieldText 	= '';		
			$settings 	= unserialize($field->settings);

			if(array_key_exists($data['VALUE'], $settings->listOptions))
			{
				$fieldText = $settings->listOptions[$data['VALUE']];
			}
								
			$this->addVar($field->fieldname, $data['VALUE']);
			$this->addVar($field->fieldname.'_TEXT', $fieldText);
		}
	}
	
	function _addVarImage($field, $data)
	{
		if($data['VALUE'])
		{
			$settings = unserialize($field->settings);			
			$image = unserialize($data['VALUE']);
			
			if($image->filename)
			{
				$tagWidth = ($image->width > 0) ? ' width="'.$image->width.'"' : '';
				$tagHeight = ($image->height > 0) ? ' height="'.$image->height.'"' : '';
				
				if($settings->imageOutputMode == 0)
				{				
					$this->addVar($field->fieldname, F2C_Image::GetImagesUrl($this->form->projectid, $this->form->id) . $image->filename);						
				}
				else
				{
					$this->addVar($field->fieldname, '<img src="' . F2C_Image::GetImagesUrl($this->form->projectid, $this->form->id) . $image->filename . '" alt="' . $image->alt . '" title="' . $image->title . '"' . $tagWidth . $tagHeight . '/>');
				}
				
				// add image information
				$this->addVar($field->fieldname.'_RAW', F2C_Image::GetImagesUrl($this->form->projectid, $this->form->id) . $image->filename);
				$this->addVar($field->fieldname.'_IMG', '<img src="' . F2C_Image::GetImagesUrl($this->form->projectid, $this->form->id) . $image->filename . '" alt="' . $image->alt . '" title="' . $image->title . '"' . $tagWidth . $tagHeight . '/>');
				$this->addVar($field->fieldname.'_ALT', HtmlHelper::stringHTMLSafe($image->alt));					
				$this->addVar($field->fieldname.'_TITLE', HtmlHelper::stringHTMLSafe($image->title));					
				$this->addVar($field->fieldname.'_WIDTH', ($image->width > 0) ? $image->width : '');					
				$this->addVar($field->fieldname.'_HEIGHT', ($image->height > 0) ? $image->height : '');					
				$this->addVar($field->fieldname.'_WIDTH_THUMB', ($image->widthThumbnail > 0) ? $image->widthThumbnail : '');					
				$this->addVar($field->fieldname.'_HEIGHT_THUMB', ($image->heightThumbnail > 0) ? $image->heightThumbnail : '');					

				// add image urls
				$this->addVar($field->fieldname.'_PATH_ABSOLUTE', Path::Combine(F2C_Image::GetImagesPath($this->form->projectid, $this->form->id, false), $image->filename));
				$this->addVar($field->fieldname.'_PATH_RELATIVE', Path::Combine(F2C_Image::GetImagesPath($this->form->projectid, $this->form->id, true), $image->filename));
				
				// add thumbnail urls
				$this->addVar($field->fieldname.'_THUMB_URL_ABSOLUTE', Path::Combine(F2C_Image::GetThumbnailsUrl($this->form->projectid, $this->form->id), $image->filename));
				$this->addVar($field->fieldname.'_THUMB_URL_RELATIVE', Path::Combine(F2C_Image::GetThumbnailsUrl($this->form->projectid, $this->form->id, true), $image->filename));
			}
			else
			{
				// no image was specified
				$this->addVar($field->fieldname.'_IMG', '');					
				$this->addVar($field->fieldname.'_RAW', '');					
				$this->addVar($field->fieldname, '');
				$this->addVar($field->fieldname.'_PATH_ABSOLUTE', '');
				$this->addVar($field->fieldname.'_PATH_RELATIVE', '');
				$this->addVar($field->fieldname.'_THUMB_URL_ABSOLUTE', '');
				$this->addVar($field->fieldname.'_THUMB_URL_RELATIVE', '');
				$this->addVar($field->fieldname.'_ALT', '');					
				$this->addVar($field->fieldname.'_TITLE', '');					
			} 
		}
	}

	function _addVarIFrame($field, $data)
	{
		if($data['VALUE'])
		{
			$iframe = unserialize($data['VALUE']);
			$iframeTag = '<iframe src="' . $iframe->url . '" height="' . $iframe->height . '" width="' . $iframe->width . '"></iframe>';
			$this->addVar($field->fieldname, $iframeTag);
		}				
	}	
	
	function _addVarEmail($field, $data)
	{
		$emailTag = '';
		$emailAddress = '';
		$emailDisplay = '';
		
		if($data['VALUE'])
		{
			$email = unserialize($data['VALUE']); 
			
			if($email->email)
			{
				$display = $email->display ? $email->display : $email->email;
				$emailTag = '<a href="mailto:' . $email->email . '">' . HtmlHelper::stringHTMLSafe($display) . '</a>';
				$emailAddress = $email->email;
				$emailDisplay = HtmlHelper::stringHTMLSafe($email->display);
			}
		}
		
		$this->addVar($field->fieldname, $emailTag);
		$this->addVar($field->fieldname.'_ADDRESS', $emailAddress);
		$this->addVar($field->fieldname.'_DISPLAY', $emailDisplay);
	}
	
	function _addVarHyperlink($field, $data)
	{
		$linkTitle = '';
		$linkTarget = '';
		$linkDisplay = '';
		
		if($data['VALUE'])
		{
			$settings = unserialize($field->settings);			
			$link = unserialize($data['VALUE']); 
			
			if($link->url)
			{
				$display = $link->display ? $link->display : $link->url;
				$linkTitle 		= $link->title;
				$linkTarget 	= $link->target;
				$linkDisplay 	= $link->display;
				$linkUrl 		=  $link->url;
				
				if($settings->outputMode == 0)
				{
					$linkTag = $link->url;
				}
				else
				{
					$linkTag = '<a href="' . $link->url . '" target="' . $link->target . '" title="' . $link->title . '">' . $display . '</a>';					
				}
				
				$this->addVar($field->fieldname, $linkTag);
			}
			else
			{
				$this->addVar($field->fieldname, '');
			}
			
			$this->addVar($field->fieldname.'_URL', $linkUrl);		
			$this->addVar($field->fieldname.'_TITLE', $linkTitle);		
			$this->addVar($field->fieldname.'_TARGET', $linkTarget);		
			$this->addVar($field->fieldname.'_DISPLAY', $linkDisplay);			
		}
	}

	function _addVarMultiSelectList($field, $data)
	{
		$tag = '';		
		$customFormat = ''; 
		$assocArray	= array();
		
		if($data['VALUE'])
		{
			$settings 			= unserialize($field->settings);
			$selectedOptions 	= unserialize($data['VALUE']);
			
			if(count($selectedOptions) > 0)
			{
				$customFormat .= $settings->preListTag; 
				
				foreach($selectedOptions as $optionValue)
				{
					if(array_key_exists($optionValue, $settings->listOptions))
					{
						$tag .= '<li>' . htmlspecialchars($settings->listOptions[$optionValue]) . '</li>';
						$customFormat .= $settings->preElementTag.$settings->listOptions[$optionValue].$settings->postElementTag;
						$assocArray[$optionValue] = $settings->listOptions[$optionValue];	
					}
				}
				
				$customFormat .= $settings->postListTag; 				
			}			
		}
	
		$this->addVar($field->fieldname, $tag);		
		$this->addVar($field->fieldname.'_CUSTOM_FORMAT', $customFormat);
		$this->addVar($field->fieldname.'_VALUES', $assocArray);
	}

	function _addVarInfoText($field, $data)
	{
		// Nothing to parse		
	}

	function _addVarDatePicker($field, $data)
	{
		$value = '';
		
		if($data['VALUE'])
		{
			$date = new JDate($data['VALUE']);
			$value= $date->toFormat($this->config->date_format);
		}

		$this->addVar($field->fieldname, $value);
	}

	function _addVarDisplayList($field, $data)
	{
		$output = '';
		
		if($data['VALUE'])
		{
			$settings = unserialize($field->settings);
			$values = unserialize($data['VALUE']);
						
			if($values)
			{
				foreach($values as $value)
				{
					$output .= '<li>'.htmlspecialchars($value).'</li>';
				}	
				
				if($settings->ordered)
				{
					$output = '<ol>'.$output.'</ol>';
				}
				else
				{
					$output = '<ul>'.$output.'</ul>';				
				}				
			}
		}
						
		$this->addVar($field->fieldname, $output);		
	}

	function _addVarFileUpload($field, $data)
	{
		if($data['VALUE'])
		{
			$settings = unserialize($field->settings);			
			$filename = $data['VALUE'];

			if($filename)
			{
				if($settings->outputMode == 0)
				{				
					$this->addVar($field->fieldname, Path::Combine(F2C_FileUpload::GetFileUrl($this->form->projectid, $this->form->id, $field->id), $filename));						
				}
				else
				{
					$this->addVar($field->fieldname, '<a href="'.Path::Combine(F2C_FileUpload::GetFileUrl($this->form->projectid, $this->form->id, $field->id), $filename).'" target="_blank">' . HtmlHelper::stringHTMLSafe($filename) . '</a>');
				}
				
				$this->addVar($field->fieldname.'_FILENAME', $filename);
				$this->addVar($field->fieldname.'_URL_RELATIVE', Path::Combine(F2C_FileUpload::GetFileUrl($this->form->projectid, $this->form->id, $field->id, true), $filename));
			}
			else
			{
				// no file was specified
				$this->addVar($field->fieldname, '');
				$this->addVar($field->fieldname.'_FILENAME', '');
				$this->addVar($field->fieldname.'_URL_RELATIVE', '');
			} 
		}			
	}

	function _addVarDatabaseLookup($field, $data)
	{
		if($data['VALUE'])
		{
			$settings 	= unserialize($field->settings);
			$value 		= $data['VALUE'];
			$text 		= '';
			$db 		=& JFactory::getDBO();			
			$db->setQuery($settings->query);				
			$rowList 	= $db->loadRowList(0);
			$text 		= $rowList[$value][1];			
		}	
			
		$this->addVar($field->fieldname, $value);
		$this->addVar($field->fieldname.'_TEXT', $text);
	}
	
	function _addVarGeoCoder($field, $data)
	{
		if($data)
		{
			$this->addVar($field->fieldname.'_ADDRESS', HtmlHelper::stringHTMLSafe($data['ADDRESS']));
			$this->addVar($field->fieldname.'_LAT', $data['LAT']);
			$this->addVar($field->fieldname.'_LON', $data['LON']);
		}
		else
		{
			$this->addVar($field->fieldname.'_ADDRESS', '');
			$this->addVar($field->fieldname.'_LAT', '');
			$this->addVar($field->fieldname.'_LON', '');
		}
	}
	
	function _addVarDatabaseLookupMulti($field, $data)
	{
		$output 	= '';		
		$settings 	= unserialize($field->settings);
		$db 		=& JFactory::getDBO();
		$assocArray	= array();
		$db->setQuery($settings->query);				
		$dicValues = $db->loadRowList(0);

		if(count($data))
		{
			foreach($data['VALUE'] as $value)
			{
				$output .= '<li>'.$dicValues[$value][1].'</li>';
				$assocArray[$value] = $dicValues[$value][1];
			}	
			
			if($settings->ordered)
			{
				$output = '<ol>'.$output.'</ol>';
			}
			else
			{
				$output = '<ul>'.$output.'</ul>';				
			}				
		}
		
		$this->addVar($field->fieldname.'_VALUES', $assocArray);
		$this->addVar($field->fieldname, $output);		
	}
	
	function getTemplateVars($formVars, &$usedVars)
	{
		foreach($this->templates as $templateName)
		{
			$this->_getTemplateVars($templateName, $formVars, $usedVars);
		}
	}
	
	function _getTemplateVars($templateName, $formVars, &$usedVars)
	{
		$contents = JFile::read(Path::Combine(F2C_Config::getTemplatePath(), $templateName));

		// check which vars are used within the template
		foreach($formVars as $formVarAlias => $formVarName)
		{
			if(strpos($contents, '{$'.$formVarAlias.'}') !== false)
			{
				$usedVars[] = strtoupper($formVarName);
			}

			if(strpos($contents, '{$'.$formVarAlias.'|') !== false)
			{
				$usedVars[] = strtoupper($formVarName);
			}
		}		
	} 	
}
?>