<?php
defined('_JEXEC') or die('Restricted acccess');

class F2C_FieldContent
{
	var $id;
	var $attribute;
	var $content;
	var $action;
	
	function F2C_FieldContent($id, $attribute, $content, $action)
	{
		$this->id 			= $id;
		$this->attribute 	= $attribute;
		$this->content 		= $content;
		$this->action		= $action;
	}
}

class F2C_Storage
{
	var $config;
	var $formId;
	var $backEnd;
	var $db;
	var $F2C_FIELD_FUNCTION_MAPPING = array();
	var $preparedData = null;
	
	function F2C_Storage($config, $formId, $backEnd)
	{
		$this->config	= $config;
		$this->formId 	= $formId;
		$this->backEnd 	= $backEnd;
		$this->db		=& JFactory::getDBO();

		$this->F2C_FIELD_FUNCTION_MAPPING = array(F2C_FIELDTYPE_SINGLELINE => 'SingleLineText',
												  F2C_FIELDTYPE_MULTILINETEXT => 'MultiLineText',
												  F2C_FIELDTYPE_MULTILINEEDITOR => 'MultiLineEditor',
												  F2C_FIELDTYPE_CHECKBOX => 'CheckBox',
												  F2C_FIELDTYPE_SINGLESELECTLIST => 'SingleSelectList', 
												  F2C_FIELDTYPE_IMAGE => 'Image',
												  F2C_FIELDTYPE_IFRAME => 'IFrame', 
												  F2C_FIELDTYPE_EMAIL => 'Email', 
												  F2C_FIELDTYPE_HYPERLINK => 'Hyperlink', 
										   	      F2C_FIELDTYPE_MULTISELECTLIST => 'MultiSelectList', 
												  F2C_FIELDTYPE_INFOTEXT => 'InfoText', 
												  F2C_FIELDTYPE_DATEPICKER => 'DatePicker', 
												  F2C_FIELDTYPE_DISPLAYLIST => 'DisplayList', 
												  F2C_FIELDTYPE_FILE => 'FileUpload', 
												  F2C_FIELDTYPE_DATABASE_LOOKUP => 'DatabaseLookup', 
												  F2C_FIELDTYPE_GEOCODER => 'GeoCoder',
												  F2C_FIELDTYPE_DB_LOOKUP_MULTI => 'DatabaseLookupMulti');		
	}
	
	function storeFields($fields)
	{
		foreach($fields as $field)
		{
			$this->storeField($field, $this->preparedData);
		}		
	}
	
	function storeField($field, $data)
	{

		$elementName		= 't' . $field->id;
		$functionName 		= '_store'.$this->F2C_FIELD_FUNCTION_MAPPING[$field->fieldtypeid];				
		$content 			= $this->$functionName($elementName, $field, $data);
		
		// Process the content if a value was provided.
		// In front-end skip fields that were not shown on the form
		if(($field->frontvisible || $this->backEnd) && count($content))
		{									
			foreach($content as $fieldContent)
			{
				switch($fieldContent->action)
				{
					case 'INSERT':
						$this->db->setQuery('INSERT INTO #__f2c_fieldcontent (formid, fieldid, attribute, content) VALUES ('.(int)$this->formId.','.(int)$field->id.','.$this->db->quote($fieldContent->attribute).','.$this->db->quote($fieldContent->content).')');
						$this->db->query();
						break;
					case 'UPDATE':
						$this->db->setQuery('UPDATE #__f2c_fieldcontent set content='.$this->db->quote($fieldContent->content).' WHERE id='.(int)$fieldContent->id);
						$this->db->query();
						break;
					case 'DELETE':
						$this->db->setQuery('DELETE FROM #__f2c_fieldcontent WHERE id='.(int)$fieldContent->id);
						$this->db->query();							
						break;
					default: 
						// do nothing
						break;
				}														
			}
		}
	}
	
	function _storeSingleLineText($elementName, $field, $data)
	{
		$content 	= array();
		$value 		= $data[$elementName];
		$fieldId	= $data[$elementName.'_fieldid'];
		$action 	= ($value != '') ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}
	
	function _storeMultiLineText($elementName, $field, $data)
	{
		$content 	= array();				
		$value 		= $data[$elementName];
		$fieldId	= $data[$elementName.'_fieldid'];
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		
		if($field->settings)
		{
			$multiLineTextSettings = unserialize($field->settings);
			
			if($multiLineTextSettings->maxNumChars != 0)
			{
				if(function_exists('mb_substr_count') && function_exists('mb_substr'))
				{
					$numNewLines = mb_substr_count ($value, "\r\n", 'UTF-8');
					$value = mb_substr($value, 0, $multiLineTextSettings->maxNumChars + $numNewLines, 'UTF-8');
				}
				else
				{
					$numNewLines = substr_count ($value, "\r\n");
					$value = substr($value, 0, $multiLineTextSettings->maxNumChars + $numNewLines);
				}
			}
		}
							
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}
	
	function _storeMultiLineEditor($elementName, $field, $data)
	{
		$content 	= array();					
		$value 		= $data[$elementName];
		$fieldId	= $data[$elementName.'_fieldid'];
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}
	
	function _storeCheckBox($elementName, $field, $data)
	{
		$content 	= array();					
		$value 		= $data[$elementName];
		$fieldId	= $data[$elementName.'_fieldid'];
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);

		return $content;		
	}
	
	function _storeSingleSelectList($elementName, $field, $data)
	{
		$content 	= array();					
		$value 		= $data[$elementName];
		$fieldId	= $data[$elementName.'_fieldid'];
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}
	
	function _storeImage($elementName, $field, $data)
	{
		$content 	= array();				
		$fieldId 	= $data[$elementName.'_fieldid'];						
		$image 		= new F2C_Image();
	
		if($data[$elementName.'_del'])
		{
			$image->filename = $data[$elementName.'_filename'];
			$image->DeleteImages($field->projectid, $this->formId);
			$image->filename = '';
			$image->alt = '';
			$image->title = '';
		}
		else
		{			
			switch($data[$elementName.'_method'])
			{
				case 'upload':				
					$uploadfile = $data[$elementName.'_fileupload'];

					if($uploadfile['size'])
					{						
						// delete current image, if there is one
						if($fieldId)
						{
							$this->db->setQuery('SELECT * FROM #__f2c_fieldcontent WHERE id='.(int)$fieldId);
							$fieldContent = $this->db->loadObject();
		
							if($fieldContent->content)
							{
								$currentImage = unserialize($fieldContent->content);
								$currentImage->DeleteImages($field->projectid, $this->formId);							
							}
						}
								
						// Store the uploaded image
						$maxImageWidth			= 10000;
						$maxImageHeight			= 10000;
						$uploadFileName 		= $uploadfile['name'];
						$imagePath 				= Path::Combine(F2C_Image::GetImagesRootPath(), 'p'.$field->projectid);				
						$imagePath 				= Path::Combine($imagePath, 'f'.$this->formId);				
						$thumbsPath 			= Path::Combine($imagePath, 'thumbs');
						$imageFileName 			= F2C_Image::CreateFullImageName($uploadFileName, $field->id);
						$imageFileLocation 		= Path::Combine($imagePath, $imageFileName);
						$imageFileLocationTmp 	= Path::Combine($imagePath, '~'.$imageFileName);
						$thumbnailLocation 		= Path::Combine($thumbsPath, F2C_Image::CreateThumbnailImageName($uploadFileName, $field->id));
						
						if($field->settings)
						{
							$imageFieldSettings = unserialize($field->settings);
							$maxImageWidth 		=  $imageFieldSettings->width;
							$maxImageHeight 	=  $imageFieldSettings->height;
						}
		
						if(!JFolder::exists($thumbsPath)) JFolder::create($thumbsPath);
						
						if(JFile::upload($uploadfile['tmp_name'], $imageFileLocationTmp))
						{			
							$image->filename = $imageFileName;								
							
							// resize image
							if(!ImageHelper::ResizeImage($imageFileLocationTmp, $imageFileLocation, $maxImageWidth, $maxImageHeight, $this->config->jpeg_quality))
							{
								JError::raiseError(401,JText::_('ERROR_IMAGE_RESIZE_FAILED'));
								return false;
							}
							
							$image->width = $maxImageWidth;
							$image->height = $maxImageHeight;
							
							// create thumbnail image
							$defaultThumbnailWidth = (array_key_exists('default_thumbnail_width',get_object_vars($this->config)) && (int)$this->config->default_thumbnail_width) ? (int)$this->config->default_thumbnail_width : F2C_DEFAULT_THUMBNAIL_WIDTH;
							$defaultThumbnailHeight = (array_key_exists('default_thumbnail_height',get_object_vars($this->config)) && (int)$this->config->default_thumbnail_height) ? (int)$this->config->default_thumbnail_height : F2C_DEFAULT_THUMBNAIL_HEIGHT;
							$thumbnailWidth = ($imageFieldSettings->thumbnailWidth) ? $imageFieldSettings->thumbnailWidth : $defaultThumbnailWidth;
							$thumbnailHeight = ($imageFieldSettings->thumbnailHeight) ? $imageFieldSettings->thumbnailHeight : $defaultThumbnailHeight;
							
							if(!ImageHelper::ResizeImage($imageFileLocationTmp, $thumbnailLocation, $thumbnailWidth, $thumbnailHeight, $this->config->jpeg_quality))
							{
								JError::raiseError(401,JText::_('ERROR_IMAGE_RESIZE_FAILED'));
								return false;
							}
							
							$image->widthThumbnail = $thumbnailWidth;
							$image->heightThumbnail = $thumbnailHeight;
							
							JFile::delete($imageFileLocationTmp);								
						}				
					}
					else
					{
						$image->filename = $data[$elementName.'_filename'];
					}				
					break;
					
				case 'copy':
					$srcImage 				= $data[$elementName.'_location'];
					$srcThumb 				= $data[$elementName.'_thumblocation'];
					$filename				= $data[$elementName.'_filename'];						
					$imagePath 				= Path::Combine(F2C_Image::GetImagesRootPath(), 'p'.$field->projectid);				
					$imagePath 				= Path::Combine($imagePath, 'f'.$this->formId);				
					$thumbsPath 			= Path::Combine($imagePath, 'thumbs');
					$imageFileName 			= F2C_Image::CreateFullImageName($filename, $field->id);
					$imageFileLocation 		= Path::Combine($imagePath, $imageFileName);
					$thumbnailLocation 		= Path::Combine($thumbsPath, F2C_Image::CreateThumbnailImageName($filename, $field->id));
					
					JFolder::create($thumbsPath);				
					JFile::copy($srcImage, $imageFileLocation);
					JFile::copy($srcThumb, $thumbnailLocation);
					
					list($width, $height, $type, $attr) = getimagesize($imageFileLocation);
					list($widthThumb, $heightThumb, $typeThumb, $attrThumb) = getimagesize($thumbnailLocation);
					
					$image->filename = $filename;
					$image->width = $width;
					$image->height = $height;
					$image->widthThumbnail = $widthThumb;
					$image->heightThumbnail = $heightThumb;
					break;
			}
			
			
			$image->alt 	= $data[$elementName.'_alt'];
			$image->title 	= $data[$elementName.'_title'];		
		}				
		
		$value 		= serialize($image);
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');				
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;	
	}
	
	function _storeIFrame($elementName, $field, $data)
	{
		$content 		= array();		
		$iframe 		= new F2C_IFrame();
		$fieldId		= $data[$elementName.'_fieldid'];
		$iframe->url	= $data[$elementName];
		$iframe->width 	= $data[$elementName.'_width'];
		$iframe->height = $data[$elementName.'_height'];
		$value 			= serialize($iframe);
		$action 		= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 		= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}
	
	function _storeEmail($elementName, $field, $data)
	{
		$content 		= array();					
		$email 			= new F2C_Email();
		$fieldId		= $data[$elementName.'_fieldid'];
		$email->email	= $data[$elementName];
		$email->display	= $data[$elementName.'_display'];
		$value 			= serialize($email);
		$action 		= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 		= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}
	
	function _storeHyperlink($elementName, $field, $data)
	{
		$content 		= array();					
		$link 			= new F2C_Link();
		$fieldId		= $data[$elementName.'_fieldid'];
		$link->url		= $data[$elementName];
		$link->display	= $data[$elementName.'_display'];
		$link->title 	= $data[$elementName.'_title'];
		$link->target 	= $data[$elementName.'_target'];
		$value 			= serialize($link);
		$action 		= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 		= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}
	
	function _storeMultiSelectList($elementName, $field, $data)
	{
		$content 		= array();
		$fieldId		= $data[$elementName.'_fieldid'];
		$selections		= $data[$elementName];
		$multiListNew 	= null;
		
		if($selections)
		{
			foreach($selections as $value)
			{
				if(!$multiListNew || !array_key_exists($value, $multiListNew))
				{										
					$multiListNew[] = $value;
				}
			}
		}
		
		$value 		= ($multiListNew) ? serialize($multiListNew) : '';
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;				
	}
	
	function _storeInfoText($elementName, $field, $data)
	{
		$content = array();
		return $content;
	}
	
	function _storeDatePicker($elementName, $field, $data)
	{
		$content	= array();
		$fieldId	= $data[$elementName.'_fieldid'];
		$value		= $data[$elementName];
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;		
	}

	function _storeFileUpload($elementName, $field, $data)
	{
		$content 	= array();					
		$fileUpload = new F2C_FileUpload();
		$fieldId	= $data[$elementName.'_fieldid'];			
		
		$this->db->setQuery('SELECT * FROM #__f2c_fieldcontent WHERE id='.(int)$fieldId);
		$fieldContent = $this->db->loadObject();
		
		if($fieldContent) 
		{
			$fileUpload->filename = $fieldContent->content;
		}
									
		if($data[$elementName.'_del'])
		{
			$fileUpload->DeleteFile($field->projectid, $this->formId, $field->id);
			$fileUpload->filename = '';
		}
		else
		{
			switch($data[$elementName.'_method'])
			{
				case 'upload':
					$uploadfile	= $data[$elementName.'_fileupload'];
					
					if($uploadfile['size'])
					{						
						// check extension
						if($field->settings)
						{
							$fileSettings = unserialize($field->settings);
							$extension = strtolower(JFile::getExt($uploadfile['name']));
		
							if(count($fileSettings->whiteList))
							{
								if(!array_key_exists($extension, $fileSettings->whiteList))
								{
									JError::raiseError(401,sprintf(JText::_('ERROR_FILE_UPLOAD_EXTENSION_NOT_ALLOWED'), $extension));
									return false;
								}
							}
		
							if(count($fileSettings->blackList))
							{
								if(array_key_exists($extension, $fileSettings->blackList))
								{
									JError::raiseError(401,sprintf(JText::_('ERROR_FILE_UPLOAD_EXTENSION_NOT_ALLOWED'), $extension));
									return false;
								}
							}
						}
											
						if($fieldId)
						{
							// delete previous file							
							$fileUpload->DeleteFile($fieldId, $this->formId, $field->id);
						}
						
						$fileUpload->filename 	= $uploadfile['name'];
						$fileLocation 			= Path::Combine(F2C_FileUpload::GetFilePath($field->projectid, $this->formId, $field->id), $fileUpload->filename);
						
						if(JFile::upload($uploadfile['tmp_name'], $fileLocation))
						{			
						}						
					}	
					
					$value = $fileUpload->filename;
					break;
					
				case 'copy':
					$src = $data[$elementName.'_location'];
					$dstFolder = F2C_FileUpload::GetFilePath($field->projectid, $this->formId, $field->id);
					$dst = Path::Combine($dstFolder, $data[$elementName.'_filename']);
					JFolder::create($dstFolder);					
					JFile::copy($src, $dst);
					$value = $data[$elementName.'_filename'];
					break;
			}
						
		}				
		
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');				
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);		

		return $content;
	}
	
	function _storeDatabaseLookup($elementName, $field, $data)
	{
		$content 	= array();
		$value 		= $data[$elementName];
		$fieldId	= $data[$elementName.'_fieldid'];
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		return $content;
	}
	
	function _storeDisplayList($elementName, $field, $data)
	{
		$content	= array();							
		$fieldId	= JRequest::getInt('hid'.$elementName);		
		$listNew 	= null;

		if(count($data[$elementName.'_rowkey']))
		{
			foreach($data[$elementName.'_rowkey'] as $rowKey)
			{ 
				$val = $data[$elementName.'_row'.$rowKey];

				if($val != '')
				{
					if(!$listNew || !array_key_exists($val, $listNew))
					{	
						
						$listNew[] = $val;
					}
				}						
			}
		}
		
		$value 		= serialize($listNew);		
		$action 	= ($value) ? (($fieldId) ? 'UPDATE' : 'INSERT') : (($fieldId) ? 'DELETE' : '');
		$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $value, $action);
		
		return $content;
	}
	
	function _storeGeoCoder($elementName, $field, $data)
	{
		$addressId		= $data[$elementName.'_addressid'];
		$addressValue 	= $data[$elementName.'_address'];		
		$latId			= $data[$elementName.'_latid'];
		$latValue		= $data[$elementName.'_lat'];
		$lonId			= $data[$elementName.'_lonid'];
		$lonValue 		= $data[$elementName.'_lon'];		
		
		if($addressId)
		{
			// existing record
			$action = (!$addressValue && !$latValue && !$lonValue) ? 'DELETE' : 'UPDATE';
		}
		else
		{
			// new record
			$action = ($addressValue || $latValue || $lonValue) ? 'INSERT' : '';
		}
		
		$content 	= array();					
		$content[] 	= new F2C_FieldContent($addressId, 'ADDRESS', $addressValue, $action);
		$content[] 	= new F2C_FieldContent($latId, 'LAT', $latValue, $action);
		$content[] 	= new F2C_FieldContent($lonId, 'LON', $lonValue, $action);
		
		return $content;					
	}
	
	function _storeDatabaseLookupMulti($elementName, $field, $data)
	{
		$content	= array();							
		$fieldId	= JRequest::getInt('hid'.$elementName);		

		if(count($data[$elementName.'_rowkey']))
		{
			foreach($data[$elementName.'_rowkey'] as $rowKey)
			{ 
				$val = $data[$elementName.'_row'.$rowKey];

				$content[] 	= new F2C_FieldContent($fieldId, 'VALUE', $val, 'INSERT');
			}
		}

		// Remove all previous entries
		$this->db->setQuery('DELETE FROM #__f2c_fieldcontent WHERE formid='.$this->formId.' AND fieldid='.$fieldId);
		$this->db->query();		
				
		return $content;
	}
	
	function prepareSubmittedData($fields)
	{
		$this->preparedData = array();
		
		foreach($fields as $field)
		{
			$functionName = '_prepare'.$this->F2C_FIELD_FUNCTION_MAPPING[$field->fieldtypeid];
			$this->$functionName('t' . $field->id, $field, $this->preparedData);		
		}
	}
	
	function _prepareSingleLineText($elementName, $field, &$data)
	{
		$data[$elementName] = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW));
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);
	}
	
	function _prepareMultiLineText($elementName, $field, &$data)
	{
		$data[$elementName] = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW)); 
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);
	}
	
	function _prepareMultiLineEditor($elementName, $field, &$data)
	{
		$data[$elementName] = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW)); 
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);
	}
	
	function _prepareCheckBox($elementName, $field, &$data)
	{
		$data[$elementName] = unquoteData(JRequest::getString($elementName));
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);
	}
	
	function _prepareSingleSelectList($elementName, $field, &$data)
	{
		$data[$elementName] = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW)); 
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);
	}
	
	function _prepareImage($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] 		= JRequest::getInt('hid'.$elementName);
		$data[$elementName.'_method']		= 'upload';
		$data[$elementName.'_del'] 			= JRequest::getVar($elementName . '_del');
		$data[$elementName.'_filename'] 	= JRequest::getString($elementName . '_filename');
		$data[$elementName.'_fileupload'] 	= JRequest::getVar($elementName . '_fileupload', '', 'files', 'array');
		$data[$elementName.'_alt'] 			= unquoteData(JRequest::getString($elementName . '_alt'));
		$data[$elementName.'_title'] 		= unquoteData(JRequest::getString($elementName . '_title'));
	}
	
	function _prepareIFrame($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] 	= JRequest::getInt('hid'.$elementName);
		$data[$elementName]				= unquoteData(JRequest::getString($elementName));		
		$data[$elementName.'_width'] 	= JRequest::getInt($elementName . '_width');
		$data[$elementName.'_height'] 	= JRequest::getInt($elementName . '_height');
	}
	
	function _prepareEmail($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] 	= JRequest::getInt('hid'.$elementName);
		$data[$elementName]				= unquoteData(JRequest::getString($elementName));		
		$data[$elementName.'_display'] 	= unquoteData(JRequest::getString($elementName . '_display'));
	}
	
	function _prepareHyperlink($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] 	= JRequest::getInt('hid'.$elementName);
		$data[$elementName]				= unquoteData(JRequest::getString($elementName));		
		$data[$elementName.'_display'] 	= unquoteData(JRequest::getString($elementName . '_display'));
		$data[$elementName.'_title'] 	= unquoteData(JRequest::getString($elementName . '_title'));
		$data[$elementName.'_target'] 	= unquoteData(JRequest::getString($elementName . '_target'));
	}
	
	function _prepareMultiSelectList($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] 	= JRequest::getInt('hid'.$elementName);
		$data[$elementName]				= JRequest::getVar($elementName);		
	}
	
	function _prepareInfoText($elementName, $field, &$data)
	{
	}
	
	function _prepareDatePicker($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] 	= JRequest::getInt('hid'.$elementName);
		$data[$elementName] = '';
		
		$value = unquoteData(JRequest::getString($elementName));
		
		if($value)
		{
			$date = ParseDate($value, $this->config->date_format);
			$data[$elementName] = ($date) ? $date->toISO8601() : '';						
		}
	}

	function _prepareFileUpload($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] 		= JRequest::getInt('hid'.$elementName);
		$data[$elementName.'_method']		= 'upload';
		$data[$elementName.'_del'] 			= JRequest::getVar($elementName . '_del');
		$data[$elementName.'_fileupload'] 	= JRequest::getVar($elementName . '_fileupload', '', 'files', 'array');
	}
	
	function _prepareDatabaseLookup($elementName, $field, &$data)
	{
		$data[$elementName] = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW)); 
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);
	}
	
	function _prepareDisplayList($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);		
		$data[$elementName.'_rowkey'] = Jrequest::getVar($elementName.'RowKey', array());

		if(count($data[$elementName.'_rowkey']))
		{
			foreach($data[$elementName.'_rowkey'] as $rowKey)
			{
				$data[$elementName.'_row'.$rowKey] = JRequest::getVar($rowKey . 'val', '', 'post', 'string', JREQUEST_ALLOWRAW);
			}
		}
	}
	
	function _prepareGeoCoder($elementName, $field, &$data)
	{
		$data[$elementName.'_addressid']	= JRequest::getInt('hid'.$elementName.'_address');
		$data[$elementName.'_address'] 		= unquoteData(JRequest::getString($elementName.'_address'));		
		$data[$elementName.'_latid']		= JRequest::getInt('hid'.$elementName.'_lat');
		$data[$elementName.'_lat'] 			= unquoteData(JRequest::getString($elementName.'_hid_lat'));
		$data[$elementName.'_lonid']		= JRequest::getInt('hid'.$elementName.'_lon');
		$data[$elementName.'_lon'] 			= unquoteData(JRequest::getString($elementName.'_hid_lon'));		
	}
	
	function _prepareDatabaseLookupMulti($elementName, $field, &$data)
	{
		$data[$elementName.'_fieldid'] = JRequest::getInt('hid'.$elementName);		
		$data[$elementName.'_rowkey'] = Jrequest::getVar($elementName.'RowKey', array());

		if(count($data[$elementName.'_rowkey']))
		{
			foreach($data[$elementName.'_rowkey'] as $rowKey)
			{
				$data[$elementName.'_row'.$rowKey] = JRequest::getVar($rowKey . 'val', '', 'post', 'string', JREQUEST_ALLOWRAW);
			}
		}
	}		
}
?>
