<?php
defined('_JEXEC') or die('Restricted acccess');

jimport('joomla.html.pagination');
jimport('joomla.utilities.date');

class Path
{
	function Combine($path, $fileName)
	{
		return rtrim($path, "/\\") . '/' . $fileName;
	}	
}

class F2C_FileInfo
{
	var $id;
	var $fileName;
	var $fileLocation;
	var $fileSize;
	var $fileExtension;
	
	function F2C_FileInfo($fileLocation, $fileName)
	{
		$this->id = $fileLocation.$fileName;
		$this->fileName = $fileName;
		$this->fileLocation = $fileLocation;
		$this->fileExtension = JFile::getExt($this->id);
		$this->fileSize = F2C_FileInfo::FormatFileSize(filesize($this->id));
	}
	
	function FormatFileSize($filesize)
	{	
		if($filesize > 1024 * 1024)
		{
			$filesize = round($filesize / (1024 * 1024), 2);
			return $filesize . ' Mb';
		}
	
		if($filesize > 1024)
		{
			$filesize = round($filesize / 1024, 2);
			return $filesize . ' kb';
		}
		
		return $filesize . ' bytes';
	}
}

class ImageHelper
{
    function ResizeImage($srcFile, $dstFile = null, &$dstWidth, &$dstHeight, $jpegQuality = 75) 
    {
		// Initialize variables
		jimport('joomla.client.helper');
		$FTPOptions = JClientHelper::getCredentials('ftp');
    	
		if(!ImageHelper::isGdiLibInstalled())
		{
			JError::raiseError("ResizeImage(): Missing GD Libraries");
			return false;
		}
    	
    	if(!$dstFile)
    	{
			$dstFile = $srcFile;    		
    	}
    	
    	$fileExt = strtolower(JFile::getExt($srcFile));

		if($fileExt != 'gif' && $fileExt != 'jpg' && $fileExt != 'jpeg' && $fileExt != 'png')
		{
			JError::raiseError("ResizeImage(): Invalid file extension: {$fileExt}");
			return false;			
		}
		
		if($dstWidth == 0 || $dstHeight == 0) 
		{
			JError::raiseError("ResizeImage(): Invalid size value (w:{$dstWidth}, h:{$dstHeight})");
			return false;
		}
		
		list($srcWidth, $srcHeight, $imgType) = getimagesize($srcFile);
		
		if(!$srcWidth || !$srcHeight || !$imgType) 
		{
			JError::raiseError("ResizeImage(): Cannot retrieve image information; not a valid image");			

			if(!unlink($srcFile))
			{
				JError::raiseError("ResizeImage(): Cannot delete file");
			}
			
			return false;
		}
		
    	if($srcWidth == 0 || $srcHeight == 0) 
    	{
			JError::raiseError("ResizeImage(): Invalid size value for source image (original width: {$srcWidth}, original height:{$srcHeight})");
			return false;
		}
		
    	if(($srcWidth < $dstWidth) && ($srcHeight < $dstHeight))
    	{
    		// No resize necessary: fill the output parameters
    		$dstWidth = $srcWidth;
    		$dstHeight = $srcHeight;
    		
    		if($srcFile == $dstFile)
    		{
    			return true;
    		}
    		    		
    		return JFile::copy($srcFile, $dstFile);
    	}
    	
    	$srcRatio = $srcWidth / $srcHeight;

		if($dstWidth / $dstHeight > $srcRatio)
		{
		   $dstWidth = $dstHeight * $srcRatio;
		}
		else
		{
		   $dstHeight = $dstWidth / $srcRatio;
		}

		$dstHeight = (int)ceil($dstHeight);
		$dstWidth = (int)ceil($dstWidth);

		if(!($dstImage = imagecreatetruecolor($dstWidth, $dstHeight)))
		{
			return false;
		}
		    			
		switch($imgType)
		{
			case 1: // gif
				if(!($srcImage = imagecreatefromgif($srcFile))) 
				{
					JError::raiseError("ResizeImage(): Invalid GIF file");
					return false;
				}
				
				$colorcount = imagecolorstotal($srcImage);
				
				if($colorcount)
				{
					imagetruecolortopalette($dstImage, true, $colorcount);
				}
				
				imagepalettecopy($dstImage,$srcImage);
				$transparentcolor = imagecolortransparent($srcImage);
				
				if($transparentcolor > -1)
				{
					imagefill($dstImage,0,0,$transparentcolor);
				}
				
				imagecolortransparent($dstImage,$transparentcolor);
				imagecopyresampled($dstImage, $srcImage, 0,0,0,0, $dstWidth, $dstHeight, $srcWidth, $srcHeight); 
				
				if ($FTPOptions['enabled'] == 1)
				{
					ob_start();

					if(!(imagegif($dstImage, null)))
					{
						ob_end_clean();
						JError::raiseError("ResizeImage(): Could not create buffered GIF file");
						return false;
					}
					
					$imgGifData = ob_get_contents();
					ob_end_clean();
					
					if(!JFile::write($dstFile, $imgGifData)) 
					{
						JError::raiseError("ResizeImage(): Could not create GIF file (JFile write)");
						return false;
					}
				}
				else
				{
					if(!(imagegif($dstImage, $dstFile)))
					{
						JError::raiseError("ResizeImage(): Could not create GIF file (Direct write)");
						return false;
					}
				}
				
				break;
				
			case 2: // jpg
				if(!($srcImage = imagecreatefromjpeg($srcFile)))
				{
					JError::raiseError("ResizeImage(): Invalid JPG file");
					return false;
				}
			
				Imagefill($dstImage, 0, 0, imagecolorallocate($dstImage, 255, 255, 255));
				imagecopyresampled($dstImage, $srcImage, 0,0,0,0, $dstWidth, $dstHeight, $srcWidth, $srcHeight);

				if ($FTPOptions['enabled'] == 1)
				{
					ob_start();

					if(!(imagejpeg($dstImage, null, $jpegQuality)))
					{
						ob_end_clean();
						JError::raiseError("ResizeImage(): Could not create buffered JPG file");
						return false;
					}
					
					$imgJpgData = ob_get_contents();
					ob_end_clean();
					
					if(!JFile::write( $dstFile, $imgJpgData)) 
					{
						JError::raiseError("ResizeImage(): Could not create JPG file (JFile write)");
						return false;
					}
				}
				else
				{
					if(!(imagejpeg($dstImage, $dstFile, $jpegQuality)))
					{
						JError::raiseError("ResizeImage(): Could not create JPG file (Direct write)");
						return false;
					}
				}
				break;
				
			case 3: // png
				if(!($srcImage = imagecreatefrompng($srcFile)))
				{
					JError::raiseError("ResizeImage(): Invalid PNG file");
					return false;
				}
			
				imagealphablending($dstImage, false);
	            $colorTransparent = imagecolorallocatealpha($dstImage, 0, 0, 0, 127);
	            imagefill($dstImage, 0, 0, $colorTransparent);
	            imagesavealpha($dstImage, true);
				imagecopyresampled($dstImage, $srcImage, 0,0,0,0, $dstWidth, $dstHeight, $srcWidth, $srcHeight); 
			
				if ($FTPOptions['enabled'] == 1)
				{
					ob_start();

					if(!(imagepng($dstImage, null)))
					{
						ob_end_clean();
						JError::raiseError("ResizeImage(): Could not create buffered PNG file");
						return false;
					}
					
					$imgPngData = ob_get_contents();
					ob_end_clean();
					
					if(!JFile::write($dstFile, $imgPngData)) 
					{
						JError::raiseError("ResizeImage(): Could not create PNG file (JFile write)");
						return false;
					}
				}
				else
				{
					if(!(imagepng($dstImage, $dstFile)))
					{
						JError::raiseError("ResizeImage(): Could not create PNG file (Direct write)");
						return false;
					}
				}
												
				break;
		}

		imagedestroy($dstImage);
		imagedestroy($srcImage);
		return true;
    }
    
    function isGdiLibInstalled()
    {
    	if((!function_exists('imagecreatetruecolor')) 	|| (!function_exists('imagecreatefromgif')) 	||
		   (!function_exists('imagecopyresampled'))		|| (!function_exists('imagegif')) 				||
		   (!function_exists('imagecreatefromgif')) 	|| (!function_exists('imagecreatefromjpeg')) 	||
		   (!function_exists('imagecreatefrompng'))		|| (!function_exists('imagecolorstotal'))		||
		   (!function_exists('imagecolortransparent'))	|| (!function_exists('imagefill'))				||
		   (!function_exists('imagetruecolortopalette'))|| (!function_exists('imagepalettecopy')))
		{		
			return false;
		}
		else
		{
			return true;
		}
    }	
}

class JPaginationClient extends JPagination
{
	/**
	 * Return the icon to move an item UP
	 *
	 * @access	public
	 * @param	int		$i The row index
	 * @param	boolean	$condition True to show the icon
	 * @param	string	$task The task to fire
	 * @param	string	$alt The image alternate text string
	 * @return	string	Either the icon to move an item up or a space
	 * @since	1.0
	 */
	function orderUpCustomIcon($i, $condition = true, $task = 'orderup', $alt = 'Move Up', $enabled = true, $icon='images/uparrow.png', $iconDisabled='images/uparrow0.png')
	{
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i > 0 || ($i + $this->limitstart > 0)) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '   <img src="'.$icon.'" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="'.$iconDisabled.'" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}

	/**
	 * Return the icon to move an item DOWN
	 *
	 * @access	public
	 * @param	int		$i The row index
	 * @param	int		$n The number of items in the list
	 * @param	boolean	$condition True to show the icon
	 * @param	string	$task The task to fire
	 * @param	string	$alt The image alternate text string
	 * @return	string	Either the icon to move an item down or a space
	 * @since	1.0
	 */
	function orderDownCustomIcon($i, $n, $condition = true, $task = 'orderdown', $alt = 'Move Down', $enabled = true, $icon='images/downarrow.png', $iconDisabled='images/downarrow0.png')
	{
		$alt = JText::_($alt);

		$html = '&nbsp;';
		if (($i < $n -1 || $i + $this->limitstart < $this->total - 1) && $condition)
		{
			if($enabled) {
				$html	= '<a href="#reorder" onclick="return listItemTask(\'cb'.$i.'\',\''.$task.'\')" title="'.$alt.'">';
				$html	.= '  <img src="'.$icon.'" width="16" height="16" border="0" alt="'.$alt.'" />';
				$html	.= '</a>';
			} else {
				$html	= '<img src="'.$iconDisabled.'" width="16" height="16" border="0" alt="'.$alt.'" />';
			}
		}

		return $html;
	}
}

class ContentHelper
{
	function filterCategory($query, $active = NULL)
	{
		// Initialize variables
		$db	= & JFactory::getDBO();

		$categories[] = JHTML::_('select.option', '0', '- '.JText::_('Select Category').' -');
		$db->setQuery($query);
		$categories = array_merge($categories, $db->loadObjectList());

		$category = JHTML::_('select.genericlist',  $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $active);

		return $category;
	}
	
	function syncArticleOrder($catid)
	{
		$db	= & JFactory::getDBO();
		
		$sql =	'UPDATE #__content c INNER JOIN #__f2c_form f ON f.reference_id = c.id ' .
				'SET c.ordering = f.ordering WHERE f.catid = ' . (int)$catid;
		$db->setQuery($sql);
		$db->query();
	}
	
	function encodeParameters($name)
	{
		$params	= JRequest::getVar($name, null, 'post', 'array');

		// Build parameter INI string
		if (is_array($params))
		{
			$txt = array ();
			foreach ($params as $k => $v) 
			{
				$txt[] = "$k=$v";
			}
			return implode("\n", $txt);
		}		
	}	
}

function ParseDate($date, $format)
{
	$day = 0;
	$month = 0;
	$year = 0;
	$date = trim($date);
	
	if(stristr($date, ' ') === FALSE)
	{
		$date .= ' 00:00:00';
	}
	
	list($datePart, $timePart) = explode(' ', $date);

	$dateFormat = explode('-', $format); 
	$dateParts = explode('-', $datePart);
	$timeParts = explode(':', $timePart);

	if(count($dateParts) != 3)
	{
		return false;
	}

	if(count($timeParts) == 1)
	{
		$timeParts[1] = '00';
		$timeParts[2] = '00';
	}

	if(count($timeParts) == 2)
	{
		$timeParts[2] = '00';
	}

	$timeParts[0] = (int)$timeParts[0];
	$timeParts[1] = (int)$timeParts[1];
	$timeParts[2] = (int)$timeParts[2];
	
	if(!checktime($timeParts[0], $timeParts[1], $timeParts[2]))
	{
		return false;
	}
			
	for($i = 0; $i < count($dateFormat); $i++)
	{
		switch($dateFormat[$i])
		{
			case '%d':
				$day = (int)$dateParts[$i];
				break;
			case '%m':
				$month = (int)$dateParts[$i];
				break;
			case '%Y':
				$year = (int)$dateParts[$i];
				break;
		}
	}
	
	
	if(checkdate($month, $day, $year))
	{
		return new JDate($year.'-'.$month.'-'.$day. ' '.$timeParts[0].':'.$timeParts[1].':'.$timeParts[2]);
	}
	else
	{
		return false;
	}
}

function checktime($hours, $minutes, $seconds)
{
	if($hours < 0 || $hours > 23)
	{
		return false;
	}

	if($minutes < 0 || $minutes[1] > 59)
	{
		return false;
	}

	if($seconds < 0 || $seconds > 59)
	{
		return false;
	}
	
	return true;
}

class F2C_AdminHelper
{
	function generateSampleTemplate($contentTypeId)
	{
		$this->_db->setQuery("SELECT title FROM #__f2c_project WHERE id=$contentTypeId");
		$projectTitle = JFile::makeSafe($this->_db->loadResult());
	
		$template = '';		
		$template .= 'This template is based on the Smarty template engine<br/>'."\n";
		$template .= 'Please find the documentation at <a href="http://www.form2content.com/documentation" target="_blank">http://www.form2content.com/documentation</a>.<br/>'."\n";
		$template .= 'The list of all possible template parameters can be found <a href="http://www.form2content.com/f2c-joomla/pro/f2c-documentation/16-form2content-template-parameters" target="_blank">here</a>.<hr/>'."\n";
		$template .= '<h1>{$JOOMLA_TITLE}</h1>'."\n";		
		$template .= "<p>This is an automatically generated default intro template - please do not edit.</p>\n";			
		$template .= '<hr/>'."\n";
		
		$this->_db->setQuery("SELECT fieldname, fieldtypeid FROM #__f2c_projectfields WHERE projectid=$contentTypeId ORDER BY ordering");
		$rows = $this->_db->loadObjectList();
		
		for ($i=0, $n=count($rows); $i < $n; $i++) 
	    {
	      	$row = $rows[$i];
	      
	      	switch(intval($row->fieldtypeid))
	      	{
	      		case F2C_FIELDTYPE_SINGLESELECTLIST: 
	      		case F2C_FIELDTYPE_DATABASE_LOOKUP:
	      			$template .= $row->fieldname.' (value): {$'.strtoupper($row->fieldname)."}<br/>\n";			
	      			$template .= $row->fieldname.' (text): {$'.strtoupper($row->fieldname)."_TEXT}\n";
	      			break;
	      			
	      		case F2C_FIELDTYPE_MULTISELECTLIST:
  					$template .= $row->fieldname.': <ul>{$'.strtoupper($row->fieldname)."}</ul>\n";			
	      			break;

	      		case F2C_FIELDTYPE_FILE:
	      			$template .= $row->fieldname.' (url): {$'.strtoupper($row->fieldname)."}<br/>\n";			
	      			$template .= $row->fieldname.' (filename): {$'.strtoupper($row->fieldname)."_FILENAME}\n";			
	      			break;
	      			
	      		case F2C_FIELDTYPE_GEOCODER:
	      			$template .= $row->fieldname.' (addres): {$'.strtoupper($row->fieldname)."_ADDRESS}<br/>\n";			
	      			$template .= $row->fieldname.' (latitude): {$'.strtoupper($row->fieldname)."_LAT}<br/>\n";			
	      			$template .= $row->fieldname.' (longitude): {$'.strtoupper($row->fieldname)."_LON}\n";			
	      			break;

	      		default:
	      			$template .= $row->fieldname.': {$'.strtoupper($row->fieldname)."}\n";			
	      			break;
	      	}
	      	
   			$template .= '<hr/>';			
		}
	
		$fileName = Path::Combine(F2C_Config::getTemplatePath(), 'default_intro_template_' .$projectTitle.'.tpl');
		JFile::write($fileName, $template);
		
		$template = "";	
		$template .= "<hr/>\n";
		$template .= "<p>This is an automatically generated default main template - please do not edit.</p>\n";
		$template .= "<p>Please note: the main template does not contain any fields.</p>\n";
		$template .= "<hr/>\n";
	
		$fileName = Path::Combine(F2C_Config::getTemplatePath(), 'default_main_template_'.$projectTitle.'.tpl');
		JFile::write($fileName, $template);
	}	
}
?>
