<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');

class F2C_Validation
{
	function createFileUploadClientSideScript($field)
	{
		$whiteList = 'new Array()';
		$blackList = 'new Array()';

		if($field->settings)
		{	
			$fileSettings = unserialize($field->settings);
			
			if(count($fileSettings->whiteList))
			{
				$whiteList = 'new Array(\'' . implode('\',\'', $fileSettings->whiteList) .'\')';
			}
			
			if(count($fileSettings->blackList))
			{
				$blackList = 'new Array(\'' . implode('\',\'', $fileSettings->blackList) .'\')';
			}
		}	
	
		$msgWhiteList = JText::_('FIELD') . ' \\\'' . HtmlHelper::stringHTMLSafe($field->title) . '\\\': ' . JText::_('ERROR_FILE_UPLOAD_EXTENSION_NOT_ALLOWED');
		$msgBlackList = JText::_('FIELD') . ' \\\'' . HtmlHelper::stringHTMLSafe($field->title) . '\\\': ' . JText::_('ERROR_FILE_UPLOAD_EXTENSION_NOT_ALLOWED');
		return 'if (!F2C_checkExtension(\'t'. $field->id . '_fileupload\', ' . $whiteList . ','. $blackList . ',\''.$msgWhiteList.'\',\''.$msgBlackList.'\')) return false; ';	
	}
	
	function valReqField($field, $elementName, $data)
	{
		$F2C_FIELD_FUNCTION_MAPPING = array(F2C_FIELDTYPE_SINGLELINE => 'SingleLineText',
									F2C_FIELDTYPE_MULTILINETEXT => 'MultiLineText',
									F2C_FIELDTYPE_MULTILINEEDITOR => 'MultiLineEditor',
									F2C_FIELDTYPE_CHECKBOX => 'CheckBox',
									F2C_FIELDTYPE_SINGLESELECTLIST => 'SingleSelectList', 
									F2C_FIELDTYPE_IMAGE => 'Image',
									F2C_FIELDTYPE_IFRAME => 'IFrame', 
									F2C_FIELDTYPE_EMAIL => 'Email', 
									F2C_FIELDTYPE_HYPERLINK => 'Hyperlink', 
									F2C_FIELDTYPE_MULTISELECTLIST => 'MultiSelectList', 
									F2C_FIELDTYPE_INFOTEXT => 'InfoText', 
									F2C_FIELDTYPE_DATEPICKER => 'DatePicker', 
									F2C_FIELDTYPE_DISPLAYLIST => 'DisplayList', 
									F2C_FIELDTYPE_FILE => 'FileUpload', 
									F2C_FIELDTYPE_DATABASE_LOOKUP => 'DatabaseLookup', 
									F2C_FIELDTYPE_GEOCODER => 'GeoCoder',
									F2C_FIELDTYPE_DB_LOOKUP_MULTI => 'DatabaseLookupMulti');

		$functionName = '_valReq'.$F2C_FIELD_FUNCTION_MAPPING[$field->fieldtypeid];

		return $this->$functionName($elementName, $data);
	}
	
	function _valReqSingleLineText($elementName, $data)
	{
		$content = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW));
		return (trim($content) != '');
	}
	
	function _valReqMultiLineText($elementName, $data)
	{
		$content = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW));
		return (trim($content) != '');
	}
	
	function _valReqMultiLineEditor($elementName, $data)
	{
		$content = unquoteData(JRequest::getVar($elementName, '', 'post', 'string', JREQUEST_ALLOWRAW));
		return (trim($content) != '');
	}

	function _valReqCheckBox($elementName, $data)
	{
		$content = unquoteData(JRequest::getString($elementName));
		return $content;
	}
	
	function _valReqSingleSelectList($elementName, $data)
	{
		$content = unquoteData(JRequest::getString($elementName));
		return ($content != '');
	}
	
	function _valReqImage($elementName, $data)
	{
		$uploadfile = JRequest::getVar($elementName . '_fileupload', '', 'files', 'array');
		
		if(JRequest::getVar($elementName . '_del')) return false;
		if($uploadfile['size']) return true;
		
		// check if an image exists
		$sql = 'SELECT content FROM #__f2c_fieldcontent WHERE id='.JRequest::getInt('hid'.$elementName);
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$content = $db->loadResult();
		
		if($content)
		{
			$fileContent = unserialize($content);
			return ($fileContent->filename != '');
		}

		return false;		
	}
	
	function _valReqIFrame($elementName, $data)
	{
		$content = unquoteData(JRequest::getString($elementName));
		return (trim($content) != '');
	}
	
	function _valReqEmail($elementName, $data)
	{
		$content = unquoteData(JRequest::getString($elementName));
		return (trim($content) != '');
	}
	
	function _valReqHyperlink($elementName, $data)
	{
		$content = unquoteData(JRequest::getString($elementName));
		return (trim($content) != '');
	}
	
	function _valReqMultiSelectList($elementName, $data)
	{
		$selections = JRequest::getVar($elementName);
					
		if($selections)
		{
			foreach($selections as $value)
			{
				if(trim($value) != '') return true;
			}
		}
	
		return false;
	}
	
	function _valReqDatePicker($elementName, $data)
	{
		$content = unquoteData(JRequest::getString($elementName));
		return (trim($content) != '');
	}
	
	function _valReqDisplayList($elementName, $data)
	{
		$listNew = null;
	
		if(array_key_exists($elementName.'RowKey',$data) && count($data[$elementName.'RowKey']))
		{
			foreach($data[$elementName.'RowKey'] as $rowKey)
			{ 
				// fix up special html field
				$val = JRequest::getVar($rowKey.'val', '', 'post', 'string', JREQUEST_ALLOWRAW);	
				if($val != '') return true;
			}
		}

		return false;		
	}
	
	function _valReqFileUpload($elementName, $data)
	{
		$uploadfile = JRequest::getVar($elementName . '_fileupload', '', 'files', 'array');
		
		if(JRequest::getVar($elementName . '_del')) return false;
		if($uploadfile['size']) return true;
		
		// check if a file exists
		$sql = 'SELECT content FROM #__f2c_fieldcontent WHERE id='.JRequest::getInt('hid'.$elementName);
		$db = JFactory::getDBO();
		$db->setQuery($sql);
		$content = $db->loadResult();
		return($content);
	}
	
	function _valReqDatabaseLookup($elementName, $data)
	{
		$content = unquoteData(JRequest::getString($elementName));
		return ($content != '');
	}
	
	function _valReqGeoCoder($elementName, $data)
	{
		$addressValue 	= unquoteData(JRequest::getString($elementName.'_address'));
		$latValue		= unquoteData(JRequest::getString($elementName.'_hid_lat'));
		$lonValue 		= unquoteData(JRequest::getString($elementName.'_hid_lon'));
		return(trim($addressValue) && $latValue && $lonValue);		
	}
	
	function _valReqDatabaseLookupMulti($elementName, $data)
	{
		$listNew = null;
	
		if(array_key_exists($elementName.'RowKey',$data) && count($data[$elementName.'RowKey']))
		{
			foreach($data[$elementName.'RowKey'] as $rowKey)
			{ 
				// fix up special html field
				$val = JRequest::getVar($rowKey.'val', '', 'post', 'string', JREQUEST_ALLOWRAW);	
				if($val != '') return true;
			}
		}

		return false;		
	}
	
	function valSizeImage($field, $config)
	{
		$uploadfile = JRequest::getVar('t'.$field->id.'_fileupload', '', 'files', 'array');
		
		if($uploadfile['size'])
		{
			if((int)($uploadfile['size']/1024) > (int)$config->max_image_upload_size)
			{
				return(JText::_('ERROR_IMAGE_UPLOAD_MAX_SIZE_F2C_CONFIG'));
			}			
		}
		else if($uploadfile['error'] == 1)
		{
			return JText::_('ERROR_IMAGE_UPLOAD_MAX_SIZE');
		}

		return '';		
	}

	function valSizeFileUpload($field)
	{
		$uploadfile = JRequest::getVar('t'.$field->id.'_fileupload', '', 'files', 'array');
		$settings	= ($field->settings) ? unserialize($field->settings) : new F2C_FileSettings();
		
		if($uploadfile['size'])
		{
			if((int)$settings->maxFileSize > 0 && (int)($uploadfile['size']) > (int)$settings->maxFileSize * 1024)
			{
				return(JText::_('ERROR_FILE_UPLOAD_MAX_SIZE_FIELD_CONFIG'));
			}			
		}
		else if($uploadfile['error'] == 1)
		{
			return JText::_('ERROR_FILE_UPLOAD_MAX_SIZE');
		}
		
		return '';
	}
}
?>
