<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'renderer.form2content.php');

jimport('joomla.application.component.view');
jimport('joomla.language.helper');

class Form2ContentViewForm extends JView
{
	function display($tpl = null)
	{
		$config 		= new F2CConfig();
		$app 			=& JFactory::getApplication();
		$db 			=& JFactory::getDBO();		
		$params 		=& $app->getParams();
		$uri 			=& JFactory::getURI();
		$dataObject 	=& $this->get('Data');
		$model 			=& $this->getModel();
		$editor 		=& JFactory::getEditor();
		$isNew			= ($dataObject->id < 1);
		$languageId 	= JLanguageHelper::detectLanguage();
		$itemId			= JRequest::getInt('Itemid', 0);
		$jsValidation	= '';
		$jsFieldVal		= '';
		$jsEditorInit	= '';
		$jsEditorSave 	= '';
		$renderCaptcha	= '';
		
		// add javascript library
		$document = &JFactory::getDocument();
		$document->addScript('includes/js/joomla.javascript.js'); 
		
		if(!$model->_canSave())
		{
			JError::raiseNotice(F2C_ERROR_MAX_FORMS, JText::_('ERROR_MAX_FORMS_EXCEEDED'));
			return false;
		}
		
		if(!$languageId)
		{
			$languageId = -1;
		}

		// load project data
		$db->setQuery('SELECT * FROM #__f2c_project WHERE id=' . (int)$dataObject->projectid);			
		$project = $db->loadObject();
		$contentTypeSettings = ($project->settings) ? unserialize($project->settings) : new F2C_ContentTypeSettings();

		if($params->get('restrict_sectioncategory_id', '-1_-1') != '-1_-1')
		{
			// menu parameter overrules project setting
			$project->frontend_catsel = false;
		}

		$text = $isNew ? JText::_('New') : JText::_('Edit');
		$formTitle = ($contentTypeSettings->article_caption) ? $contentTypeSettings->article_caption : JText::_('FORM');		
		$pagetitle = $formTitle .': <small><small>[ ' . $text.' ]</small></small>';
		
		$dataObject->created = JHTML::_('date', $dataObject->created, $config->date_format . ' %H:%M:%S');
		
  		if($dataObject->publish_up == $db->getNullDate())
		{
			$dataObject->publish_up = '';
		}
		else
		{
			$dataObject->publish_up = JHTML::_('date', $dataObject->publish_up, $config->date_format . ' %H:%M:%S');
		}

 		if($dataObject->publish_down)
		{
	  		if($dataObject->publish_down == $db->getNullDate())
			{
				$dataObject->publish_down = '';
			}
			else
			{
				$dataObject->publish_down = JHTML::_('date', $dataObject->publish_down, $config->date_format . ' %H:%M:%S');
			}
		}
		
		// Load field definitions for the current project		
	 	$db->setQuery("SELECT f.* " 
				  	. "FROM #__f2c_projectfields f "
				  	. "WHERE f.projectid =" . $dataObject->projectid
				  	. " ORDER BY f.ordering ASC");
				  	
	  	$fields = $db->loadObjectList();	
			
		// Load translated fields	
	 	$db->setQuery("SELECT f.id, t.title_translation, t.description_translation " 
				  	. "FROM #__f2c_projectfields f "
				  	. "INNER JOIN #__f2c_translation t ON f.id = t.reference_id and t.language_id = '$languageId' "
				  	. "WHERE f.projectid =" . $dataObject->projectid);
			
		$translatedFields = $db->loadObjectList('id');
			
		$validationCounter 	 = 0;
		$jsValidation 		.= 'var arrValidation=new Array;';		
		$jsEditorInit 		.= 'function F2C_GetEditorText(id) { switch(id) { ';
			
		foreach($fields as $field)
		{
			switch($field->fieldtypeid)
			{
				case F2C_FIELDTYPE_MULTILINEEDITOR:
					if($field->frontvisible)
					{
						$elmEditor = 't' . $field->id; // elementname
						$jsEditorInit .= "case '".$elmEditor."': return ".$editor->getContent($elmEditor)."\n";
						$jsEditorSave .= $editor->save($elmEditor);
					}
					break;
				case F2C_FIELDTYPE_FILE:
					if($field->frontvisible)
					{
						$jsFieldVal .= F2C_Validation::createFileUploadClientSideScript($field);
					}
					break;
			}
			
			if($field->settings)
			{
				$fieldSettings = unserialize($field->settings);
				
				if($fieldSettings->required)
				{
					$requiredMsg = ($fieldSettings->errorMessageRequired) ? $fieldSettings->errorMessageRequired : sprintf(JText::_('ERROR_FIELD_X_REQUIRED'), $field->title);
					$jsValidation .= 'arrValidation['.$validationCounter++.']=new Array('.$field->id.','.$field->fieldtypeid.',\''.$requiredMsg.'\');';
				}
			}			
		}

		$jsEditorInit .= '}}';
			
		// load field content
		$db->setQuery("SELECT fc.id, fc.fieldid, fc.attribute, fc.content, pf.fieldtypeid "
					. "FROM #__f2c_form f "
					. "INNER JOIN #__f2c_fieldcontent fc on f.id = fc.formid "
					. "INNER JOIN #__f2c_projectfields pf ON fc.fieldid = pf.id "					
					. "WHERE f.id = $dataObject->id");
							
		$fieldValuesObjectList = $db->loadObjectList();
		
		$fieldValues = array();
		
		// Group data by field id
		foreach($fieldValuesObjectList as $fieldValueObject)
		{
			if(!array_key_exists($fieldValueObject->fieldid, $fieldValues))
			{
				$fieldValues[$fieldValueObject->fieldid] = array();
				
				if($fieldValueObject->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
				{
					$fieldValues[$fieldValueObject->fieldid]['VALUE'] = array();
				}
			}
			
			if($fieldValueObject->fieldtypeid == F2C_FIELDTYPE_DB_LOOKUP_MULTI)
			{
				$fieldValues[$fieldValueObject->fieldid][$fieldValueObject->attribute][] = $fieldValueObject;
			}
			else
			{						
				$fieldValues[$fieldValueObject->fieldid][$fieldValueObject->attribute] = $fieldValueObject;
			}
		}
		
		if($project->catid == -2)
		{
			// only show category
			$lists['catid'] = getCategoryList($project->sectionid, $dataObject->catid);
			$lists['sectionid'] = HtmlHelper::hiddenField('sectionid', $project->sectionid);
		}
		else
		{
			$javascript = "onchange=\"changeDynaList( 'catid', sectioncategories, document.adminForm.sectionid.options[document.adminForm.sectionid.selectedIndex].value, 0, 0);\"";		
			$lists = getSectionCategoryList($dataObject->sectionid, $dataObject->catid, $javascript);
		}
		
		$lists['created_by'] = JHTML::_('select.genericlist', getAuthorList(), 'created_by', 'class="inputbox" size="1"', 'created_by', 'name', $dataObject->created_by);
		$lists['frontpage'] = JHTML::_('select.booleanlist', 'frontpage', '', $dataObject->frontpage, 'F2C_YES', 'F2C_NO');
		$lists['state'] = JHTML::_('select.booleanlist', 'state', '', $dataObject->state, 'F2C_YES', 'F2C_NO');		
		$lists['access'] = JHTML::_('list.accesslevel', $dataObject); 		

		$renderer = new F2C_Renderer($config, $dataObject->id, $translatedFields, $contentTypeSettings);
		
		// Handle the captcha
		if($contentTypeSettings->captcha_front_end)
		{
			if(!function_exists('recaptcha_get_html'))
			{
				require_once(JPATH_COMPONENT_SITE.DS.'libraries'.DS.'recaptcha'.DS.'recaptchalib.php');
			}
			
			$publickey = (array_key_exists('recaptcha_public_key', get_object_vars($config))) ? $config->recaptcha_public_key : '';			
			$renderCaptcha .= '<tr><td colspan="2"><br/>'.recaptcha_get_html($publickey).'</td></tr>';
			$submitForm = 'F2C_CheckCaptcha(pressbutton, \''.JText::_('ERROR_CAPTCHA_INCORRECT').'\','.$itemId.');';
		}
		else
		{
			$submitForm = 'submitform(pressbutton);';
		}
		
		$this->assignRef('lists', $lists);
		$this->assignRef('form', $dataObject);
		$this->assignRef('project', $project);
		$this->assignRef('contentTypeSettings', $contentTypeSettings);		
		$this->assignRef('isNew', $isNew);
		$this->assignRef('fields', $fields);
		$this->assignRef('translatedFields', $translatedFields);		
		$this->assignRef('fieldValues', $fieldValues);
		$this->assignRef('pagetitle', $pagetitle);
		$this->assignRef('renderer', $renderer);
		$this->assignRef('jsValidation', $jsValidation);
		$this->assignRef('jsFieldVal', $jsFieldVal);						
		$this->assignRef('jsEditorInit', $jsEditorInit);
		$this->assignRef('jsEditorSave', $jsEditorSave);
		$this->assignRef('renderCaptcha', $renderCaptcha);
		$this->assignRef('submitForm', $submitForm);
		$this->assign('action',	$uri->toString());
			
		parent::display($tpl);	
	}	
}

?>