<?php
defined('_JEXEC') or die('Restricted acccess');

require_once(JPATH_COMPONENT_SITE.DS.'shared.form2content.php');
require_once(JPATH_COMPONENT_SITE.DS.'utils.form2content.php');
require_once(JPATH_BASE.'/administrator/includes/toolbar.php');

jimport('joomla.application.component.view');

class Form2ContentViewForms extends JView
{
	function display($tpl = null)
	{
		$app 				=& JFactory::getApplication();
		$option 			= JRequest::getCmd('option');		
		$uri 				=& JFactory::getURI();
		$f2cconfig 			= new F2CConfig();
		$menuItemParams 	=& JComponentHelper::getParams('com_form2content');
		$db 				=& JFactory::getDBO();
		$params 			=& $app->getParams();
		$document 			=& JFactory::getDocument();
		$menus				=& JSite::getMenu();
		$menu				= $menus->getActive();
		$search				= $app->getUserStateFromRequest($option.'forms', 'searchforms', '', 'string');
		$search				= JString::strtolower($search);
		$filter_order		= $app->getUserStateFromRequest($option.'filter_order', 'filter_order', 'section_name', 'cmd');
		$filter_order_Dir	= $app->getUserStateFromRequest($option.'filter_order_Dir', 'filter_order_Dir', '', 'word');
		$filter_sectionid	= $app->getUserStateFromRequest($option.'filter_sectionid', 'filter_sectionid', -1, 'int');
		$sectionid			= JRequest::getVar('sectionid', -1, '', 'int');
		$catid				= $app->getUserStateFromRequest($option.'catid', 'catid', 0, 'int');
		$items 				=& $this->get('Data');
		$total 				=& $this->get('Total');
		$pagination 		=& $this->get('Pagination');		
		$filter 			= '';		
		$sectionFixed 		= false;
		$contentType		= null;
		
		// add javascript library
		$document->addScript('includes/js/joomla.javascript.js'); 
		
		// because the application sets a default page title, we need to get it right from the menu item itself
		if (is_object($menu)) 
		{
			$menu_params = new JParameter($menu->params);
			if (!$menu_params->get('page_title')) 
			{
				$params->set('page_title',	JText::_('FORM2CONTENT'));
			}
		} 
		else 
		{
			$params->set('page_title',	JText::_( 'FORM2CONTENT' ));
		}
		
		if($params->get('contenttypeid', 0) == 0)
		{
			// get content type from filterdropdown
			$projectid	= $app->getUserStateFromRequest($option.'projectid', 'projectid', -1, 'int');
						
			$listProjects[] = JHTML::_('select.option', '-1', '-&nbsp;' . JText::_('SELECT_A_PROJECT') . '&nbsp;-', 'id', 'title');
			// get all published projects
			$listProjects = array_merge($listProjects, getProjectList(true));
							
			$lists['projectid'] = JHTML::_('select.genericlist',  $listProjects, 'projectid', 'class="inputbox" size="1" onchange="submitform( );"', 'id', 'title', $projectid);
			$fixedContentType = false;
		}
		else
		{
			// get content type from menu parameter
			$projectid = $params->get('contenttypeid', -1);
			$this->assignRef('projectid', $projectid);
			$fixedContentType = true;
		}		

		// If the Content Type is fixed and the section of that type is fixed also
		// only show the categories in that situation
		if($fixedContentType)
		{
			$db->setQuery('SELECT * FROM #__f2c_project WHERE id = ' . $projectid);
			$contentType = $db->loadObject();
			
			if($contentType->catid == -2)
			{
				$sectionFixed = true;
			}
		}
		
		$submitScript = 'onchange="document.adminForm.submit();"';
		
		if($sectionFixed)
		{
			// only show category
			$lists['catid'] = getCategoryList($contentType->sectionid, $catid, $submitScript);
			$lists['sectionid'] = HtmlHelper::hiddenField('sectionid', $contentType->sectionid);
			// get the category title
			$db->setQuery('SELECT title FROM #__sections WHERE id = '.(int)$contentType->sectionid);
			$lists['sectionid'] .= HtmlHelper::stringHTMLSafe($db->loadResult()).'&nbsp;';
		}
		else
		{
			// get list of categories for dropdown filter	
			if ($filter_sectionid >= 0) 
			{
				$filter = ' WHERE cc.section = '.$db->Quote($filter_sectionid);
			}
	
			// get list of categories for dropdown filter
			$query = 'SELECT cc.id AS value, cc.title AS text, section' .
					' FROM #__categories AS cc' .
					' INNER JOIN #__sections AS s ON s.id = cc.section' .
					$filter .
					' ORDER BY s.ordering, cc.ordering';
			
			$lists['catid'] = ContentHelper::filterCategory($query, $catid);
			
			// get list of sections for dropdown filter
			$lists['sectionid'] = JHTML::_('list.section', 'filter_sectionid', $filter_sectionid, $submitScript);
		}
				
		// search filter
		$lists['search']= $search;
		
		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
						
		// check which columns to display
		$cols['ordering'] 	= ($params->get('show_sectioncategory', 2) == 1);
		$cols['section'] 	= $params->get('show_sectioncategory', 2) && !$sectionFixed;
		$cols['category'] 	= $params->get('show_sectioncategory', 2);
		
		// perform a check whether a user can create new items in this view
		$modelProjectSelect = $this->getModel('projectselect');
		$contentTypes = $modelProjectSelect->getData($projectid);
		// Show the new button only when it's configured to be shown and the content types allow creation of new articles
		$params->set('show_new_button', $params->get('show_new_button', 1) ? count($contentTypes) : 0);

		// Check if the user can publish items in the front-end
		$publishing = $this->_userCanPublish($f2cconfig);
		
		$this->assignRef('fixedContentType', $fixedContentType);		
		$this->assignRef('lists', $lists);
		$this->assignRef('items', $items);		
		$this->assignRef('pagination', $pagination);
		$this->assignRef('option', $option);
		$this->assignRef('params', $params);
		$this->assignRef('cols', $cols);
		$this->assignRef('f2cconfig', $f2cconfig);
		$this->assign('action',	$uri->toString());
		$this->assign('publishing',	$publishing);
		
		parent::display($tpl);
	}
	
	/*
	 * Check if an user can publish items in the front end
	 */
	function _userCanPublish($f2cConfig)
	{
		switch((array_key_exists('front_end_publish',get_object_vars($f2cConfig))) ? (int)$f2cConfig->front_end_publish : 1)
		{
			case 0:
				return false;
				break;
			case 1:
				return true;
				break;
			case 2:
				// check if the user is an admin
				$user = JFactory::getUser();		
				return ($user->usertype == 'Super Administrator' || $user->usertype == 'Administrator');
				break;
		}		
	}	
}
?>